/**** Funkcje X *************************************************
****************************************************************/
// LPC2368 RAM: 0x40000000..0x40007FFF; Ethernet_RAM: 0x7FE00000..7FE03FFF;
// USB_RAM: 0x7FD00000..7FD01FFF; RTC_RAM: 0xE0084000..0xE00847FF;
 
// UWAGA w WinARM int ma 32 bity oraz int16_t i uint16_t maja 32 bity ! 
 
// RD_VDIP Read VDIP ------------------------------------------------
unsigned short RD_VDIP(void)
{
unsigned short rezult, f;
 for(f=0;f<3;f++)
   {
    CS_VDIP_1;
    rezult = SPI0(0x0C00);
    CS_VDIP_0;

    // SPI0(0x0FFF);
    SCLKX_0; // dodatkowy clock
    delayx(0x00000003);
    SCLKX_1;

    if((rezult & 1) == 0)
     break;
   }
 if(rezult & 1)
  return(0x7FFF);
 rezult = rezult >> 1;
 return(rezult & 0x00FF);
}

// WR_VDIP Write VDIP ------------------------------------------------
unsigned short WR_VDIP(unsigned char dane)
{
unsigned short rezult, f, slowo;
 slowo = (unsigned short)dane << 1;
 slowo |= 0x0800;
 slowo &= 0x09FE;

 for(f=0;f<9;f++)
   {
    CS_VDIP_1;
    rezult = SPI0(slowo);
    CS_VDIP_0;

    // SPI0(0x0FFF);
    SCLKX_0; // dodatkowy clock
    delayx(0x00000003);
    SCLKX_1;

    if((rezult & 1) == 0)
     break;
   }
 return(rezult & 1);
}

// GC_VDIP Read VDIP -------- Get Char VDIP -------------------------
unsigned short GC_VDIP(void)
{
unsigned short rezult, f;
 for(f=0;f<0x7FFF;f++)
   {
    CS_VDIP_1;
    rezult = SPI0(0x0C00);
    CS_VDIP_0;

    // SPI0(0x0FFF);
    SCLKX_0; // dodatkowy clock
    delayx(0x00000003);
    SCLKX_1;

    if((rezult & 1) == 0)
     break;
   }
 if(rezult & 1)
  return(0x7FFF);
 rezult = rezult >> 1;
 return(rezult & 0x00FF);
}

// GL_VDIP Read VDIP -------- Get Line VDIP -------------------------
unsigned short GL_VDIP(void)
{
unsigned short rezult, f;
 for(f=0;f<512;f++)
   {
    rezult = GC_VDIP();
    Buf_8[f] = rezult;
    if((rezult == 0x0D) || (rezult > 0x0100))
     break;
   }
 if(rezult > 0x0100)
     return(0);
 return(f+1);
}

// GR_VDIP Read VDIP -------- Get Response VDIP ----------------------
unsigned short GR_VDIP(void)
{
unsigned short rezult, f;
 for(f=0;f<512;f++)
   {
    rezult = GC_VDIP();
    Buf_8[f] = rezult;
    if(rezult > 0x0100)
     break;
   }
// if((f == 0) && (rezult > 0x0100))
//     return(0);
 return(f);
}

// I2C[0] Zapisz rejestr (adr_slave, adr_reg, dat)--------------------
int i2c_write_reg(char adr_slave, char adr_reg, char dat)
{
 int Lxx;
    Lxx = i2c_write_a(adr_slave);
    if(Lxx >= 0)
        {
         i2c_write_dn(adr_reg);
         Lxx = i2c_write_de(dat);
        }
 return Lxx;
}

// I2C[0] Czytaj rejestr (adr_slave, adr_reg)--------------------------
int i2c_read_reg(char adr_slave, char adr_reg)
{
 int Lxx;
    Lxx = i2c_write_a(adr_slave);
    if(Lxx >= 0)
        {
         i2c_write_dn(adr_reg);
         Lxx = i2c_read_a(adr_slave);
        }
 return Lxx;
}

// I2C[0] Zapisz adres ------------------------------------------------
int i2c_write_a(char ch)
{
 I20CONSET = 0x20; //STA
 while(!(I20CONSET&0x08));
 I20CONCLR = 0x20;

// while(!(I20CONSET&0x08));

 I20DAT = ch;
 I20CONCLR = 0x08;
 while(!(I20CONSET&0x08));
 if(I20STAT!=0x18)
  {
   I20CONSET = 0x10; // STO
   I20CONCLR = 0x08;
   return(-1);
  }
 I20CONCLR = 0x08;
 return(ch);
}

// I2C[0] Zapisz dane -------------------------------------------------
int i2c_write_dn(char ch)
{
 int stat;
 //I20CONCLR = 0x20;
 I20DAT = ch;
 //I20CONSET = 0x04;
 I20CONCLR = 0x08;
 while(!(I20CONSET&0x08));
 stat = I20STAT;
 if(stat!=0x28)
     {
      //I20CONSET = 0x10; // STO
      I20CONCLR = 0x08;
      return(-1);
     }
 I20CONCLR = 0x08;
 return(ch);
}

// I2C[0] Zapisz ostatnie dane ----------------------------------------
int i2c_write_de(char ch)
{
 int stat;
 //I20CONCLR = 0x20;
 I20DAT = ch;
 //I20CONSET = 0x04;
 I20CONCLR = 0x08;
 while(!(I20CONSET&0x08));
 stat = I20STAT;
 if(stat!=0x28)
     {
      I20CONSET = 0x10; // STO
      I20CONCLR = 0x08;
      return(-1); // (-1);
     }
 I20CONSET = 0x10; // STO
 I20CONCLR = 0x08;
 return(ch);
}

// I2C[0] Zapisz adres, czytaj dane -----------------------------------
int i2c_read_a(char ch)
{
 I20CONSET = 0x20; //STA
 while(!(I20CONSET&0x08));
 I20CONCLR = 0x20;

// while(!(I20CONSET&0x08));

 I20DAT = ch | 0x01;
 I20CONCLR = 0x08;
 while(!(I20CONSET&0x08));
 if(I20STAT!=0x40)
     {
      I20CONSET = 0x10; // STO
      I20CONCLR = 0x08;
      return(-1);
     }
 I20CONCLR = 0x04; // ACK
 I20CONCLR = 0x08;
 while(!(I20CONSET&0x08));

 ch = I20DAT; // Read

 I20CONSET = 0x10; // STO
 I20CONCLR = 0x08;
 return(ch);
}

// I2C[0] Zapisz adres, czytaj pierwsza dana --------------------------
int i2c_read_a1(char ch)
{
 I20CONSET = 0x20; //STA
 while(!(I20CONSET&0x08));
 I20CONCLR = 0x20;

// while(!(I20CONSET&0x08));

 I20DAT = ch | 0x01;
 I20CONCLR = 0x08;
 while(!(I20CONSET&0x08));
 if(I20STAT!=0x40)
     {
      I20CONSET = 0x10; // STO
      I20CONCLR = 0x08;
      return(-1);
     }
 I20CONSET = 0x04; // ACK
 I20CONCLR = 0x08;
 while(!(I20CONSET&0x08));

 ch = I20DAT; // Read

 I20CONCLR = 0x08;
 return(ch);
}

// I2C[0] Czytaj kolejna dana ----------------------------------------
int i2c_read_dn(void)
{
char ch;

 I20CONSET = 0x04; // ACK
 I20CONCLR = 0x08;
 while(!(I20CONSET&0x08));

 if(I20STAT!=0x50)
     {
      I20CONSET = 0x10; // STO
      I20CONCLR = 0x08;
      return(-1);
     }

 ch = I20DAT; // Read

 return(ch);
}

// I2C[0] Czytaj otatnia dana ----------------------------------------
int i2c_read_de(void)
{
char ch;

 I20CONCLR = 0x04; // ACK
 I20CONCLR = 0x08;
 while(!(I20CONSET&0x08));


 if(I20STAT!=0x58)
     {
      I20CONSET = 0x10; // STO
      I20CONCLR = 0x08;
      return(-1);
     }

 ch = I20DAT; // Read

 I20CONSET = 0x10; // STO
 I20CONCLR = 0x08;

 return(ch);
}

// I2C[1] ========================================================+=====
char i2c1_write_reg(char adress, char reg, char dat)
{
int Lxx;
    Lxx = i2c1_write_a(adress);
    if(Lxx >= 0)
        {
         i2c1_write_dn(reg);
         Lxx = i2c1_write_de(dat);
        }
return Lxx;
}

// I2C[1] Zapisz adres ------------------------------------------------
int i2c1_write_a(char ch)
{
 I21CONSET = 0x20; //STA
 while(!(I21CONSET&0x08));
 I21CONCLR = 0x20;

// while(!(I21CONSET&0x08));

 I21DAT = ch;
 I21CONCLR = 0x08;
 while(!(I21CONSET&0x08));
 if(I21STAT!=0x18)
     {
      I21CONSET = 0x10; // STO
      I21CONCLR = 0x08;
      return(-1);
     }
 I21CONCLR = 0x08;
 return(ch);
}

// I2C[1] Zapisz dane -------------------------------------------------
int i2c1_write_dn(char ch)
{
 int stat;
 //I21CONCLR = 0x20;
 I21DAT = ch;
 //I21CONSET = 0x04;
 I21CONCLR = 0x08;
 while(!(I21CONSET&0x08));
 stat = I21STAT;
 if(stat!=0x28)
     {
      //I21CONSET = 0x10; // STO
      I21CONCLR = 0x08;
      return(-1);
     }
 I21CONCLR = 0x08;
 return(ch);
}

// I2C[1] Zapisz ostatnie dane ----------------------------------------
int i2c1_write_de(char ch)
{
 int stat;
 //I21CONCLR = 0x20;
 I21DAT = ch;
 //I21CONSET = 0x04;
 I21CONCLR = 0x08;
 while(!(I21CONSET&0x08));
 stat = I21STAT;
 if(stat!=0x28)
     {
      I21CONSET = 0x10; // STO
      I21CONCLR = 0x08;
      return(-1); // (-1);
     }
 I21CONSET = 0x10; // STO
 I21CONCLR = 0x08;
 return(ch);
}

// I2C[1] Zapisz adres, czytaj dane -----------------------------------
int i2c1_read_a(char ch)
{
 I21CONSET = 0x20; //STA
 while(!(I21CONSET&0x08));
 I21CONCLR = 0x20;

// while(!(I21CONSET&0x08));

 I21DAT = ch | 0x01;
 I21CONCLR = 0x08;
 while(!(I21CONSET&0x08));
 if(I21STAT!=0x40)
     {
      I21CONSET = 0x10; // STO
      I21CONCLR = 0x08;
      return(-1);
     }
 I21CONCLR = 0x04; // ACK
 I21CONCLR = 0x08;
 while(!(I21CONSET&0x08));

 ch = I21DAT; // Read

 I21CONSET = 0x10; // STO
 I21CONCLR = 0x08;
 return(ch);
}

// I2C[1] Zapisz adrea, czytaj pierwsza dana --------------------------
int i2c1_read_a1(char ch)
{
 I21CONSET = 0x20; //STA
 while(!(I21CONSET&0x08));
 I21CONCLR = 0x20;

// while(!(I21CONSET&0x08));

 I21DAT = ch | 0x01;
 I21CONCLR = 0x08;
 while(!(I21CONSET&0x08));
 if(I21STAT!=0x40)
     {
      I21CONSET = 0x10; // STO
      I21CONCLR = 0x08;
      return(-1);
     }
 I21CONSET = 0x04; // ACK
 I21CONCLR = 0x08;
 while(!(I21CONSET&0x08));

 ch = I21DAT; // Read

 I21CONCLR = 0x08;
 return(ch);
}

// I2C[1] Czytaj kolejna dana ----------------------------------------
int i2c1_read_dn(void)
{
char ch;

 I21CONSET = 0x04; // ACK
 I21CONCLR = 0x08;
 while(!(I21CONSET&0x08));

 if(I21STAT!=0x50)
     {
      I21CONSET = 0x10; // STO
      I21CONCLR = 0x08;
      return(-1);
     }

 ch = I21DAT; // Read

 return(ch);
}

// I2C[1] Czytaj otatnia dana ----------------------------------------
int i2c1_read_de(void)
{
char ch;

 I21CONCLR = 0x04; // ACK
 I21CONCLR = 0x08;
 while(!(I21CONSET&0x08));


 if(I21STAT!=0x58)
     {
      I21CONSET = 0x10; // STO
      I21CONCLR = 0x08;
      return(-1);
     }

 ch = I21DAT; // Read

 I21CONSET = 0x10; // STO
 I21CONCLR = 0x08;

 return(ch);
}
// ====================================================================

// Open disk SD -------------------------------------------------------
int Open_SD(void)
{
int lx;
   Zapal_SD;
   lx = disk_initialize(0);
   SD_error = lx;
   Zgas_SD;
   if(lx == 0x00)
   {
    lx = disk_ioctl(0, GET_SECTOR_COUNT, &SD_SECTORS);
    lx = disk_ioctl(0, MMC_GET_CID, &SD_CXX);

    SD_SN = (long)SD_CXX[9] & 0x000000FF;
    SD_SN = SD_SN | ((long)SD_CXX[10] << 8);
    SD_SN = SD_SN | ((long)SD_CXX[11] << 16);
    SD_SN = SD_SN | ((long)SD_CXX[12] << 24);

    SD_Name[0] = SD_CXX[1];
    SD_Name[1] = SD_CXX[2];
    SD_Name[2] = SD_CXX[3];
    SD_Name[3] = SD_CXX[4];
    SD_Name[4] = SD_CXX[5];
    SD_Name[5] = SD_CXX[6];
    SD_Name[6] = SD_CXX[7];
    SD_Name[7] = 0;
   }
   else
   {
    BlkAddr = 0;
    SD_SECTORS = 0;
    SD_FILE_FORMAT = 0;
   }
 return lx;
}
// -------------------------------------------------------------------

unsigned short GFAT0(unsigned short KlasterF)
{
// Get FAT - Dynamik Fat Loader
// JestFat == 1 -> czytano FAT'a
// LastFat == 0x0000 -> czytano FAT'a 000 B
// LastFat == 0x2000 -> czytano FAT'a 001 B
// LastFat == 0xE000 -> czytano FAT'a 111 B
unsigned short Klaster123;
unsigned long SecF, SecLL, SecHL;

 SecLL = secl;
 SecHL = sech;

 Klaster123 = KlasterF & 0xF800;

 if((JestFat == 0) || (Klaster123 != LastFat))
 {
  if(FATZmod)
  {
   error = Zapisz_FATy();
   if(!error)FATZmod = 0;
  }

  LastFat = Klaster123;                // Starsze 5 bitow
  SecF = (unsigned long)FAT_0 + ((unsigned long)LastFat >> 8);
  
  secl = SecF;
  sech = secl + 7;
  
  Zapal_SD;
//  error = read_n_sec_x(0x0E00); // Pocztek Buf_FAT
  error = read_n_sec_p(Buf_FAT);
  Zgas_SD;
  
  if(!error) 
  {
   JestFat = 1;
  }

 }
 
 secl = SecLL;
 sech = SecHL; 

 return Buf_FAT[KlasterF & 0x07FF];
}
// ---------------------------------------------------------------

void SetFAT(unsigned int KlasterF, unsigned int NewClus)
{
unsigned int Klaster123, OldClus;
unsigned long SecF, SecLL, SecHL;

 SecLL = secl;
 SecHL = sech;

 Klaster123 = KlasterF & 0xF800;

 if((JestFat==0) || (Klaster123 != LastFat))
 {
  if(FATZmod)
   error = Zapisz_FATy();
  if(!error)FATZmod = 0;

  LastFat = Klaster123;                // Starsze 5 bitow

  SecF = (unsigned long)FAT_0 + ((unsigned long)LastFat >> 8);

  secl = SecF;
  sech = secl + 7;

  Zapal_SD;
//  error = read_n_sec_x(0x0E00); // Pocztek Buf_FAT
  error = read_n_sec_p(Buf_FAT);
  Zgas_SD;
 }

 JestFat = 1;

 OldClus = Buf_FAT[KlasterF & 0x07FF];
 if((OldClus == 0) && NewClus)
   {
   // Mozna wpisac niezerow wartosc w komorke z zerem
    Buf_FAT[KlasterF & 0x07FF] = NewClus;
    FATZmod = 1;
   }
 else
   {
    if(OldClus && NewClus)
      FATE |= 0x02;
    if(NewClus == 0)
      FATE |= 0x01;
   }

 if(NewClus == 0xFFFF)
 {
  Zapisz_FATy();
  if(!error)FATZmod = 0;
 }

 secl = SecLL;
 sech = SecHL; 
}
// ---------------------------------------------------------------

void DelFAT(unsigned int KlasterF)
{
unsigned int Klaster123;
unsigned long SecF, SecLL, SecHL;

 SecLL = secl;
 SecHL = sech;

 Klaster123 = KlasterF & 0xF800;

 if((JestFat==0) || (Klaster123 != LastFat))
 {
  if(FATZmod)
   error = Zapisz_FATy();
  if(!error)FATZmod = 0;

  LastFat = Klaster123;                // Starsze 5 bitow

  SecF = (unsigned long)FAT_0 + ((unsigned long)LastFat >> 8);

  secl = SecF;
  sech = secl + 7;

  Zapal_SD;
//  error = read_n_sec_x(0x0E00); // Pocztek Buf_FAT
  error = read_n_sec_p(Buf_FAT);
  Zgas_SD;
 }

 JestFat = 1;

 if(Buf_FAT[KlasterF & 0x07FF] == 0)
   FATE |= 0x01;
 Buf_FAT[KlasterF & 0x07FF] = 0;
 FATZmod = 1;

 secl = SecLL;
 sech = SecHL; 
}
// ---------------------------------------------------------------

// Zapisz FAT'y
unsigned short Zapisz_FATy(void)
{
unsigned long SecZF, SecHF;
unsigned long SecLL, SecHL, px;

 SecLL = secl;
 SecHL = sech;
 
 error = 0;

// FAT_0
  SecZF = (unsigned long)FAT_0 + ((unsigned long)LastFat >> 8);
  SecHF = (unsigned long)SecZF + (unsigned long)7;

  while(1)
  {
   if(SecHF < ((unsigned long)FAT_0 + (unsigned long)Boot_HDD.Boot_FATSz16))
    break;
   else
    SecHF--;
  }

  if(SecZF <= SecHF)
  {
   secl = SecZF;
   sech = SecHF;

   Zapal_SD;
//   error = write_n_sec_x(0x0E00); // Pocztek Buf_FAT
   px = (unsigned long)Buf_FAT;
   error = write_n_sec_p((char*)px);
   // error = write_n_sec_p(Buf_FAT);
   Zgas_SD;
  }
// Delay
   delayx(2000);

// FAT_1
   SecZF = (unsigned long)FAT_1 + ((unsigned long)LastFat >> 8);
   SecHF = (unsigned long)SecZF + (unsigned long)7;

   while(1)
   {
    if(SecHF < ((unsigned long)FAT_1 + (unsigned long)Boot_HDD.Boot_FATSz16))
     break;
    else
     SecHF--;
   }

   if((SecZF <= SecHF) && !error)
   {
    secl = SecZF;
    sech = SecHF;

    Zapal_SD;
//    error = write_n_sec_x(0x0E00); // Pocztek Buf_FAT
    px = (unsigned long)Buf_FAT;
    error = write_n_sec_p((char*)px);
    // error = write_n_sec_p(Buf_FAT);
    Zgas_SD;
   }

 secl = SecLL;
 sech = SecHL; 

 return error;   
}
// ------------------------------------------------------

unsigned short GetFreeFAT(unsigned short KlasterS)
{
unsigned short f123, r123;
 r123 = 0;
 if((KlasterS > 1) && (KlasterS < MAX_Klaster));
 {
  for(f123 = KlasterS; f123 <= MAX_Klaster; f123++)
   if(!GFAT0(f123))
   {
    r123 = f123;
    break;
   }
 }
 return(r123);
}
// ---------------------------------------------------------------


unsigned short GetFreeFATX(unsigned short KlasterS)
{
unsigned short f123, r123, tx;
 r123 = 0;
 wskr = 4096;
 if((KlasterS > 1) && (KlasterS < MAX_Klaster));
 {
  for(f123 = 0; f123 < 4096; f123++)
      {
      tx = (unsigned short)Tab_32_Eth[f123];
       if( tx >= KlasterS )
           {
            r123 = tx;
            wskr = f123;
            break;
           }
      }
 }
 return(r123);
}
// ---------------------------------------------------------------

unsigned short GetFreeFATY(unsigned short KlasterS)
{
unsigned short f123, r123, tx;
unsigned long ul;
 r123 = 0;
 wskr = 4096;
 if((KlasterS > 1) && (KlasterS < MAX_Klaster));
 {
  for(f123 = 0; f123 < 4096; f123++)
      {
       ul = Tab_32_USB[f123/2];
       if(f123 & 1)
          {
           ul = ul >> 16;
           tx = (unsigned short)ul;
          }
       else
           tx = ul & 0x0000FFFF; 
       if( tx >= KlasterS )
           {
            r123 = tx;
            wskr = f123;
            break;
           }
      }
 }
 return(r123);
}
// ---------------------------------------------------------------

unsigned short GetFreeFATZ(unsigned short KlasterS)
{
unsigned short f123, r123, tx;
 r123 = 0;
 wskr = 4096;
 if((KlasterS > 1) && (KlasterS < MAX_Klaster));
 {
  for(f123 = 0; f123 < 4096; f123++)
      {
      tx = (unsigned short)Buf_16_FAT[f123];
       if( tx >= KlasterS )
           {
            r123 = tx;
            wskr = f123;
            break;
           }
      }
 }
 return(r123);
}
// ---------------------------------------------------------------

unsigned long Wolne_Sec(void)
{
unsigned short ux, uy, fl;
 ux = 0;
 for(uy = 0; uy <= (MAX_Klaster>>11); uy++)
 {
  fl = GFAT0(uy<<11);

  if(uy == (MAX_Klaster>>11))
  {
   for(fl = 0; fl < (MAX_Klaster & 0x07FF); fl++)
    if(!Buf_FAT[fl])ux++;
  }
  else
  {
   for(fl = 0; fl < 0x800; fl++)
    if(!Buf_FAT[fl])ux++;
  }
 }

 return ((unsigned long)ux * (unsigned long)SecPerClusL);
}
// ===================================================================

void Get_1_SEC(unsigned short XClusf)
{
unsigned long SecLL, SecHL, px;

 SecLL = secl;
 SecHL = sech;

 secl = DATA_0 + (((unsigned long)XClusf - (unsigned long)2) * (unsigned long)SecPerClusL);
 sech = secl;

 px = (unsigned long)Buf_8;
 read_n_sec_p((char*)px);
 //read_n_sec_p(Buf_8);

 secl = SecLL;
 sech = SecHL; 
}
// -------------------------------------------------------------------

void Get_32_SEC(unsigned short XClusf)
{
unsigned long SecLL, SecHL, px;

 SecLL = secl;
 SecHL = sech;

 secl = DATA_0 + (((unsigned long)XClusf - (unsigned long)2) * (unsigned long)SecPerClusL);
 sech = secl + 31;

 px = (unsigned long)Buf_8_2k;
 read_n_sec_p((char*)px);
 //read_n_sec_p(Buf_8);

 secl = SecLL;
 sech = SecHL; 
}
// -------------------------------------------------------------------

void Put_1_SEC(unsigned short XClusf)
{
unsigned long SecLL, SecHL, px;

 SecLL = secl;
 SecHL = sech;

 secl = DATA_0 + (((unsigned long)XClusf - (unsigned long)2) * (unsigned long)SecPerClusL);
 sech = secl;

 px = (unsigned long)Buf_8;
 write_n_sec_p((char*)px);
 //write_n_sec_p(Buf_8);

 secl = SecLL;
 sech = SecHL; 
}
// -------------------------------------------------------------------

unsigned short Inic_SRAM(void)
{
unsigned short xx, f;
// SPI1 -> SRAM

  DI;

  CS_SRAM_0; // CS_SRAM#
  xx = SPI1(0x01); // Write WRSR 23K256 
  xx = SPI1(0x81); // MODE: Byte - 0x01; Pagre(32) - 0x81; Sequent - 0x41  
  CS_SRAM_1; // CS_SRAM#

  for(f=0;f<10000;f++)
  {
   CS_SRAM_0; // CS_SRAM#
   xx = SPI1(0x05); // Read RDSR 23K256 
   xx = SPI1(0xFF); // MODE: Byte - 0x01; Pagre(32) - 0x81; Sequent - 0x41  
   CS_SRAM_1; // CS_SRAM#
   if(xx == 0x81)
    break;
   else
   {
    CS_SRAM_0; // CS_SRAM#
    xx = SPI1(0x01); // Write WRSR 23K256 
    xx = SPI1(0x81); // MODE: Byte - 0x01; Pagre(32) - 0x81; Sequent - 0x41  
    CS_SRAM_1; // CS_SRAM#
   }
  }

  EI;

  if(xx == 0x81)
      return 0;
  else
      return 0x00FE;
}

unsigned short WR_SRAM(unsigned short adr, char *buff)
{
unsigned short xx, f;

 adr = adr & 0xFFE0; // Modulo 16

 DI;

 CS_SRAM_0; // CS_SRAM#

 xx = SPI1(0x02); // Write 23K256
 xx = SPI1(adr >> 8); // Adres H
 xx = SPI1(adr & 0x00FF); // Adres L
 for(f=0;f<32;f++)
  xx = SPI1(*buff++);
 CS_SRAM_1; // CS_SRAM#

 EI;

 return 0;
}

unsigned short RD_SRAM(unsigned short adr, char *buff)
{
unsigned short xx, f;

 adr = adr & 0xFFE0; // Modulo 16
  
 DI;

 CS_SRAM_0; // CS_SRAM#
 xx = SPI1(0x03); // Read 23K256
 xx = SPI1(adr >> 8); // Adres H
 xx = SPI1(adr & 0x00FF); // Adres L
 for(f=0;f<32;f++)
  *buff++ = SPI1(0x00FF);
 CS_SRAM_1; // CS_SRAM#

 EI;

 return 0;
}

// --------------------------------------------------------------


unsigned char Read_DIR(unsigned short Klaster1)
{
// Read_DIR
unsigned short f123, fst, DirSecx, Tryb_SubDIR, Tryb_RootDIR;
intptr_t dira;

 DIRow = 0;
 Plikow = 0;
 Tryb_SubDIR = 0;
 Tryb_RootDIR = 0;

 fst = 0;

 if(Klaster1)
 {
  fst = 1; // pomin katalog "."
  Tryb_SubDIR = 1;
 }
 else
  Tryb_RootDIR = 1;

 if(Inic_SRAM())
  return 0x00FE;

 if(Klaster1)
 {
  Klaster = Klaster1;

  secl = DATA_0 + (((unsigned long)Klaster - (unsigned long)2) * (unsigned long)SecPerClusL);

  DirSecx = (unsigned short)SecPerClusL;

// Sprawdzenie katalogow "." i ".."
  sech = secl;   
  Zapal_SD;
  read_n_sec();
  Zgas_SD;

// Sprawczenie czy mamy do czynienia z podkatalogiem
  if(Klaster1 && (Tab_8[0x2000]=='.')&&(Tab_8[0x2020]=='.')&&(Tab_8[0x2021]=='.')&&(Tab_8[0x202B]==0x10))
   Tryb_SubDIR = 2;

  if( !Tryb_RootDIR && (Tryb_SubDIR<2))
   return 1; // Inny plik

  Klaster_dot = Klaster;

// Czy nalezy wyskoczyc do root DIR
  if( !Tryb_RootDIR && Tryb_SubDIR && DIR_DOT && (INDEX == 1) && (Poziom == 1))
  {
   ch_ptr = Tab_8 + 0x2000 + 32;
   memcpy(&Kat_Pliku, ch_ptr, 32);
   if(Kat_Pliku.Klaster == 0) 
   {
    secl = (unsigned long)DIR_0;
    DIR_DOT = 0;
    DirSecx = DIRSec;
   }
   else
   {
    secl = DATA_0 + (((unsigned long)Klaster - (unsigned long)2) * (unsigned long)SecPerClusL);
    DIR_DOT = 1; 
    DirSecx = (unsigned short)SecPerClusL;
   }
  }
 }

 if(Tryb_RootDIR)
 {
  secl = (unsigned long)DIR_0;;
  DIR_DOT = 0; 
  DirSecx = DIRSec;
  Poziom = 0;
 }
 else
 {
  DIR_DOT = 1;
  if(Klaster_dot_B != Klaster_dot)
  {
   if((INDEX == 1) && Poziom)
    Poziom--;
   else
    Poziom++;
  }
 }

 Klaster_dot_B = Klaster_dot;

 if(DirSecx < 65) // 65
  DirSecx = 64;
// DIRSec = DirSecx;

 if(DirSecx < 49)
 {
  sech = secl + (unsigned long)DirSecx - (unsigned long)1;

  error = 0;
  Zapal_SD;
  read_n_sec();
  Zgas_SD;
  if(error)
   return 0x00FE;

  for(f123=0;f123<768;f123++)
  {
   ch_ptr = (void*)Tab_8 + 0x2000 + (f123 << 5);
   WR_SRAM(f123 << 5, ch_ptr);
  }
  memcpy((void*)DIR0, (void*)Buf_8_2k, 24576);
 }
 else
 {
  secl = secl + 32;
  sech = secl + (unsigned long)31;

  error = 0;
  Zapal_SD;
  read_n_sec();
  Zgas_SD;
  if(error)
   return 0x00FE;

  for(f123=0;f123<512;f123++)
  {
   ch_ptr = (void*)Tab_8 + 0x2000 + (f123 << 5);
   WR_SRAM(0x4000+(f123 << 5), ch_ptr); 
  }
  dira = DIR0 + 0x4000;
  memcpy((void*)dira, (void*)Buf_8_2k, 16384);
  secl = secl - 32;
  sech = secl + (unsigned long)31;

  error = 0;
  Zapal_SD;
  read_n_sec();
  Zgas_SD;
  if(error)
   return 0x00FE;

  for(f123=0;f123<512;f123++)
  {
   ch_ptr = Tab_8 + 0x2000 + (f123 << 5);
   WR_SRAM(f123 << 5, ch_ptr); 
  }
  memcpy(DIR0, Buf_8_2k, 16384);
 }

// memcpy(DIR0, Buf_SEC, DIRSec<<9);

 LastDirEnt = Boot_HDD.Boot_RootEntCnt;
 if(Tryb_RootDIR)
  CurrDirEnt = LastDirEnt;
 else
  CurrDirEnt = (unsigned short)SecPerClusL << 4; // 32 * 14 = 512


 if(LastDirEnt > 1024) // 1024
  LastDirEnt = 1024; // 1024

 INDEX = 0;
 INDEXB = fst;

 LCD_Off;

 for(f123 = fst; f123 < CurrDirEnt ;f123++)
 {
//  ch_ptr = Tab_8 + 0x2000 + (f123 << 5);
//  memcpy(&Kat_Pliku, ch_ptr, 32);
  RD_SRAM(f123 << 5, &Kat_Pliku); 

  Typ_Pliku = Kat_Pliku.Name[0];
  if((Typ_Pliku) && ((char)Typ_Pliku != (char)0xE5))
  {
   memcpy(Name8, Kat_Pliku.Name, 8);
   Name8[8]=0x00;
   memcpy(Ext3, Kat_Pliku.Ext, 3);
   Ext3[3]=0x00;
   strcpy(zs, Name8);
   strcat(zs,".");
   strcat(zs, Ext3);
   Rozmiar_Pliku = Kat_Pliku.Rozmiar;
   Atrybut = Kat_Pliku.Atrybuty;
   Klaster = Kat_Pliku.Klaster;
   AtrybTot = (unsigned long)Atrybut;
//   strcat(zs, " / ");
   if((Atrybut!=0x10) && (Atrybut!=0x0F) && (Atrybut!=8) && ((unsigned char)Typ_Pliku < 0x7F))
   {
    Plikow++;
    INDEX++;
//    Tab_32_USB[INDEX<<2] = Klaster;
//    Tab_32_USB[(INDEX<<2)+1] = Rozmiar_Pliku;
//    Tab_32_USB[(INDEX<<2)+2] = Atrybut;
//    Tab_32_USB[(INDEX<<2)+3] = INDEXB;
    if(!strcmp(Ext3, "MP3"))
     AtrybTot = AtrybTot | 0x000000100; 
    if(!strcmp(Ext3, "WAV"))
     AtrybTot = AtrybTot | 0x000000200; 
    if(!strcmp(Ext3, "PCM"))
     AtrybTot = AtrybTot | 0x000000400; 
    if(!strcmp(Ext3, "OBJ"))
     AtrybTot = AtrybTot | 0x000000800;
    Tab_Klaster(INDEX) = Klaster;
    Tab_Rozmiar(INDEX) = Rozmiar_Pliku;
    Tab_Atrybut(INDEX) = AtrybTot;
    Tab_Indexb(INDEX) = INDEXB;
    piszs("\n\r");
    piszdec(INDEX,3);
 //   piszc('/');
//    piszdec(INDEXB,5);
    piszc(' ');
    piszs(zs);
    piszs(" ");
    piszdec(Rozmiar_Pliku, 0);
    piszc(' ');
   }
   else
   {
    if(Atrybut == 0x10)
    {
//     strcat(zs, "<DIR>");
     DIRow++;
     INDEX++;
     Tab_Klaster(INDEX) = Klaster;
     Tab_Rozmiar(INDEX) = Rozmiar_Pliku;
     Tab_Atrybut(INDEX) = Atrybut;
     Tab_Indexb(INDEX) = INDEXB;
     piszs("\n\r");
     piszdec(INDEX,3);
 //    piszc('/');
 //    piszdec(INDEXB,5);
     piszc(' ');
     piszs(zs);
     piszs(" <DIR>");
     piszc(' ');
    }
   }
  }
  INDEXB++;
  if((!Typ_Pliku) || (INDEX >= MAX_INDEX))
   break;
 }
 Indexow = DIRow + Plikow;
 if(Index_1 >= Indexow)Index_1 = Indexow - 1;

 piszs("\n\rDIR's:");
 piszdec(DIRow,0);
 piszc(' ');

 piszs("Files:");
 piszdec(Plikow,0);
 piszc(' ');

 piszs("Poziom:");
 piszdec(Poziom,0);
 piszs("<\n\r");

 LCD_X;

 return 0;
}
//---------------------------------------------------------------------------

void DIR_AB(short ab)
{
short f123, fst, dot;

  fst = 0;
  dot = 0;
  if(DIR_DOT)
      dot = 1;
  INDEX = 0;
  INDEXB = fst;
  Plikow = 0;
  DIRow = 0;
  
  LCD_On;
  gotoxy(1,1);

  for(f123 = fst; f123 < CurrDirEnt ;f123++)
  {
 //  ch_ptr = Tab_8 + 0x2000 + (f123 << 5);
 //  memcpy(&Kat_Pliku, ch_ptr, 32);
   RD_SRAM(f123 << 5, &Kat_Pliku); 

   Typ_Pliku = Kat_Pliku.Name[0];
   if((Typ_Pliku) && ((char)Typ_Pliku != (char)0xE5))
   {
    memcpy(Name8, Kat_Pliku.Name, 8);
    Name8[8]=0x00;
    memcpy(Ext3, Kat_Pliku.Ext, 3);
    Ext3[3]=0x00;
    strcpy(zs, Name8);
    strcat(zs,".");
    strcat(zs, Ext3);
    Rozmiar_Pliku = Kat_Pliku.Rozmiar;
    Atrybut = Kat_Pliku.Atrybuty;
    Klaster = Kat_Pliku.Klaster;
    AtrybTot = (unsigned long)Atrybut;
 //   strcat(zs, " / ");
    if((Atrybut!=0x10) && (Atrybut!=0x0F) && (Atrybut!=8) && ((unsigned char)Typ_Pliku < 0x7F))
    {
     Plikow++;
     INDEX++;
     if(!strcmp(Ext3, "MP3"))
      AtrybTot = AtrybTot | 0x000000100; 
     if(!strcmp(Ext3, "WAV"))
      AtrybTot = AtrybTot | 0x000000200; 
     if(!strcmp(Ext3, "PCM"))
      AtrybTot = AtrybTot | 0x000000400; 
     if(!strcmp(Ext3, "OBJ"))
      AtrybTot = AtrybTot | 0x000000800; 
     Tab_Klaster(INDEX) = Klaster;
     Tab_Rozmiar(INDEX) = Rozmiar_Pliku;
     Tab_Atrybut(INDEX) = AtrybTot;
     Tab_Indexb(INDEX) = INDEXB;

     if((INDEX == ab) || (INDEX == (ab+1)))
      {
       piszs("\n\r");
       gotoxy(1, INDEX - ab + 1);
       piszdec(INDEX - dot,3);
  //   piszc('/');
 //    piszdec(INDEXB,5);
       piszc(' ');
       piszs(zs);
       piszs(" ");
       if(Rozmiar_Pliku < 9999999)
        {
         piszdec(Rozmiar_Pliku >> 10, 4);
         piszs("k ");
        }
       else
        {
         piszdec(Rozmiar_Pliku >> 20, 4);
         piszs("M ");
        }

      }
    }
    else
    {
     if(Atrybut == 0x10)
     {
 //     strcat(zs, "<DIR>");
      DIRow++;
      INDEX++;
      Tab_Klaster(INDEX) = Klaster;
      Tab_Rozmiar(INDEX) = Rozmiar_Pliku;
      Tab_Atrybut(INDEX) = Atrybut;
      Tab_Indexb(INDEX) = INDEXB;
      if((INDEX == ab) || (INDEX == (ab+1)))
       {
        piszs("\n\r");
        gotoxy(1, INDEX - ab + 1);
        piszdec(INDEX - dot,3);
  //    piszc('/');
  //    piszdec(INDEXB,5);
        piszc(' ');
        piszs(zs);
        piszs(" <DIR>");
        piszc(' ');
       }
     }
    }
   }
   INDEXB++;
   if((!Typ_Pliku) || (INDEX >= MAX_INDEX))
    break;
  }

  if(ab > Indexow)
      {
       gotoxy(1,2);
       piszs("Plikow:");
       piszdec(Plikow, 3);
       piszs("   ");
      }
  // Indexow = DIRow + Plikow;
  // if(Index_1 >= Indexow)Index_1 = Indexow - 1;

 LCD_X;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

void DIR_ABP(short ab)
{
long fab, fst, attp_, rp_;

  fst = INDEXP;
  INDEXP = ab;
  
  LCD_On;
  gotoxy(1,1);

  for(fab = ab; fab < (ab + 2); fab++)
  {
   INDEXP = fab;
   attp_ = Get_NameP(zs);
   rp_ = Tab_32_Eth[(fab*5)+4];
   if(INDEXP <= IndexowP)
   {
    if(attp_ != 0x10)
    {
  
         piszs("\n\r");
         if(fab == ab)
           gotoxy(1, 1);
         else
           gotoxy(1,2);
         piszdec(INDEXP, 3);
         piszc(' ');
         piszs(zs);
         piszs(" ");
         if(rp_ < 9999999)
          {
           piszdec(rp_ >> 10, 4);
           piszs("k ");
          }
         else
          {
           piszdec(rp_ >> 20, 4);
           piszs("M ");
          }
    }
    else
    {
        piszs("\n\r");
        if(fab == ab)
          gotoxy(1, 1);
        else
          gotoxy(1,2);
        piszdec(INDEXP, 3);
        piszc(' ');
        piszs(zs);
        piszs(" <DIR>");
        piszc(' ');
    }
   }
  }

  if(ab > IndexowP)
      {
       gotoxy(1,2);
       piszs("Plikow:");
       piszdec(PlikowP, 3);
       piszs("   ");
      }
  // Indexow = DIRow + Plikow;
  // if(Index_1 >= Indexow)Index_1 = Indexow - 1;
 INDEXP = fst;
 attp_ = Get_NameP(zs);
 LCD_X;
}
// --------------------------------------------------------------------------------

// Daj nazwe pliku z SD
unsigned short Get_Name(char *buff, short indx)
{
unsigned short adr, f;

 adr = Tab_Indexb(indx) << 5; // INDEXB

 if(indx <= MAX_INDEX)
 {
//  adr = adr & 0xFFE0; // Modulo 32

  CS_SRAM_0; // CS_SRAM#
  SPI1(0x03); // Read 23K256
  SPI1(adr >> 8); // Adres H
  SPI1(adr & 0x00E0); // Adres L
  for(f=0;f<12;f++)
   buff[f] = SPI1(0x00FF);
  buff[12]=0;
  CS_SRAM_1; // CS_SRAM#
 }
 return 0;
}
//---------------------------------------------------------------------------

// Zrob atrybut plikow z pendriv'a
// 0010 DIP
// 0020 File
// 0120 File MP3
unsigned short Get_AtrP(char *buff)
{
unsigned short x, d, m, f, c, s, r;

 x = strlen(buff);
 d = 0; 
 m = 0;
 r = 0x0020;

 if(x > 5)
     {
     for(f=x-5;f<x-1;f++)
         {
          c = buff[f];
          s = x - f; 
              switch(s)
                  {
                  case 5 :  if(c == '.')m++;
                            if(c == ' ')d++;
                            break;
                  case 4 :  if(c == 'M')m++;
                            if(c == 'D')d++;
                            break;
                  case 3 :  if(c == 'P')m++;
                            if(c == 'I')d++;
                            break;
                  case 2 :  if(c == '3')m++;
                            if(c == 'R')d++;
                            break;
                  default:  break;
                  }
         }
    
     }

 if(m == 4)r = 0x0120;
 if(d == 4)r = 0x0010;

 return r;
}
//---------------------------------------------------------------------------

// Wpisz nazwe pliku z pendriv'a
unsigned short Put_NameP(char *buff, unsigned short atryb)
{
unsigned short d, f, c, s, ix;
unsigned long dd;

 d = 0; 
 s = 0;
 ix = INDEXP * 5;

 if(INDEXP <= MAX_INDEXP)
 {
      for(f=0;f<3;f++)
      {
       dd = 0;
         for(s=0;s<4;s++)
          {
            c = buff[(f*4) + s];
            if((c == ' ')||(c == 0x0D))
                d++;
            if(d)
                c = 0;
            switch(s)
            {
                          case 0 :  dd = c & 0x000000FF;
                                    break;
                          case 1 :  dd = dd | (c << 8);
                                    break;
                          case 2 :  dd = dd | (c << 16);
                                    break;
                          case 3 :  dd = dd | (c << 24);
                          default:  break;
           }
    
         }
       Tab_32_Eth[ix + f] = dd;
      }
  Tab_32_Eth[ix + 3] = atryb;
  return(INDEXP);
 }
 else
  return 0;
}
//---------------------------------------------------------------------------

// Daj nazwe pliku z pendriv'a
unsigned short Get_NameP(char *buff)
{
unsigned short f, c, s, ix;
unsigned long dd;
// Tab_32_Eth[x+0]=name[0..3], 
// Tab_32_Eth[x+1]=name[4..7], 
// Tab_32_Eth[x+2]=name[8..11], 
// Tab_32_Eth[x+3]=AttP, 
// Tab_32_Eth[x+4]=Rozmiar_Pliku_P 

ix = INDEXP * 5;

 if(INDEXP <= MAX_INDEXP)
 {
      for(f=0;f<3;f++)
      {
       dd = Tab_32_Eth[ix + f];
         for(s=0;s<4;s++)
          {
            switch(s)
            {
                          case 0 :  c = dd & 0x000000FF;
                                    break;
                          case 1 :  c = dd >> 8;
                                    break;
                          case 2 :  c = dd >> 16;
                                    break;
                          case 3 :  c = dd >> 24;
                          default:  break;
           }
           buff[(f*4) + s] = c;
         }

      }

  if(Tab_32_Eth[ix + 3] != 0x0010)
      Rozmiar_Pliku_P = Tab_32_Eth[ix + 4];

  return(Tab_32_Eth[ix + 3]);  // Atrybut
 }
 else
  return 0;
}
//---------------------------------------------------------------------------


// Pobierz i wpisz dlugosc pliku z pendriv'a
unsigned long Put_RozmiarP(char *buff)
{
unsigned short f, c, ix, x;
unsigned long dd, s;

 x = strlen(buff);
 ix = INDEXP * 5;

 if(INDEXP <= MAX_INDEXP)
 {
//     WR_VDIP(0x0D); // CR
//     delayx(0x00000100);
//     while(RD_VDIP() != 0x0D)

     WR_VDIP(0x01); // DIR
     WR_VDIP(0x20);


     for(f=0;f<x;f++) // Nazwa
      {
       WR_VDIP(buff[f]);
      }

     WR_VDIP(0x0D); // CR

     delayx(0x00000100);

//   Odpowiedz: CR name SPACE 4xHEX CR

     while(RD_VDIP() != 0x20)

     dd = 0;
     s = (unsigned long)GC_VDIP();
     dd = dd + (s & 0x000000FF);
     s = (unsigned long)GC_VDIP() << 8;
     dd = dd + (s & 0x0000FF00);
     s = (unsigned long)GC_VDIP() << 16;
     dd = dd + (s & 0x00FF0000);
     s = (unsigned long)GC_VDIP() << 24;
     dd = dd + (s & 0xFF000000);

     c = GC_VDIP(); // CR

     Tab_32_Eth[ix + 4] = dd;
     Rozmiar_Pliku_P = dd;

  return(dd);  // Rozmiar pliku
 }
 else
  return 0;
}
//---------------------------------------------------------------------------

unsigned short Open_VDIP(void)
{
int mx, uc, f, xx;

   INDEXP = 0;
   IndexowP = 0;
   DIRowP = 0;
   PlikowP = 0;
   Tab_32_Eth[0] = 0; // ROOT DIR

// Sprwadzenie VDIP
   gotoxy(1,1);
   piszs("\n\rVDIP-");
   mx = 1;

   WR_VDIP(0x0D); // Enter
   delayx(0x00001000);
   for(f=0;f<99;f++)
   {
    xx = RD_VDIP(); // Slepe czytanie
    if((xx>0x1F) && (xx<0x7F))
      piszc(xx);
   }

   WR_VDIP(0x10);
   WR_VDIP(0x0D); // shorted mode
   delayx(0x00000100);
   GL_VDIP(); // Slepe czytanie
   delayx(0x00000100);

   WR_VDIP(0x0D); // identifocatoin
   delayx(0x00000100);
   xx = GL_VDIP();
   if(xx == 3)
   {
     if((Buf_8[0]=='N') && (Buf_8[1]=='D'))
     {
      piszs("No Disk ");
      mx = 0;
     }

     if((Buf_8[0]=='N') && (Buf_8[1]=='U'))
      piszs("No Update ");
   }
   if(xx == 4)
     if((Buf_8[0]=='D') && (Buf_8[1]=='D') && (Buf_8[2]=='2'))
      piszs("Device 2 ");

   WR_VDIP(0x0D); // identifocatoin
   delayx(0x00000100);
    xx = GL_VDIP();
    if(xx == 3)
    {
      if((Buf_8[0]=='N') && (Buf_8[1]=='D'))
      {
       piszs("No Disk ");
       mx = 0;
      }

      if((Buf_8[0]=='N') && (Buf_8[1]=='U'))
       piszs("No Update ");
    }
    if(xx == 4)
      if((Buf_8[0]=='D') && (Buf_8[1]=='D') && (Buf_8[2]=='2'))
        piszs("Device 2 ");

   if(mx)
   {
    piszs("OK ");
// OK -------------------------------

    LCD_Off;

    WR_VDIP(0x0D); // CR
    delayx(0x00001000);

    WR_VDIP(0x91);
    WR_VDIP(0x0D); // binary values
    delayx(0x00000100);
    GL_VDIP(); // Slepe czytanie
    delayx(0x00000100);

    WR_VDIP(0x01); // DIR
    WR_VDIP(0x0D); // CR
    delayx(0x00001000);

    piszs("\n\rDIR(K/P).._");
    Timer_1 = 600;
    while(Timer_1)
    {
        xx = GL_VDIP();
        if(!xx)
            break;
        Buf_8[xx] = 0;

//        piszs("\n\r"); // Nowa linia dla DIR'a

        if((xx > 5) && (Buf_8[xx-5]==' ') && (Buf_8[xx-4]=='D'))
        {
         if(!((xx == 6) && (Buf_8[0]))) // Pomijam katalog "."
         {
            INDEXP++;
            DIRowP++;
            //piszs("\010K");
         }
         else
         {
            //piszs("000 ");
            Tab_32_Eth[0] = 0x002E; // Dot DIR 
         }
        }
        else
            if((xx>2) && (Buf_8[xx-2] != '>'))
            {
                INDEXP++;
                PlikowP++;
                //piszs("\010P");
            }

        if( INDEXP && (xx>2)) // pomijam ">"
            {
                //piszdec(INDEXP,3);
                //piszc(' ');

                //for(f=0;f<xx;f++)
                //    piszc(Buf_8[f]);

                AttP = Get_AtrP(Buf_8);

                Put_NameP(Buf_8, AttP);
            }

        uc = KlawX();
        if(uc == 0x0B)
            break;
     }
    }

    LCD_On;
    gotoxy(1,2);
    piszs("\n\rKat.:");
    piszdec(DIRowP,0);
    piszs(" Plik.:");
    piszdec(PlikowP,0);

    IndexowP = DIRowP + PlikowP;
    DIR_DOT_P = Tab_32_Eth[0];

// --------------------------------------------------
    
    LCD_Off;

    if(DIRowP || PlikowP)
    {
     piszs("\n\r* Drugie czytanie *");
     for(INDEXP=1; INDEXP<=IndexowP; INDEXP++)
     {
      piszs("\n\r");
      piszdec(INDEXP, 3);
      piszc(' ');
      AttP = Get_NameP(zs);
      piszs(zs);
      if(AttP == 0x0010)
      {
         piszs(" <DIR>");
      }
      else
      {
         xx = Put_RozmiarP(zs);
         piszc(' ');
         piszdec(xx, 0);
      }
     }

     DIR_OK_P = 1;

     LCD_On;
     gotoxy(1,2);
     piszs("\n\rKat.:");
     piszdec(DIRowP,0);
     piszs(" Plik.:");
     piszdec(PlikowP,0);

// Test -------------------------------------------------------- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//     xx = 0x0800;
//     for(f = 0; f < 4096; f++) 
//     {
//        Tab_32[xx] = Tab_32_Eth[f];
//        xx++;
//     }
    }

    LCD_X;

 return IndexowP;
}
// -------------------------------------------------------------

// Audio Graj PCM/WAV -----------------------------------
unsigned long Graj_PCM(short Index)
{
int x1l, rr;

    EPM_WM_SCK(1);

    MUTE_On();

    if(DDAdr)
    {
        STA_write(0x05, Tryb_44); // SFREQ: 0-48, 1-44.1, 2-32, 4-96, 5-88.2 [kHz]
        Set_PLL2PCM(0, 2);
        // STA_PLL_in(0, 0);
        act_decoder = 0;
        STA_write(0x4C, 0x03);
        STA_write(0x4D, 0x03);
        STA_write(0x05, Tryb_44); // SFREQ: 0-48, 1-44.1, 2-32, 4-96, 5-88.2 [kHz]
        CircleSurr();
        VCROut();
        piszs("*CSurr*");
        //piszs("SIN_1");
    }

    WM_INB = WM_IN;
    WM_OUT_MXB = WM_OUT_MX;
    WM_IN = 7;
    TDA_Vol(TDA_Vol_7 + (TDA_Bass_X>>1));
    if(MODE_DIG)
        {
           WM_OUT_MX = 1; // DAC1,2,3,4
           WM_DIG_ATT(0xFE, 0xFE, 0xFE, 0xFE);
        }
    else
        {  
           WM_OUT_MX = 3; // DAC & AUX
           WM_DIG_ATT(0x01, 0x01, 0x01, 0xFE);
        }
    write_WM8770(0x1B, 0x77); // LMX(2,1,0); RMX(6,5,4)
    WM_Out_Mix(WM_OUT_MX, WM_OUT_MX, WM_OUT_MX, WM_OUT_MX); // 1-DAC, 2-Bypass/DAC, 5-AUX/DAC, 7-Bypass/AUX/DAC

    Display_Freq(19,2);
    gotoxy(1,1);
    piszs("PLY:"); // +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ Test

    rr = Graj_PCM_WAV(Index, 0);
    Timer_M = 100;
    MUTE_On();

    WM_IN = WM_INB;
    if((WM_IN & 0x07) != 0x07)
        TDA_Vol(TDA_Vol_7 + (TDA_Bass_X>>1));
    if((WM_IN & 0x07)==0)
        TDA_Vol(TDA_Vol_Radio + (TDA_Bass_X>>1));
     WM_OUT_MX = WM_OUT_MXB;
    x1l = WM_IN << 4;
    x1l = x1l | WM_IN;
    write_WM8770(0x1B, x1l); // LMX(2,1,0); RMX(6,5,4)
    WM_Out_Mix(WM_OUT_MX, WM_OUT_MX, WM_OUT_MX, WM_OUT_MX); // 1-DAC, 2-Bypass/DAC, 5-AUX/DAC, 7-Bypass/AUX/DAC

    if(DDAdr)
    {

     if(SPDIF)
     {    
         STA_PLL_in(1, 1); // (1, 1); (1, 0)
         //STA_Restart(1);
         piszs("SPDIF");
     }
     else
     {
         STA_write(0x05,CTRL3&0x01); // SFREQ: 0-48, 1-44.1, 2-32, 4-96, 5-88.2 [kHz]
         Set_PLL2PCM(0, 2);
         // STA_PLL_in(0, 0);
         act_decoder = 0;
         STA_write(0x4C, 0x03);
         STA_write(0x4D, 0x03);
         STA_write(0x05,CTRL3&0x01); // SFREQ: 0-48, 1-44.1, 2-32, 4-96, 5-88.2 [kHz]
         CircleSurr();
         VCROut();
         piszs("*CSurr*");
         //piszs("SIN_1");
     }
    }
// WM_DIG_ATT(0xFE, 0xFE, 0xFE, 0xFE);
 while(Timer_M);
   MUTE_Off();
 return rr;
}
//---------------------------------------------------------------------------

// Audio Graj PCM/WAV -----------------------------------
unsigned long Graj_WAV(short Index)
{
unsigned short tryb;
unsigned long rr, x1l;

 tryb = 0;
 rr = 0;
  
// Nalezy odczytac naglowek
 Klaster = Tab_Klaster(Index);
 secl = DATA_0 + (((unsigned long)Klaster - (unsigned long)2) * (unsigned long)SecPerClusL);
 sech = secl;
 Zapal_SD;
 read_n_sec();
 Zgas_SD;
 
 gotoxy(1,1);

 ch_ptr = Tab_8 + 0x2000;
 memcpy(&Header_WAVE, ch_ptr, 44);
// Sprawdzenie paramertow
 if(Header_WAVE.Chanels != 2)rr++;
 if(Header_WAVE.Bits_per_sample != 16)rr++;
 if((Header_WAVE.Sample_rate > 42200)&&(Header_WAVE.Sample_rate < 46000))
   tryb = 44;
 if((Header_WAVE.Sample_rate > 46000)&&(Header_WAVE.Sample_rate < 50000))
   tryb = 48;
 
 if(rr || !tryb)
  return(rr << 4);

 if(tryb == 44)
     {
      piszs(">44*"); // +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ Test
      Tryb_44_48(44);
     }
 if(tryb == 48)
     {
      piszs("*>48*"); // +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ Test
      Tryb_44_48(48);
     }

 EPM_WM_SCK(1);

 MUTE_On();

 if(DDAdr)
 {
     STA_write(0x05, Tryb_44); // SFREQ: 0-48, 1-44.1, 2-32, 4-96, 5-88.2 [kHz]
     Set_PLL2PCM(0, 2);
     // STA_PLL_in(0, 0);
     act_decoder = 0;
     STA_write(0x4C, 0x03);
     STA_write(0x4D, 0x03);
     STA_write(0x05, Tryb_44); // SFREQ: 0-48, 1-44.1, 2-32, 4-96, 5-88.2 [kHz]
     CircleSurr();
     VCROut();
     piszs("*CSurr*");
     //piszs("SIN_1");
 }

 WM_INB = WM_IN;
 WM_OUT_MXB = WM_OUT_MX;
 WM_IN = 7;
 TDA_Vol(TDA_Vol_7 + (TDA_Bass_X>>1));
 if(MODE_DIG)
     {
        WM_OUT_MX = 1; // DAC1,2,3,4
        WM_DIG_ATT(0xFE, 0xFE, 0xFE, 0xFE);
     }
 else
     {  
        WM_OUT_MX = 3; // DAC & AUX
        WM_DIG_ATT(0x01, 0x01, 0x01, 0xFE);
     }
 write_WM8770(0x1B, 0x77); // LMX(2,1,0); RMX(6,5,4)
 WM_Out_Mix(WM_OUT_MX, WM_OUT_MX, WM_OUT_MX, WM_OUT_MX); // 1-DAC, 2-Bypass/DAC, 5-AUX/DAC, 7-Bypass/AUX/DAC

 Display_Freq(19,2);
 gotoxy(1,1);
 piszs("PLY:"); // +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ Test

 rr = Graj_PCM_WAV(Index, tryb);

 Timer_M = 100;
 MUTE_On();

 WM_IN = WM_INB;
 if(WM_IN != 0x07)
     TDA_Vol(TDA_Vol_0 + (TDA_Bass_X>>1));
 if(!WM_IN)
     TDA_Vol(TDA_Vol_Radio + (TDA_Bass_X>>1));
 WM_OUT_MX = WM_OUT_MXB;
 x1l = WM_IN << 4;
 x1l = x1l | WM_IN;
 write_WM8770(0x1B, x1l); // LMX(2,1,0); RMX(6,5,4)
 WM_Out_Mix(WM_OUT_MX, WM_OUT_MX, WM_OUT_MX, WM_OUT_MX); // 1-DAC, 2-Bypass/DAC, 5-AUX/DAC, 7-Bypass/AUX/DAC

 gotoxy(1,1);
 if(Tryb_44_X == 48)
   {
    piszs("*>48*"); // +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ Test
    Tryb_44_48(48);
   }
 else
   {
    piszs("*>44*"); // +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ Test
    Tryb_44_48(44);
   }


 if(DDAdr)
    {
    
     if(SPDIF)
     {    
         STA_PLL_in(1, 1); // (1, 1); (1, 0)
         //STA_Restart(1);
         piszs("SPDIF");
     }
     else
     {
         STA_write(0x05,CTRL3&0x01); // SFREQ: 0-48, 1-44.1, 2-32, 4-96, 5-88.2 [kHz]
         Set_PLL2PCM(0, 2);
         // STA_PLL_in(0, 0);
         act_decoder = 0;
         STA_write(0x4C, 0x03);
         STA_write(0x4D, 0x03);
         STA_write(0x05,CTRL3&0x01); // SFREQ: 0-48, 1-44.1, 2-32, 4-96, 5-88.2 [kHz]
         CircleSurr();
         VCROut();
         piszs("*CSurr*");
         //piszs("SIN_1");
     }
    }
// WM_DIG_ATT(0xFE, 0xFE, 0xFE, 0xFE);
 while(Timer_M);
   MUTE_Off();
 return rr;
}
//---------------------------------------------------------------------------

// Audio Graj PCM/WAV -----------------------------------
unsigned long Graj_PCM_WAV(short Index, short tryb)
{
short Indexb, f, klx;
unsigned long Sec_t, Sec_c, Sec_g, Bayt_t, Bayt_g, Klast_t, Klast_g, xxx, mdc, prgs; 

 VICVectAddr31 = (uint32_t) Irq_I2S_Tx; // I2S_Tx; I2S_Rx

 //write_WM8770(0x16, 0x005); // Interface ctrl: 001 - L Just, L,R; 005 - L Just, R,L
 cros(0);

 piszs("\010\n\r");
 gotoxy(1,1);
 piszs("PLY:");

 Get_Name(name32, Index);
 strncpy(zs, name32, 8);
 zs[8]='.';
 zs[9]=name32[8];
 zs[10]=name32[9];
 zs[11]=name32[10];
 piszs(zs);

 Klaster = Tab_Klaster(Index);
 Rozmiar_Pliku = Tab_Rozmiar(Index);
 Indexb = Tab_Indexb(Index);

 Bayt_t = Rozmiar_Pliku;
 Bayt_g = 0;

 Sec_t = Bayt_t >> 9;
 Sec_g = 0;
 Sec_c = 0;

 gotoxy(18,2);
 piszs("  000% ");
 prgs = 12345;

 gotoxy(24,1);
 mdc = 'w';

 Klast_t = Sec_t / SecPerClusL;
 if((Klast_t * SecPerClusL) < Sec_t)
  Klast_t++;
 Klast_g = 0;

 if(Sec_t < 48) // Za molo sektorow -----------------------
  return 0xFE; 

 CTRL1B = CTRL1;
 //CTRL1 = CTRL1_GRAJ_WAV; //0x83
 //LD_Latch_n(CTRL1, 1); 

 CTRL2B = CTRL2;
 //CTRL2 = CTRL2_GRAJ_WAV; //0x4A
 //LD_Latch_n(CTRL2, 2);
 if(MODE_DIG)
  MUX123 = MUX123_GRAJ_WAV_DD;
 else
  MUX123 = MUX123_GRAJ_WAV;

 CTRL3B = CTRL3;
 //CTRL3 &= 0xFC;
 //CTRL3 |= CTRL3_GRAJ_WAV; //0xEA
 //LD_Latch_n(CTRL3, 3);
 if(MODE_DIG)
  MUX45 = MUX45_GRAJ_WAV_DD;
 else
  MUX45 = MUX45_GRAJ_WAV;

 Konfiguracja();

 MUTE_Off();

 xxx = DATA_0 + (((unsigned long)Klaster - (unsigned long)2) * (unsigned long)SecPerClusL);

 if((SD_SECTORS > xxx) && (SecPerClusL >= (unsigned long)16))
 {
  secl = xxx;
  sech = secl + 15;
  Zapal_SD;
  read_n_sec();
  Zgas_SD;
  Sec_g = Sec_g + 16;
  Sec_c = Sec_c + 16;
  if(Sec_c == SecPerClusL)
  {
   Klaster = GFAT0(Klaster);
   Sec_c = 0;
   secl = DATA_0 + (((unsigned long)Klaster - (unsigned long)2) * (unsigned long)SecPerClusL);
  }
  else
   secl = secl + 16;
  sech = secl + 15;

// Jesli WAV, to wycisz naglowek
  if(tryb)
   for(f=0x2000;f<0x202C;f++)
    Tab_8[f] = 0;

  Zapal_SD;
  read_n_sec_x(0x4000);
  Zgas_SD;
  Sec_g = Sec_g + 16;
  Sec_c = Sec_c + 16;
  if(Sec_c == SecPerClusL)
  {
   Klaster = GFAT0(Klaster);
   Sec_c = 0;
   secl = DATA_0 + (((unsigned long)Klaster - (unsigned long)2) * (unsigned long)SecPerClusL);
  }
  else
   secl = secl + 16;
  sech = secl + 15;

  Zapal_SD;
  read_n_sec_x(0x6000);
  Zgas_SD;
  Sec_g = Sec_g + 16;
  Sec_c = Sec_c + 16;
  if(Sec_c == SecPerClusL)
  {
   Klaster = GFAT0(Klaster);
   Sec_c = 0;
   secl = DATA_0 + (((unsigned long)Klaster - (unsigned long)2) * (unsigned long)SecPerClusL);
  }
  else
   secl = secl + 16;
  sech = secl + 15;

  i2s_x=4; // 4
  i2s_y=4; // 4
  i2s_o=0; // 0
  i2s_b=0; // 0 lub 8

  for(f=0;f<8;f++)
  {
   I2S_TX_FIFO = 0;
  }

  xxx = i2s_o;

  I2S_IRQ = 0 + 0x0002 + (4<<8) + (4<<16); // IRQ_rx(01), IRG_tx(02), FIFO_level_rx, FIFO_level_tx

  piszc(mdc);

  while(1)
  {
   if(xxx != i2s_o)
   {
    xxx = i2s_o;
    piszc(8);
    gotoxy(24,1);
    mdc ^= 0x01;
    piszc(mdc);
   }

// Progres =========================================================
   ECHO_Off;
   if(prgs!=Progres(Sec_t , Sec_g))
       {
        prgs = Progres(Sec_t , Sec_g);
        gotoxy(20,2);
        piszdec( prgs , 3);
       }
   LCD_X;

   if(Sec_g >= Sec_t)
   {
    delayx(0x00013210);
    break;
   }
   if(i2s_b & 1)
   {
    DI;i2s_b &= 0x0E;EI;
    Zapal_SD;
    read_n_sec_x(0x2000);
    Zgas_SD;
    Sec_g = Sec_g + 16;
    Sec_c = Sec_c + 16;
    if(Sec_c == SecPerClusL)
    {
     Klaster = GFAT0(Klaster);
     Sec_c = 0;
     secl = DATA_0 + (((unsigned long)Klaster - (unsigned long)2) * (unsigned long)SecPerClusL);
    }
    else
     secl = secl + 16;
    sech = secl + 15;
   }

   if(i2s_b & 2)
   {
    DI;i2s_b &= 0x0D;EI;
    Zapal_SD;
    read_n_sec_x(0x4000);
    Zgas_SD;
    Sec_g = Sec_g + 16;
    Sec_c = Sec_c + 16;
    if(Sec_c == SecPerClusL)
    {
     Klaster = GFAT0(Klaster);
     Sec_c = 0;
     secl = DATA_0 + (((unsigned long)Klaster - (unsigned long)2) * (unsigned long)SecPerClusL);
    }
    else
     secl = secl + 16;
    sech = secl + 15;
   }

   if(i2s_b & 4)
   {
    DI;i2s_b &= 0x0B;EI;
    Zapal_SD;
    read_n_sec_x(0x6000);
    Zgas_SD;
    Sec_g = Sec_g + 16;
    Sec_c = Sec_c + 16;
    if(Sec_c == SecPerClusL)
    {
     Klaster = GFAT0(Klaster);
     Sec_c = 0;
     secl = DATA_0 + (((unsigned long)Klaster - (unsigned long)2) * (unsigned long)SecPerClusL);
    }
    else
     secl = secl + 16;
    sech = secl + 15;
   }

   klx = KlawX();
   if((klx==0x1B)||(klx == 0x0D))
   {
    gotoxy(24,1);
    piszc('<');
    break;
   }
   if((klx == '+')||(klx == '-'))
        Set_Vol_SPK(klx);
   klx = 0;
  }
// wylacz przerwania IRG_tx(02)
  I2S_IRQ = 0 + 0 + (4<<8) + (4<<16); // IRQ_rx(01), IRG_tx(02), FIFO_level_rx, FIFO_level_tx  

// Wypelnij FIFO wartosciami (0x0303)771/(0xFCFC)-771 bo TX bedzie nadawac w nieskonczonosc !
  for(f=0;f<4;f++)
  {
   I2S_TX_FIFO = 0x01000100;
   I2S_TX_FIFO = 0xFEFFFEFF;
  }

  //piszs(" x=");piszhex(i2s_x);
  //piszs(" y=");piszhex(i2s_y);
  //piszs(" o=");piszhex(i2s_o);
  //piszs(" SEC=");piszhex(sech + 1);
 }

 //write_WM8770(0x16, 0x001); // Interface ctrl: 001 - L Just, L,R; 005 - L Just, R,L
 cros(0);

 CTRL1 = CTRL1B;
 LD_Latch_n(CTRL1, 1);

 CTRL2 = CTRL2B;
 LD_Latch_n(CTRL2, 2);

 CTRL3 = CTRL3B;
 LD_Latch_n(CTRL3, 3);

 return 0;
}
// ---------------------------------------------------------------------------------

// Audio Graj MP3 -----------------------------------
unsigned long Graj_MP3(short Index)
{
unsigned short Indexb, Zeroj, mdc, xsh, fsh, fade, ign;// x1l;
unsigned long Sec_t, Sec_c, Sec_g, Bayt_t, Bayt_g, Klast_t, Klast_g, xxx, fff, framesm;
short klx, prgs; 

 Zeroj = 0;
 mdc = 'v';
 prgs = 12345;
 fade = 0;
 ign = 0;

 piszs("\010\n\r");
 gotoxy(1,1);
 piszs("PLY:");

 Get_Name(name32, Index);
 strncpy(zs, name32, 8);
 zs[8]='.';
 zs[9]=name32[8];
 zs[10]=name32[9];
 zs[11]=name32[10];
 piszs(zs);

 Klaster = Tab_Klaster(Index);
 Rozmiar_Pliku = Tab_Rozmiar(Index);
 Indexb = Tab_Indexb(Index);

 Bayt_t = Rozmiar_Pliku;
 Bayt_g = 0;

 Sec_t = Bayt_t >> 9;
 Sec_g = 0;
 Sec_c = 0;

 Klast_t = Sec_t / SecPerClusL;
 if((Klast_t * SecPerClusL) < Sec_t)
  Klast_t++;
 Klast_g = 0;

 if(Sec_t < 112) // Za molo sektorow -----------------------
  return 0xFE; 

 xxx = DATA_0 + (((unsigned long)Klaster - (unsigned long)2) * (unsigned long)SecPerClusL);

 if((SD_SECTORS > xxx) && (SecPerClusL >= (unsigned long)16))
 {
  i2c_write_STA015(0x46, 96);  // DLA ATT
  i2c_write_STA015(0x48, 96);  // DRA ATT

  Record = 1; // Blokada ADC L R
  Unmute_F = 0;

// 2000 ------------------------------------------------------------------------------------------
  secl = xxx;
  sech = secl + 15;
  Zapal_SD;
  read_n_sec();
  Zgas_SD;
  Sec_g = Sec_g + 16;
  Sec_c = Sec_c + 16;

  // MP3Freq ------------------------------- okresl czestotliwosc MP3Freq--------------------------------
  MP3TAG = 0;  // 0 - TAGv1, 1 - TAGv2
  MP3Freq = 0; // 0x00 - 44100, 0x04 - 48000, 0x08 - 32000
  if((Tab_8[0x2000]=='I')&&(Tab_8[0x2001]=='D')&&(Tab_8[0x2002]=='3'))
      {
        MP3TAG = 1;
        // szukamy 62 bajtow 0x00, 0xFF, 0xFB lub 0xFA
        xsh = 0;
        for(fsh = 0x2300; fsh < 0x2FFF; fsh++)
            {
                if(!Tab_8[fsh])
                    xsh++;
                else
                    break;
                 
            }
        if((xsh > 61)&&(Tab_8[0x2300+xsh]==0xFF)&&((Tab_8[0x2301+xsh]|0x01)==0xFB))
            MP3Freq = Tab_8[0x2302+xsh] & 0x0C;
      }
  if((Tab_8[0x2000]==0xFF)&&((Tab_8[0x2001]|0x01)==0xFB))
        MP3Freq = Tab_8[0x2002] & 0x0C;

  gotoxy(2,1);
  switch(MP3Freq)
      {
    case 0x00    : piszs("44");
                   MP_Freq = 44100;
          break;
    case 0x04    : piszs("48");
                   MP_Freq = 48000;
          break;
    case 0x08    : piszs("32");
                   MP_Freq = 32000;
          break;
      }

  // Odczyt TAG'ow
  xsh = 0;
  if(MP3TAG)
    {
     // Szukam tytul: TIT2 00 00 00 x 00 00 00 t y t u l
     // Szuknie artysty: TPE1 00 00 00 x 00 00 00 artysta
     for(fsh = 0x2003; fsh < 0x2300; fsh++)
       {
        if((Tab_8[fsh]==0x54)&&(Tab_8[fsh+1]==0x49)&&(Tab_8[fsh+2]==0x54)&&(Tab_8[fsh+3]==0x32))
          {
           xsh = Tab_8[fsh+7];
           if(xsh > 2)
             xsh--; // xsh = ilosc znakow - 1
           if(xsh < 64)
             {
              xsh = 0;
              for(fff = fsh + 11; fff < fsh + 35; fff++)
                {
                  Buf_zs[xsh] = Tab_8[fff];
                  xsh++;
                  Buf_zs[xsh] = 0x00; // maksymalnie 24 znaki
                  if(xsh == Tab_8[fsh+7]) // ostatni znak
                    break;
                }
              gotoxy(8,1);
              piszc('/');
              for(fff = 0; fff < 8; fff++)
                piszc(Buf_zs[fff]);
              break;
             }
          }
       }

    }

  // -----------------------------------------------------------------------------------------------------

  if(Sec_c == SecPerClusL)
  {
   Klaster = GFAT0(Klaster);
   Sec_c = 0;
   secl = DATA_0 + (((unsigned long)Klaster - (unsigned long)2) * (unsigned long)SecPerClusL);
  }
  else
   secl = secl + 16;
  sech = secl + 15;

// 4000 ------------------------------------------------------------------------------------------
  Zapal_SD;
  read_n_sec_x(0x4000);
  Zgas_SD;
  Sec_g = Sec_g + 16;
  Sec_c = Sec_c + 16;
  if(Sec_c == SecPerClusL)
  {
   Klaster = GFAT0(Klaster);
   Sec_c = 0;
   secl = DATA_0 + (((unsigned long)Klaster - (unsigned long)2) * (unsigned long)SecPerClusL);
  }
  else
   secl = secl + 16;
  sech = secl + 15;

// 6000 ------------------------------------------------------------------------------------------
  Zapal_SD;
  read_n_sec_x(0x6000);
  Zgas_SD;
  Sec_g = Sec_g + 16;
  Sec_c = Sec_c + 16;
  if(Sec_c == SecPerClusL)
  {
   Klaster = GFAT0(Klaster);
   Sec_c = 0;
   secl = DATA_0 + (((unsigned long)Klaster - (unsigned long)2) * (unsigned long)SecPerClusL);
  }
  else
   secl = secl + 16;
  sech = secl + 15;

  i2s_x=0; // 0
  i2s_y=0; // 0, 0x4000 / 4
  i2s_o=0; // 0
  i2s_b=7; // 7

//  WM_INB = WM_IN;
//  WM_OUT_MXB = WM_OUT_MX;
//  WM_IN = 7;
//  WM_OUT_MX = 1; // DAC1,2,3,4
//  write_WM8770(0x1B, 0x77); // LMX(2,1,0); RMX(6,5,4)
//  WM_Out_Mix(WM_OUT_MX, WM_OUT_MX, WM_OUT_MX, WM_OUT_MX); // 1-DAC, 2-Bypass/DAC, 5-AUX/DAC, 7-Bypass/AUX/DAC

  write_WM8770(0x16, 0x005); // Interface ctrl: 001 - L Just, L,R; 005 - L Just, R,L

  DSP_Off();
  MUTE_Off();

  MP3_SRART(MP_Freq);

  EPM_MP3_SCK(1);

  BIT_EN_1;
  i2c_write_STA015(0x72, 0x01);  // RUN_MODE
//  gotoxy(1,2);
//  piszs(" STA015_RUN.. ");
	
  // ARM_CPSR = enableIRQ();
  // T2MCR T0MCR = 0x0003; // 0x0003 INTERRUPT
  // CTRL1 &= 0x7F;
  // CTRL1 |= 0x40;
  // LD_Latch_n(CTRL1, 1);

  while((IOPIN1 & 0x00000010)==0);

  Mp3_P = 3; // 1;
  if(Bayt_t > 320000)
      framesm = Frames + 67;
  else
      framesm = Frames + 34;

  Display_Freq(19,2);

  xxx = i2s_o;

  gotoxy(24,1);
  piszc(mdc);

  gotoxy(18,2);
  piszs("  000% ");

  while(1)
  {
   if(xxx != i2s_o)
    xxx = i2s_o;

   if(Sec_g >= Sec_t)
   {
    if(Zeroj >= 2)
     break;
    if(!Zeroj)
    {
     delayx(0x00002000); // 4000
     Zeroj++;
    }
   }

// Progres =========================================================
   ECHO_Off;
   if(prgs!=Progres(Sec_t , Sec_g))
       {
        prgs = Progres(Sec_t , Sec_g);
        gotoxy(20,2);
        piszdec( prgs , 3);
       }
   LCD_X;
   if(Sec_g >= 224) // 112
       Mp3_P = 2;

   // Fade In
   if((!fade)&&(Frames > framesm))
     for(fff = 0x0030;fff >= STA015_ATT;fff--)
     {
      i2c_write_STA015(0x46, fff);  // DLA ATT
      i2c_write_STA015(0x48, fff);  // DRA ATT
      delayx(0x0000009F);
      fade++;
     }

   if(i2s_b & 0x0100)
   {
    while(i2s_b & 0x0001); //delayx(0x00003210);
    DI;i2s_b &= 0x0E0E;EI;

    if(!ign)
       {
        if(!Zeroj)
        {
         Zapal_SD;
         read_n_sec_x(0x2000);
         Zgas_SD;
    
         Sec_g = Sec_g + 16;
         Sec_c = Sec_c + 16;
         if(Sec_c == SecPerClusL)
         {
          Klaster = GFAT0(Klaster);
          Sec_c = 0;
          secl = DATA_0 + (((unsigned long)Klaster - (unsigned long)2) * (unsigned long)SecPerClusL);
         }
         else
          secl = secl + 16;
         sech = secl + 15;
        }
        else
        {
         for(fff=0x2000;fff<0x4000;fff++)
          Tab_8[fff] = 0;
         Zeroj++;
        }
       }
    else
       ign--;

    //DI;i2s_b |= 0x0001;EI;
    piszc(8);
    gotoxy(24,1);
    mdc = 'a'; // ^= 0x01;
    piszc(mdc);// piszc('-'); //1
   }

   if(Sec_g >= Sec_t)
   {
    if(Zeroj >= 2)
     break;
    if(!Zeroj)
    {
     delayx(0x00004000);
     Zeroj++;
     Mp3_P = 1;
    }
   }

   if(i2s_b & 0x0200)
   {
    while(i2s_b & 0x0002); //delayx(0x00003210);
    DI;i2s_b &= 0x0D0D;EI;

    if(!ign)
       {
        if(!Zeroj)
        {
         Zapal_SD;
         read_n_sec_x(0x4000);
         Zgas_SD;
    
         Sec_g = Sec_g + 16;
         Sec_c = Sec_c + 16;
         if(Sec_c == SecPerClusL)
         {
          Klaster = GFAT0(Klaster);
          Sec_c = 0;
          secl = DATA_0 + (((unsigned long)Klaster - (unsigned long)2) * (unsigned long)SecPerClusL);
         }
         else
          secl = secl + 16;
         sech = secl + 15;
        }
        else
        {
         for(fff=0x4000;fff<0x6000;fff++)
          Tab_8[fff] = 0;
         Zeroj++;
         Mp3_P = 1;
        }
       }
    else
       ign--;

    //DI;i2s_b |= 0x0002;EI;
    piszc(8);
    gotoxy(24,1);
    mdc = 'c'; // mdc ^= 0x01;
    piszc(mdc); // piszc('I'); //2
   }

   if(i2s_b & 0x0400)
   {
    while(i2s_b & 0x0004); //delayx(0x00003201);
    DI;i2s_b &= 0x0B0B;EI;

    if(!ign)
       {
        if(!Zeroj)
        {
         Zapal_SD;
         read_n_sec_x(0x6000);
         Zgas_SD;
    
         Sec_g = Sec_g + 16;
         Sec_c = Sec_c + 16;
         if(Sec_c == SecPerClusL)
         {
          Klaster = GFAT0(Klaster);
          Sec_c = 0;
          secl = DATA_0 + (((unsigned long)Klaster - (unsigned long)2) * (unsigned long)SecPerClusL);
         }
         else
          secl = secl + 16;
         sech = secl + 15;
        }
        else
        {
         for(fff=0x6000;fff<=0x7FFF;fff++)
          Tab_8[fff] = 0;
         Zeroj++;
         Mp3_P = 1;
        }
       }
    else
       ign--;

    //DI;i2s_b |= 0x0004;EI;
    piszc(8);
    gotoxy(24,1);
    mdc = 'e'; // mdc ^= 0x01;
    piszc(mdc); // piszc('I'); //2
   }

   klx = KlawX();
   if((klx == 0x1B)||(klx == 0x0D))
   {
    Mp3_P = 1;   
    gotoxy(24,1);
    piszc('<');
    break;
   }
   if((klx == '+')||(klx == '-'))
       {
        DI;
        EPM_WM_SCK(1);
        Set_Vol_Spk(klx);
        EPM_MP3_SCK(1);
        EI;
       }
   klx = 0;

   // Display_Freq(19,2);
  }

  Mp3_P = 1;
  Display_Freq(19,2);

  delayx(0x0002FFFF);

// Fade Out
  for(fff = STA015_ATT; fff >= 0x30; fff++)
    {
          i2c_write_STA015(0x46, fff);  // DLA ATT
          i2c_write_STA015(0x48, fff);  // DRA ATT
          delayx(0x0000009F); // 5000
    }

  i2c_write_STA015(0x46, 64);  // DLA ATT
  i2c_write_STA015(0x48, 64);  // DRA ATT

  for(fff=0x2000;fff<0x8000;fff++)
   Tab_8[fff] = 0;

//  for(f=6143;f>=0;f--)
//   Buf_I2S_32[f] = 0xFFFF0000;

//  delayx(0x0002FFFF);

  Mp3_P = 0;
  BIT_EN_0;
  Record = 0; // Odblokuj ADC L R

  delayx(0x00002000);

  EPM_WM_SCK(1);
  Timer_M = 100;
  MUTE_On();

  i2c_write_STA015(0x13, 0x01);  // PLAY
  i2c_write_STA015(0x14, 0x00);  // MUTE

  i2c_write_STA015(0x72, 0x00);  // RUN_MODE

  gotoxy(1,2);
  piszs(" STA015 STOP ");

  MP3_STOP();

  write_WM8770(0x16, 0x001); // Interface ctrl: 001 - L Just, L,R; 005 - L Just, R,L

  if(DSP_En)
      DSP_On();

  /*piszs(" x=");piszhex(i2s_x);
  piszs(" y=");piszhex(i2s_y);
  piszs(" o=");piszhex(i2s_o);
  piszs(" SEC=");piszhex(sech + 1);*/

//  WM_IN = WM_INB;
//  WM_OUT_MX = WM_OUT_MXB;
//  x1l = WM_IN << 4;
//  x1l = x1l | WM_IN;
//  write_WM8770(0x1B, x1l); // LMX(2,1,0); RMX(6,5,4)
//  WM_Out_Mix(WM_OUT_MX, WM_OUT_MX, WM_OUT_MX, WM_OUT_MX); // 1-DAC, 2-Bypass/DAC, 5-AUX/DAC, 7-Bypass/AUX/DAC
 }
 else
  return 1;

 return 0;
}
// ---------------------------------------------------------------------------------

int Delta_ALFreq(void)
{
int l_x;
     l_x = abs(ALFreq - ALFreq_h);
     ALFreq_h = ALFreq;
return l_x;
}
// ---------------------------------------------------------------------------------

void MP3_SRART(int MP_Freq)
{
  CTRL1B = CTRL1;
  CTRL2B = CTRL2;
  CTRL3B = CTRL3;

  if(DDAdr)
      {
      if(MODE_DIG > 1)
         {
          
          Set_PLL2PCM(0, 2); // DDPCMCLK - wyscie z EPM3064 !
          //STA_PLL_in(0, 2); // DDPCMCLK - wyscie z EPM3064 !
    
          act_decoder = 0;
          STA_write(0x4C, 0x03);
          STA_write(0x4D, 0x03);
    
          if(MP_Freq == 44100)     // 44100, 48000, 32000
              STA_write(0x05,1);    // SFREQ: 0-48, 1-44.1, 2-32, 4-96, 5-88.2 [kHz]
          else
              STA_write(0x05,0);    // SFREQ: 0-48, 1-44.1, 2-32, 4-96, 5-88.2 [kHz]
    
          STA_PLL_in(0, 2); // DDPCMCLK - wyscie z EPM3064 !
    
          if(!MP3Freq)              // 0x00 -> 44100, 0x04 -> 48000, 0x08 -> 32000
              STA_write(0x05,1);    // SFREQ: 0-48, 1-44.1, 2-32, 4-96, 5-88.2 [kHz]
          else
              STA_write(0x05,0);    // SFREQ: 0-48, 1-44.1, 2-32, 4-96, 5-88.2 [kHz]
    
          act_decoder = 0;
          STA_write(0x4C, 0x03);
          STA_write(0x4D, 0x03);
    
          delayx(0x00012345);
    
          CircleSurr();
          VCROut();
          piszs("*CSurr*");
          piszs("SIN_1");
          // STA_Restart(2);
    
          /*CTRL1 = CTRL1_GRAJ_MP3_DD; // CTRL1_GRAJ_MP3 0x43
          LD_Latch_n(CTRL1, 1);
        
          CTRL2 = CTRL2_GRAJ_MP3_DD; // CTRL2_GRAJ_MP3 0x45
          LD_Latch_n(CTRL2, 2);
        
          CTRL3 = CTRL3_GRAJ_MP3_DD; // CTRL3_GRAJ_MP3 0x58
          LD_Latch_n(CTRL3, 3);*/
          MUX123 = MUX123_GRAJ_MP3_DD;
          MUX45 = MUX45_GRAJ_MP3_DD; 
          Konfiguracja();
         }
      else
         {
          /*CTRL1 = CTRL1_GRAJ_MP3; // CTRL1_GRAJ_MP3 0x43
          LD_Latch_n(CTRL1, 1);
    
          CTRL2 = CTRL2_GRAJ_MP3; // CTRL2_GRAJ_MP3 0x45
          LD_Latch_n(CTRL2, 2);
    
          CTRL3 = CTRL3_GRAJ_MP3; // CTRL3_GRAJ_MP3 0x58
          LD_Latch_n(CTRL3, 3); */
          MUX123 = MUX123_GRAJ_MP3;
          MUX45 = MUX45_GRAJ_MP3; 
          Konfiguracja();
         }
      }
  else
    {
      MUX123 = MUX123_GRAJ_MP3;
      MUX45 = MUX45_GRAJ_MP3; 
      Konfiguracja();
    }
}
// ----------------------------------------------------------------------

void MP3_STOP(void)
{
  CTRL1 = CTRL1B;
  LD_Latch_n(CTRL1, 1);

  CTRL2 = CTRL2B;
  LD_Latch_n(CTRL2, 2);

  CTRL3 = CTRL3B;
  LD_Latch_n(CTRL3, 3);

  if(DDAdr & (MODE_DIG > 1))
     {
    
      if(SPDIF)
      {    
          STA_PLL_in(1, 1); // (1, 1); (1, 0)
          //STA_Restart(1);
          piszs("SPDIF");
      }
      else
      {
          STA_write(0x05,CTRL3&0x01); // SFREQ: 0-48, 1-44.1, 2-32, 4-96, 5-88.2 [kHz]
          Set_PLL2PCM(0, 2);
          // STA_PLL_in(0, 0);
          act_decoder = 0;
          STA_write(0x4C, 0x03);
          STA_write(0x4D, 0x03);
          STA_write(0x05,CTRL3&0x01); // SFREQ: 0-48, 1-44.1, 2-32, 4-96, 5-88.2 [kHz]
          CircleSurr();
          VCROut();
          piszs("*CSurr*");
          piszs("SIN1");
      }
     }

}
// ---------------------------------------------------------------------------------

int Set_IN7(void)
{   
     if(!Input_BS)
        {
         Input_B = Input;
         Input_BS++;
         MODE_DIG_B = MODE_DIG;
        }
     Input &= 0x0030;
     Input |= 0x0007;
     WM_IN = 0x07;
     if(MODE_DIG == 0x02) // DDD
         MODE_DIG = 1; // DAA
     else
         MODE_DIG = 0; // AAA
     SPDIF = 0;
     // Set_MODE_DIG();
     Set_Input_q();
     // Set_MODE_DIG();
return Input;
}
// ---------------------------------------------------------------------------------

int Restore_IN(void)
{
    Input = Input_B;
    MODE_DIG = MODE_DIG_B;
    Input_BS = 0;

    WM_IN = Input & 0x0007;

    if(Input & 0x00000008)
       SPDIF = 1;
    else
       SPDIF = 0;
    // Set_MODE_DIG();
    Set_Input_q();
    // Set_MODE_DIG();
return Input;
}
// ---------------------------------------------------------------------------------

void Display_Freq(char x, char y)
{
int frq;
                ECHO_Off;
                gotoxy(x,y);
                piszs("@");
                frq = ALFreq;
                if(frq < 99999)
                    piszdec(frq, 5);
                else
                {
                    piszdec(frq/1000, 3);
                    piszs("k!");
                }
                LCD_X;
}
// ---------------------------------------------------------------------------------

// Odczyt pliku ( pierwsze 32 sektory ) --------------------------------------------
unsigned long Get_File(short Index)
{
short Indexb, f, m;
char a0, a1, a2, a3, a4;
unsigned long Sec_t, Bayt_t, mx; 

 piszs("\010\n\r");
 gotoxy(1,1);
 piszs("Rd_File:");

 Get_Name(name32, Index);
 strncpy(zs, name32, 8);
 zs[8]='.';
 zs[9]=name32[8];
 zs[10]=name32[9];
 zs[11]=name32[10];
 piszs(zs);

 Klaster = Tab_Klaster(Index);
 Rozmiar_Pliku = Tab_Rozmiar(Index);
 Indexb = Tab_Indexb(Index);

 Bayt_t = Rozmiar_Pliku;
 Sec_t = Bayt_t >> 9;
 mx = Rozmiar_Pliku / 12; // linii

 Get_32_SEC(Klaster);
 
// AL3102 DSP ================================================================================================
 while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
 al_write(0x400, 0x07); // Word 0
 delayx(0x07FF);
 while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
 al_write(0x401, 0x02); // Word 1

 Buf_zs[2]=0;
 m = 0;

 for(f = 0; f < Rozmiar_Pliku; f = f + 12)
 {
  Buf_zs[0] = Buf_8_2k[f];
  Buf_zs[1] = Buf_8_2k[f+1];
  a0 = asciih2bin(Buf_zs);
  Tab_8[0xE000 + (m*8)] = a0;
  Buf_zs[0] = Buf_8_2k[f+2];
  Buf_zs[1] = Buf_8_2k[f+3];
  a1 = asciih2bin(Buf_zs);
  Tab_8[0xE000 + (m*8) + 1] = a1;
  Buf_zs[0] = Buf_8_2k[f+4];
  Buf_zs[1] = Buf_8_2k[f+5];
  a2 = asciih2bin(Buf_zs);
  Tab_8[0xE000 + (m*8) + 2] = a2;
  Buf_zs[0] = Buf_8_2k[f+6];
  Buf_zs[1] = Buf_8_2k[f+7];
  a3 = asciih2bin(Buf_zs);
  Tab_8[0xE000 + (m*8) + 3] = a3;
  Buf_zs[0] = Buf_8_2k[f+8];
  Buf_zs[1] = Buf_8_2k[f+9];
  a4 = asciih2bin(Buf_zs);
  Tab_8[0xE000 + (m*8) + 4] = a4;
  // [f+10]=0x0D, [f+11]=0x0A
  if(m < 1024)
   {
     while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
     if(m <= mx)
       al_write_5(m, a0, a1, a2, a3, a4);
     else
       {
        al_write_5(m, 0, 0, 0, 0, 0);
        Tab_8[0xE000 + (m*8)] = 0;
        Tab_8[0xE000 + (m*8) + 1] = 0;
        Tab_8[0xE000 + (m*8) + 2] = 0;
        Tab_8[0xE000 + (m*8) + 3] = 0;
        Tab_8[0xE000 + (m*8) + 4] = 0;
       }
   }
  else
    break;
  m++;
 }

 if(mx < 1024)
   {
    for(m = mx; m < 1024; m++)
      {
       while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
       al_write_5(m, 0, 0, 0, 0, 0);
      }
   }

 while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
 al_write(0x400, 0x7F); // Word 0
 delayx(0x07FF);
 while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
 al_write(0x401, 0x02); // Word 1

 delayx(0x0003FFFF);

 return Bayt_t;
}
// ---------------------------------------------------------------------------------

// AL3102 DSP - Laduje program od adresu 0x2000 =============================================================
int Load_AL(int linii)
{
short f, m;
char a0, a1, a2, a3, a4;
int mx; 

 while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
 al_write(0x400, 0x07); // Word 0
 delayx(0x07FF);
 while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
 al_write(0x401, 0x02); // Word 1

 Buf_zs[2]=0;
 m = 0;
 mx = linii;

 for(f = 0; f < 1024; f = f + 5)
 {
  a0 = Buf_8_2k[f];
  Tab_8[0xE000 + (m*8)] = a0;
  a1 = Buf_8_2k[f+1];
  Tab_8[0xE000 + (m*8) + 1] = a1;
  a2 = Buf_8_2k[f+2];
  Tab_8[0xE000 + (m*8) + 2] = a2;
  a3 = Buf_8_2k[f+3];
  Tab_8[0xE000 + (m*8) + 3] = a3;
  a4 = Buf_8_2k[f+4];
  Tab_8[0xE000 + (m*8) + 4] = a4;
  // [f+10]=0x0D, [f+11]=0x0A
  if(m < 1024)
   {
     while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
     if(m <= mx)
       al_write_5(m, a0, a1, a2, a3, a4);
     else
       al_write_5(m, 0, 0, 0, 0, 0);
   }
  else
    break;
  m++;
 }
 
 if(mx < 1024)
   {
    for(m = mx; m < 1024; m++)
      {
       while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
       al_write_5(m, 0, 0, 0, 0, 0);
       Tab_8[0xE000 + (m*8)] = 0;
       Tab_8[0xE000 + (m*8) + 1] = 0;
       Tab_8[0xE000 + (m*8) + 2] = 0;
       Tab_8[0xE000 + (m*8) + 3] = 0;
       Tab_8[0xE000 + (m*8) + 4] = 0;
      }
   }

 while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
 al_write(0x400, 0x7F); // Word 0
 delayx(0x07FF);
 while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
 al_write(0x401, 0x02); // Word 1

 return mx;
}
// ---------------------------------------------------------------------------------

// AL3102 DSP - Laduje program od adresu 0xE000 =============================================================
int Load_AL_Exxx(void)
{
short f, m;
char a0, a1, a2, a3, a4;

 //while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
 //al_write(0x400, 0x07); // Word 0
 //delayx(0x07FF);
 //while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
 //al_write(0x401, 0x02); // Word 1

 //Buf_zs[2]=0;
 m = 0;

 for(f = 0; f < 1024; f = f + 5)
 {
  a0 = Tab_8[0xE000 + (m*8)];
  a1 = Tab_8[0xE000 + (m*8) + 1];
  a2 = Tab_8[0xE000 + (m*8) + 2];
  a3 = Tab_8[0xE000 + (m*8) + 3];
  a4 = Tab_8[0xE000 + (m*8) + 4];
  while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
  al_write_5(m, a0, a1, a2, a3, a4);
  m++;
 }
 
 while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
 al_write(0x400, 0x7F); // Word 0
 delayx(0x07FF);
 while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
 al_write(0x401, 0x02); // Word 1

 return m;
}
// ---------------------------------------------------------------------------------

// AL3102 DSP Laduje program z FLASH ============================================================================
int Load_AL_FL(int linii)
{
short f;
int xx; 

  //gotoxy(1,2);
  //piszs("DSP_73 Load..");

  xx = 0xE000;
  while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
  al_write(0x400, 0x07); // Word 0
  delayx(0x0FFF);
  while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
  al_write(0x401, 0x02); // Word 1
  delayx(0x0FFF);
  for(f=0; f<1024; f++)
  {
    if(f < linii)
    {
      while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
      al_write_5(f, AL_73[f][0], AL_73[f][1], AL_73[f][2], AL_73[f][3], AL_73[f][4]);
      Tab_8[xx] = AL_73[f][0];
      xx++;
        Tab_8[xx] = AL_73[f][1];
        xx++;
          Tab_8[xx] = AL_73[f][2];
          xx++;
            Tab_8[xx] = AL_73[f][3];
            xx++;
              Tab_8[xx] = AL_73[f][4];
              xx++;
    }
    else
    {
      while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
      al_write_5(f, 0, 0, 0, 0, 0);
      xx++;
        Tab_8[xx] = 0;
        xx++;
          Tab_8[xx] = 0;
          xx++;
            Tab_8[xx] = 0;
            xx++;
              Tab_8[xx] = 0;
              xx++;
    }
    xx += 3; // co 8 bajtow
  }
  while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
  al_write(0x400, 0x7F); // Word 0
  delayx(0x0FFF);
  while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
  al_write(0x401, 0x02); // Word 1

  //piszs("OK ");

  return linii;
 }
// ---------------------------------------------------------------------------------

// RD n bajtow z VDIP --------------------------------------------------------------
unsigned long RD_n_VDIP(unsigned long bajtow, unsigned long pocz)
{
unsigned long xxx, fff;
  WR_VDIP(0x0B); // RDF
  WR_VDIP(0x20);
  xxx = bajtow >> 24; // MSB
  WR_VDIP(xxx & 0x00FF);
  xxx = bajtow >> 16;
  WR_VDIP(xxx & 0x00FF);
  xxx = bajtow >> 8;
  WR_VDIP(xxx & 0x00FF);
  xxx = bajtow & 0x000000FF;
  WR_VDIP(xxx);
  WR_VDIP(0x0D);
  Timer_1 = 1000;
  for(fff = 0; fff<bajtow; fff++)
      {
       Tab_8[pocz + fff] = GC_VDIP();
       if(!Timer_1)
           break;
      }
  if(Timer_1)
   while(RD_VDIP() != 0x0D); // Czekaj na CR
  return fff;
}
// ---------------------------------------------------------------------------------

// RD n bajtow z VDIP --------------------------------------------------------------
unsigned long SEEK_VDIP(unsigned long pocz)
{
unsigned long xxx;
  WR_VDIP(0x28); // RDF
  WR_VDIP(0x20);
  xxx = pocz >> 24; // MSB
  WR_VDIP(xxx & 0x00FF);
  xxx = pocz >> 16;
  WR_VDIP(xxx & 0x00FF);
  xxx = pocz >> 8;
  WR_VDIP(xxx & 0x00FF);
  xxx = pocz & 0x000000FF;
  WR_VDIP(xxx);
  WR_VDIP(0x0D);
  while(RD_VDIP() != 0x0D); // Czekaj na CR
  return pocz;
}
// ---------------------------------------------------------------------------------

// Audio Graj MP3 z Pendriv'a ------------------------------------------------------
unsigned long Graj_MP3_P(unsigned long rpm)
{
unsigned short Zeroj, mdc, fade, ign;// x1l;
unsigned long Bayt_t, Bayt_g, Bayt_r, xxx, fff, xsh, fsh, prgs, framesm;
short klx; 

 Zeroj = 0;
 mdc = 'v';
 prgs = 12345;
 fade = 0;
 ign = 0;

 piszs("\n\r");
 gotoxy(1,1);
 piszs("PLY:");

 Get_NameP(name32);
 piszs(name32);

 Bayt_t = rpm;
 Bayt_g = 0;
 Bayt_r = 0;

 if(rpm > 57344) // 24576
 {
  i2c_write_STA015(0x46, 96);  // DLA ATT
  i2c_write_STA015(0x48, 96);  // DRA ATT

  Record = 1; // Blokada ADC L R
  Unmute_F = 0; 

  RD_n_VDIP(24576, 0x2000);
  Bayt_g = 24576;
  SEEK_VDIP(Bayt_g);
  Bayt_r = Bayt_t - Bayt_g;

  i2s_x=0; // 0
  i2s_y=0; // 0, 0x4000 / 4
  i2s_o=0; // 0
  i2s_b=7; // 7

// MP3Freq ------------------------------- okresl czestotliwosc MP3Freq--------------------------------
  MP3TAG = 0;  // 0 - TAGv1, 1 - TAGv2
  MP3Freq = 0; // 0x00 - 44100, 0x04 - 48000, 0x08 - 32000
  if((Tab_8[0x2000]=='I')&&(Tab_8[0x2001]=='D')&&(Tab_8[0x2002]=='3'))
      {
        MP3TAG = 1;
        // szukamy 62 bajtow 0x00, 0xFF, 0xFB lub 0xFA
        xsh = 0;
        for(fsh = 0x2300; fsh < 0x2FFF; fsh++)
            {
                if(!Tab_8[fsh])
                    xsh++;
                else
                    break;
                 
            }
        if((xsh > 61)&&(Tab_8[0x2300+xsh]==0xFF)&&((Tab_8[0x2301+xsh]|0x01)==0xFB))
            MP3Freq = Tab_8[0x2302+xsh] & 0x0C;
      }
  if((Tab_8[0x2000]==0xFF)&&((Tab_8[0x2001]|0x01)==0xFB))
        MP3Freq = Tab_8[0x2002] & 0x0C;

  gotoxy(2,1);
  switch(MP3Freq)
      {
      case 0x00    : piszs("44");
          MP_Freq = 44100;
          break;
      case 0x04    : piszs("48");
          MP_Freq = 48000;
          break;
      case 0x08    : piszs("32");
          MP_Freq = 32000;
          break;
      }

  // Odczyt TAG'ow
  xsh = 0;
  if(MP3TAG)
    {
     // Szukam tytul: TIT2 00 00 00 x 00 00 00 t y t u l
     // Szuknie artysty: TPE1 00 00 00 x 00 00 00 artysta
     for(fsh = 0x2003; fsh < 0x2300; fsh++)
       {
        if((Tab_8[fsh]==0x54)&&(Tab_8[fsh+1]==0x49)&&(Tab_8[fsh+2]==0x54)&&(Tab_8[fsh+3]==0x32))
          {
           xsh = Tab_8[fsh+7];
           if(xsh > 2)
             xsh--; // xsh = ilosc znakow - 1
           if(xsh < 64)
             {
              xsh = 0;
              for(fff = fsh + 11; fff < fsh + 35; fff++)
                {
                  Buf_zs[xsh] = Tab_8[fff];
                  xsh++;
                  Buf_zs[xsh] = 0x00; // maksymalnie 24 znaki
                  if(xsh == Tab_8[fsh+7]) // ostatni znak
                    break;
                }
              gotoxy(8,1);
              piszc('/');
              for(fff = 0; fff < 8; fff++)
                piszc(Buf_zs[fff]);
              break;
             }
          }
       }

    }

  // -----------------------------------------------------------------------------------------------------

/*  WM_INB = WM_IN;
  WM_OUT_MXB = WM_OUT_MX;
  WM_IN = 7;
  WM_OUT_MX = 1; // DAC1,2,3,4
  write_WM8770(0x1B, 0x77); // LMX(2,1,0); RMX(6,5,4)
  WM_Out_Mix(WM_OUT_MX, WM_OUT_MX, WM_OUT_MX, WM_OUT_MX); // 1-DAC, 2-Bypass/DAC, 5-AUX/DAC, 7-Bypass/AUX/DAC
*/
  i2c_write_STA015(0x46, 64);  // DLA ATT
  i2c_write_STA015(0x48, 64);  // DRA ATT

  DSP_Off();
  MUTE_Off();

  MP3_SRART(MP_Freq);

  write_WM8770(0x16, 0x005); // Interface ctrl: 001 - L Just, L,R; 005 - L Just, R,L

  EPM_MP3_SCK(1);

  BIT_EN_1;
  i2c_write_STA015(0x72, 0x01);  // RUN_MODE

//  piszs(" STA015_RUN ");
	
  //CTRL1 &= 0x7F;
  //CTRL1 |= 0x40;
  //LD_Latch_n(CTRL1, 1);

  while((IOPIN1 & 0x00000010)==0);

  Mp3_P = 3;
  if(Bayt_t > 320000)
      framesm = Frames + 67;
  else
      framesm = Frames + 34;

  Display_Freq(19,2);

  xxx = i2s_o;

  gotoxy(18,2);
  piszs("  000% ");

  gotoxy(24,1);
  piszc(mdc);

  while(1)
  {
   if(xxx != i2s_o)
    xxx = i2s_o;

   if(Bayt_g >= Bayt_t)
   {
    if(Zeroj >= 2)
     break;
    if(!Zeroj)
    {
     delayx(0x00002000); // 4000
     Zeroj++;
    }
   }
// Progres =========================================================
   ECHO_Off;
   if(prgs!=Progres(Bayt_t , Bayt_g))
       {
        prgs = Progres(Bayt_t , Bayt_g);
        gotoxy(20,2);
        piszdec( prgs , 3);
       }
   LCD_X;
   if(Bayt_g >= 112640) // 57344
       Mp3_P = 2;

// Fade In
    if((!fade) && (Frames > framesm))
      {
      for(fff = 0x0030;fff >= STA015_ATT;fff--)
        {
          i2c_write_STA015(0x46, fff);  // DLA ATT
          i2c_write_STA015(0x48, fff);  // DRA ATT
          delayx(0x0000009F); // 5000
        }
       fade++;
      }

   if(i2s_b & 0x0100)
   {
    while(i2s_b & 0x0001); //delayx(0x00003210); // 3210
    DI;i2s_b &= 0x0E0E;EI;

    if(!ign)
       {
        if(!Zeroj)
        {
         if(Bayt_t > Bayt_g)
             Bayt_r = Bayt_t - Bayt_g;
         if(Bayt_r > 8192)
             {
              RD_n_VDIP(8192, 0x2000);
              Bayt_g += 8192;
              SEEK_VDIP(Bayt_g);
             }
         else
             {
              for(fff=0x2000+Bayt_r;fff<0x4000;fff++)
               Tab_8[fff] = 0;
              Zeroj++;
              RD_n_VDIP(Bayt_r, 0x2000);
              Bayt_g = Bayt_t;
             }
        }
        else
        {
         for(fff=0x2000;fff<0x4000;fff++)
          Tab_8[fff] = 0;
         Zeroj++;
         Mp3_P = 1;
        }
       }
    else
       ign--;

    //DI;i2s_b |= 0x0001;EI;
    piszc(8);
    gotoxy(24,1);
    mdc = 's'; // mdc ^= 0x01;
    piszc(mdc); //piszc('-'); //1
   }

   if(Bayt_g >= Bayt_t)
   {
    if(Zeroj >= 2)
     break;
    if(!Zeroj)
    {
     delayx(0x00002000);
     Zeroj++;
     Mp3_P = 1;
    }
   }

   if(i2s_b & 0x0200)
   {
    while(i2s_b & 0x0002); //delayx(0x00003210); // 3210
    DI;i2s_b &= 0x0D0D;EI;

    if(!ign)
       {
        if(!Zeroj)
        {
            if(Bayt_t > Bayt_g)
                Bayt_r = Bayt_t - Bayt_g;
            if(Bayt_r > 8192)
                {
                 RD_n_VDIP(8192, 0x4000);
                 Bayt_g += 8192;
                 SEEK_VDIP(Bayt_g);
                }
            else
                {
                 for(fff=0x4000+Bayt_r;fff<0x6000;fff++)
                  Tab_8[fff] = 0;
                 Zeroj++;
                 RD_n_VDIP(Bayt_r, 0x4000);
                 Bayt_g = Bayt_t;
                }
        }
        else
        {
         for(fff=0x4000;fff<0x6000;fff++)
          Tab_8[fff] = 0;
         Zeroj++;
         Mp3_P = 1;
        }
       }
    else
       ign--;

    //DI;i2s_b |= 0x0002;EI;
    piszc(8);
    gotoxy(24,1);
    mdc = 'o'; // mdc ^= 0x01;
    piszc(mdc); // piszc('I'); //2
   }

   if(i2s_b & 0x0400)
   {
    while(i2s_b & 0x0004); //delayx(0x00003210); // 3210
    DI;i2s_b &= 0x0B0B;EI;

    if(!ign)
       {
        if(!Zeroj)
        {
            if(Bayt_t > Bayt_g)
                Bayt_r = Bayt_t - Bayt_g;
            if(Bayt_r > 8192)
                {
                 RD_n_VDIP(8192, 0x6000);
                 Bayt_g += 8192;
                 SEEK_VDIP(Bayt_g);
                }
            else
                {
                 for(fff=0x6000+Bayt_r;fff<0x8000;fff++)
                  Tab_8[fff] = 0;
                 Zeroj++;
                 RD_n_VDIP(Bayt_r, 0x6000);
                 Bayt_g = Bayt_t;
                }
        }
        else
        {
         for(fff=0x6000;fff<0x8000;fff++)
          Tab_8[fff] = 0;
         Zeroj++;
         Mp3_P = 1;
        }
       }
    else
       ign--;

    //DI;i2s_b |= 0x0004;EI;
    piszc(8);
    gotoxy(24,1);
    mdc = 'z'; // mdc ^= 0x01;
    piszc(mdc); // piszc('X'); //3
   }

   klx = KlawX();
   if((klx == 0x1B)||(klx == 0x0D))
   {
    Mp3_P  = 1;
    gotoxy(24,1);
    piszc('<');
    break;
   }
   if((klx == '+')||(klx == '-'))
       {
        DI;
        EPM_WM_SCK(1);
        Set_Vol_SPK(klx);
        EPM_MP3_SCK(1);
        EI;
       }
   klx = 0;
   // Display_Freq(19,2);
  }

  Mp3_P = 1;
  Display_Freq(19,2);

  delayx(0x0002FFFF);

// Fade Out
  for(fff = STA015_ATT; fff >= 0x30; fff++)
    {
          i2c_write_STA015(0x46, fff);  // DLA ATT
          i2c_write_STA015(0x48, fff);  // DRA ATT
          delayx(0x0000009F); // 5000
    }

  i2c_write_STA015(0x46, 64);  // DLA ATT
  i2c_write_STA015(0x48, 64);  // DRA ATT

  for(fff=0x2000;fff<0x8000;fff++)
   Tab_8[fff] = 0;

//  for(f=6143;f>=0;f--)
//   Buf_I2S_32[f] = 0xFFFF0000;

  delayx(0x00002000);

  Mp3_P = 0;
  BIT_EN_0;
  Record = 0; // Odblokuj ADC L R

  delayx(0x00001000); // 4000

  EPM_WM_SCK(1);
  Timer_M = 100;
  MUTE_On();

  i2c_write_STA015(0x13, 0x01);  // PLAY
  i2c_write_STA015(0x14, 0x00);  // MUTE

  i2c_write_STA015(0x72, 0x00);  // RUN_MODE

  gotoxy(1,2);
  piszs(" STA015 STOP ");

  MP3_STOP();

  write_WM8770(0x16, 0x001); // Interface ctrl: 001 - L Just, L,R; 005 - L Just, R,L

  i2c_write_STA015(0x46, STA015_ATT);  // DLA ATT
  i2c_write_STA015(0x48, STA015_ATT);  // DRA ATT

  if(DSP_En)
    DSP_On();

  /*piszs(" x=");piszhex(i2s_x);
  piszs(" y=");piszhex(i2s_y);
  piszs(" o=");piszhex(i2s_o);
  piszs(" SEC=");piszhex(sech + 1);*/

//  WM_IN = WM_INB;
//  WM_OUT_MX = WM_OUT_MXB;
//  x1l = WM_IN << 4;
//  x1l = x1l | WM_IN;
//  write_WM8770(0x1B, x1l); // LMX(2,1,0); RMX(6,5,4)
//  WM_Out_Mix(WM_OUT_MX, WM_OUT_MX, WM_OUT_MX, WM_OUT_MX); // 0-DAC, 1-Bypass/DAC, 2-AUX/DAC, 3-Bypass/AUX/DAC
 }
 else
  return 1;

 return 0;
}
// ---------------------------------------------------------------------------------

// Szukaj Nazwy 8.3
unsigned short SzukajNazwy(char szukanan[])
{
unsigned short x123, f123;
char ls[14];
x123 = 0;
 for(f123 = 0; f123 < LastDirEnt; f123++)
 {
  RD_SRAM(f123<<5, (void*)DIR0);
  memcpy(ls, (void*)DIR0, 11);
  ls[11] = 0;
  if(!memcmp(ls, szukanan, 11))
  {
   x123 = 1;
   break;
  }
 }
 return(x123);
}
// ----------------------------------------------------------------------------

// Nagrywanie - REC..
void Nagrywanie(void) // Rec...
{
 unsigned long rpl, x1f, x2f, x3f, x4f, odejm, pozost;
 unsigned short NRNazwy, XClusf, NewClusf, xlf, ixf, Rolowanie;

 Rolowanie = 0;
 Rozmiar_REC = 0;
 RecRoll = 0;
 
// ZAPAL LED'y

// gotoxy(13,1);
 if(Stat_REC < 8)
  piszs(" ADC: ");
 else
  piszs(" DIR: "); 

 odejm = SecPerClusL << 9;
 pozost = 0;

 NRNazwy = 1;
 ixf = Get_Index();
 if(ixf < LastDirEnt)
 {
  strcpy(zs, "MUSIC");
  x4f = 1;
  while(x4f)
  {
	x1f = bin2bcd(NRNazwy);
     x2f = ((x1f >> 4) & 0x0F) + 0x30;
     x1f = (x1f & 0x0F) + 0x30;
     x3f = bin2bcd(NRNazwy>>8);
     x3f = (x3f & 0x0F) + 0x30;
     zs[5] = x3f;
     zs[6] = x2f;
     zs[7] = x1f;
     zs[8] = 0;
     strcat(zs, "WAV");
	x4f = SzukajNazwy(zs);
	NRNazwy++;
  }
//  gotoxy(1,1);
  zs[8] ='.';
  zs[9] ='W';
  zs[10]='A';
  zs[11]='V';
  zs[12]= 0;
  piszs(zs);

// Test
  piszs(" i:");
  piszdec(ixf,0);

  if(RecLoop)
      Rec_Audio(); // < ================================================== REC_AUDIO (Rec... )
 else
     Rec_Audio_X(); // < ================================================== REC_AUDIO (Rec... )

// gotoxy(13,1);
  piszs("*STOP*");

  pozost = Rozmiar_REC;

  if(Nagrane)
  {
   if(RecLoop)
   {
    if(RecRoll)
    {
     Rolowanie = 2;
//	 gotoxy(13,1);
     piszs(" ROLL ");
    }
   }
  }

  FATZmod = 0;

  }
  else
  {
   piszs("*Brak miejsca w kat.*");
  }

  if(Rozmiar_REC)
  {
   NRNazwy = 1;

   ixf = Get_Index();

   if(ixf < LastDirEnt)
   {
    // gotoxy(13,1);
    piszs("*SAVE*");
    
    strcpy(zs, "MUSIC");

    x4f = 1;
    while(x4f)
	{
	 x1f = bin2bcd(NRNazwy);
      x2f = ((x1f >> 4) & 0x0F) + 0x30;
      x1f = (x1f & 0x0F) + 0x30;
      x3f = bin2bcd(NRNazwy>>8);
      x3f = (x3f & 0x0F) + 0x30;
      zs[5] = x3f;
      zs[6] = x2f;
      zs[7] = x1f;
      zs[8] = 0;
      strcat(zs, "WAV");
	 x4f = SzukajNazwy(zs);
	 NRNazwy++;
	}

// Test
    piszs(" i:");
    piszdec(ixf,0);
// Test
    piszs(" R:");
    piszdec(Rozmiar_Pliku,0);

    INDEXB = ixf;    

    Indexow = Indexow + 1;
    Plikow = Plikow + 1;

// Korekta trzaskw z ostatniego okna
//    if(Rozmiar_REC > (8192+48))
//	 Rozmiar_REC = Rozmiar_REC - 8192;  

    memcpy(Kat_Pliku.Name, zs ,8);
    memcpy(Name8, zs ,8);
    Name8[8]=0x00;
    memcpy(Kat_Pliku.Ext, "WAV", 3);
    memcpy(Ext3, "WAV", 3);
    Ext3[3]=0x00;
    Kat_Pliku.Rozmiar = Rozmiar_REC;
    Kat_Pliku.Atrybuty = 0x20;

//    XClusf = GetFreeFAT(2);
    if(RecLoop && RecRoll)
	 XClusf = Clus_N_Buf;
	else
	 XClusf = Clus_0_Buf; // Clus_0_File
	 
	Kat_Pliku.Klaster = XClusf;
	Kat_Pliku.Czas = 0x20 + (sekundy<<5) + sekundy ;// GetTimeF();
	Kat_Pliku.Data = 0x5C21;// GetDateF();

	memcpy(DIR0, &Kat_Pliku, 32); //(ixf<<5) DIR_R
     WR_SRAM(INDEXB<<5, DIR0);

// Test ----------------------------------------------------------------------------
     piszs("*INDEXB=");piszdec(INDEXB,0);
     piszs("*Zaps?(T/N)");
     if(getch() == 'T')
     {

	if(DIR_DOT)
	 Write_dot_DIR(INDEXB);
	else
	 Write_root_DIR(INDEXB);
// Naglowek WAVE
     Get_1_SEC(XClusf);
	Header_WAVE.RIFF = 0x46464952;
	Header_WAVE.File_long_sub_8 = Rozmiar_REC - 8;
	Header_WAVE.WAVE = 0x45564157;
	Header_WAVE.ID = 0x20746D66;
	Header_WAVE.Extra_format = 0x10;
	Header_WAVE.Compression = 0x0001;
	Header_WAVE.Chanels = 2; // Stereo_Mono + 1
	Header_WAVE.Sample_rate = (unsigned long)Sample_R;
	Header_WAVE.Bytes_per_second = (((long)Sample_R << 1)*2); // Stereo_Mono + 1L
	Header_WAVE.Bytes_per_sample = 2 << 1; // Stereo_Mono + 1
	Header_WAVE.Bits_per_sample = 0x10;
	Header_WAVE.DATA_WAVE = 0x61746164;
	Header_WAVE.File_lenght_sub_44 = Rozmiar_REC - 44;
     ch_ptr = Buf_8;
     memcpy(ch_ptr, &Header_WAVE, 44);
	Put_1_SEC(XClusf);

	FATZmod = 1;
	rpl = (Rozmiar_REC>>9) / (unsigned long)SecPerClusL;

     if(!Rolowanie)
      for(xlf = 0; xlf <= rpl; xlf++)
	 {
        NewClusf = GetFreeFAT(XClusf+1);
        if(NewClusf>1)
        {
         if(pozost <= odejm)
         {
          SetFAT(XClusf, 0xFFFF);
          pozost = 0;
          break;
         }
         else 
         {
          SetFAT(XClusf, NewClusf);
          pozost -= odejm;
          XClusf = NewClusf;
         }
        } 
      }  // !Rolowanie

// ---------------------------------------------------
     if(Rolowanie)
     {
// ===================================================================
	for(xlf = 0; xlf <= rpl; xlf++)
	{
	 if(xlf == rpl)
	 {
	  SetFAT(XClusf, 0xFFFF);
	  break;
	 }
	 else
	 {
	  if(Rolowanie == 3)Rolowanie = 1;
	  if(Rolowanie == 4)Rolowanie = 0;
	  if(Rolowanie == 2)
	  {
	   // Od Clus_N_Buf do Clus_E_Buf(<Clus_0_File)
	   NewClusf = GetFreeFAT(XClusf+1);
	   if(NewClusf>=Clus_E_Buf)
	   {
	    NewClusf=Clus_0_Buf;
	    Rolowanie = 3;
	   }
	   if(NewClusf>1)
	   {
           if(pozost <= odejm)
           {
            SetFAT(XClusf, 0xFFFF);
            pozost = 0;
            break;
           }
           else 
           {
            SetFAT(XClusf, NewClusf);
            pozost -= odejm;
            XClusf = NewClusf;
           }
//	    SetFAT(XClusf, NewClusf);
//	    XClusf = NewClusf;
	   }
	   else
	   {
	    SetFAT(XClusf, 0xFFFF);
	    break;
	   }
	  } // 2
	  if(Rolowanie == 1)
	  {
	   // Od Clus_0_Buf do Clus_C_Buf(<Clus_N_Buf)
	   NewClusf = GetFreeFAT(XClusf+1);
	   if(NewClusf>=Clus_N_Buf)
	   {
	    NewClusf=Clus_0_File;
	    Rolowanie = 4;
	   }
	   if(NewClusf>1)
	   {
           if(pozost <= odejm)
           {
            SetFAT(XClusf, 0xFFFF);
            pozost = 0;
            break;
           }
           else 
           {
            SetFAT(XClusf, NewClusf);
            pozost -= odejm;
            XClusf = NewClusf;
           }
//	    SetFAT(XClusf, NewClusf);
//	    XClusf = NewClusf;
	   }
	   else
	   {
	    SetFAT(XClusf, 0xFFFF);
	    break;
	   }
	  } // 1
	  if(Rolowanie == 0)
	  {
	   NewClusf = GetFreeFAT(XClusf+1);
	   if(NewClusf>1)
	   {
           if(pozost <= odejm)
           {
            SetFAT(XClusf, 0xFFFF);
            pozost = 0;
            break;
           }
           else 
           {
            SetFAT(XClusf, NewClusf);
            pozost -= odejm;
            XClusf = NewClusf;
           }
//	    SetFAT(XClusf, NewClusf);
//	    XClusf = NewClusf;
	   }
	   else
	   {
	    SetFAT(XClusf, 0xFFFF);
	    break;
	   }
	  } // 0
	 }
     }//for
// ------------------------------------------------------------------

     } // Rolowanie

    } // Test (if) ---------------------------------------------------

   }
  }
  else
   piszs("*NoRec*");  
}
// ---------------------------------------------------------------------------------------------

// Nagrywanie - REC..
void Nagrywanie_X(void) // Rec...
{
 unsigned long rpl, x1f, x2f, x3f, x4f, odejm, pozost, zapisan, rozmiar_x;
 unsigned short NRNazwy, XClusf, FirstClusf, NewClusf, ClusFFFF, xlf, ylf, ixf, fff;
 unsigned char Rolowanie, Zwykly, Caly;

 if(!SPDIF)
   Sample_R = 44100;
 else
   Sample_R = ALFreq;

 if((Sample_R > 42000)&&(Sample_R < 46000))
   {
    Sample_R = 44100;
    Tryb_44_48(44);
   }
 if((Sample_R > 46000)&&(Sample_R < 50000))
   {
    Sample_R = 48000;
    Tryb_44_48(48);
   }

 if((Sample_R <= 42000)||(Sample_R >= 50000))
   {
    Tryb_44_48(Tryb_44_X);
    return;
   }
/* {
   x1f = (long)STA_read(0x05);
   switch(x1f)
    {
     case 0 : Sample_R = 48000;
       break;
     case 1 : Sample_R = 44100;
       break;
     case 2 : Sample_R = 32000;
       break;
     default : Sample_R = 44100;
    }
 }*/

 Rolowanie = 0;
 Rozmiar_REC = 0;
 RecRoll = 0;
 RecLoop = 1;
 Zwykly = 0;
 Caly = 0;
 
 odejm = SecPerClusL << 9;
 pozost = 0;
 zapisan = 0;
 rozmiar_x = 0;
 ClusFFFF = 0;

 FATE = 0; // Bledne wpisy w tablicy FAT

// Funkcja REC_AUDIO wykorzystuje RAM 0x4000E000..0x4000FFFF
 if(DSP_En)
   {
    DSP_Off();
    DSP_En = 0;
    DSP_X = 0;
   }

// ZAPAL LED'y

 CLS_LCD();

// gotoxy(13,1);
 if(Stat_REC < 8)
  piszs("ADC:");
 else
  piszs("DIR:"); 

 NRNazwy = 1;
 ixf = Get_Index();
 if(ixf < LastDirEnt)
 {
  strcpy(zs, "MUSIC");
  x4f = 1;
  while(x4f)
  {
	x1f = bin2bcd(NRNazwy);
     x2f = ((x1f >> 4) & 0x0F) + 0x30;
     x1f = (x1f & 0x0F) + 0x30;
     x3f = bin2bcd(NRNazwy>>8);
     x3f = (x3f & 0x0F) + 0x30;
     zs[5] = x3f;
     zs[6] = x2f;
     zs[7] = x1f;
     zs[8] = 0;
     strcat(zs, "WAV");
	x4f = SzukajNazwy(zs);
	NRNazwy++;
  }
  gotoxy(5,1);
  zs[8] ='.';
  zs[9] ='W';
  zs[10]='A';
  zs[11]='V';
  zs[12]= 0;
  piszs(zs);

// Test
//  piszs(" i:");
//  piszdec(ixf,0);

  CTRL1B = CTRL1;
  CTRL2B = CTRL2;
  CTRL3B = CTRL3;

  if(DDAdr)
      {
       if(SPDIF)
           {
            LD_Latch_s(CTRLs_REC_SPDIF_DD_M);
           }
/*       else
           {
            LD_Latch_s(CTRLs_GRAJ_ADC_DD);
            Set_PLL2PCM(0, 2);
            act_decoder = 0;
            STA_write(0x4C, 0x03);
            STA_write(0x4D, 0x03);
            STA_write(0x05, 0x01);
            CircleSurr();
            VCROut();
           } */
      }
/*  else
      LD_Latch_s(CTRLs_GRAJ_WAV); */
  if(DIRDIT && (DDAdr == 0))
    {
      LD_Latch_s(CTRLs_REC_SPDIF_DD_M);
      if((DIR_AUDIO) == 0)
        {
          Timer_M = 6000;
          MUTE_On();
        }
    }

  EPM_WM_SCK(1);

  Rec_Audio_X(); // < ================================================== REC_AUDIO (Rec... )

  Tryb_44_48(Tryb_44_X);

  CTRL1 = CTRL1B;
  CTRL2 = CTRL2B;
  CTRL3 = CTRL3B;
  LD_Latch_n(CTRL1, 1);
  LD_Latch_n(CTRL2, 2);
  LD_Latch_n(CTRL3, 3);
  if(DDAdr)
     {

      if(SPDIF)
      {    
          STA_PLL_in(1, 1); // (1, 1); (1, 0)
          //STA_Restart(1);
          piszs("SPDIF");
      }
      else
      {
          STA_write(0x05,CTRL3&0x01); // SFREQ: 0-48, 1-44.1, 2-32, 4-96, 5-88.2 [kHz]
          Set_PLL2PCM(0, 2);
          // STA_PLL_in(0, 0);
          act_decoder = 0;
          STA_write(0x4C, 0x03);
          STA_write(0x4D, 0x03);
          STA_write(0x05,CTRL3&0x01); // SFREQ: 0-48, 1-44.1, 2-32, 4-96, 5-88.2 [kHz]
          CircleSurr();
          VCROut();
          piszs("*CSurr*");
          piszs("SIN1");
      }
     }


  gotoxy(17,1);
  piszs("*STOP*");

  pozost = Rozmiar_REC;

  if(Nagrane)
  {
   if(RecLoop > 2)
   {
     Rolowanie = 2;
	 gotoxy(17,1);
     piszs("*ROLL*");
   }
  }

  if(RecLoop < 2)
      {
       if(RecRoll)
         {
           Caly = 1; // <--------------------------------------------- Nagrywanie zwyke z przekreceniem
           Rolowanie = 4;
           Clus_0_Buf = Clus_N_Buf;
           wskr_0 = wskr_N;
           if(wskr_N)
             wskr_E = wskr_N - 1;
           else
             wskr_E = wskr_M;
           Rozmiar_REC = (((unsigned long)wskr_M + (unsigned long)1) * SecPerClusL) << 9;
           pozost = Rozmiar_REC;
         }
       else
           {
            Zwykly = 1; // <------------------------------------------ Nagrywanie zwyke 
            Rolowanie = 1;
            Clus_0_Buf = Clus_1_File;
            wskr_0 = 0;
            wskr_E = wskr_L;
            Rozmiar_REC = (((unsigned long)wskr_E + (unsigned long)1) * SecPerClusL) << 9;
            pozost = Rozmiar_REC;
           }
      }

  FATZmod = 0;

  }
  else
  {
      gotoxy(1,1);
      piszs("*Brak miejsca w kat.*");
  }

  if(Rozmiar_REC)
  {
// Pierwszy klaster pliku
   XClusf = Clus_0_Buf;
   FirstClusf = XClusf;

   NRNazwy = 1;

   ixf = Get_Index();

   if(ixf < LastDirEnt)
   {
    gotoxy(17,1);
    piszs("*SAVE*");
    
    strcpy(zs, "MUSIC");

    x4f = 1;
    while(x4f)
	{
	 x1f = bin2bcd(NRNazwy);
      x2f = ((x1f >> 4) & 0x0F) + 0x30;
      x1f = (x1f & 0x0F) + 0x30;
      x3f = bin2bcd(NRNazwy>>8);
      x3f = (x3f & 0x0F) + 0x30;
      zs[5] = x3f;
      zs[6] = x2f;
      zs[7] = x1f;
      zs[8] = 0;
      strcat(zs, "WAV");
	 x4f = SzukajNazwy(zs);
	 NRNazwy++;
	}

// Test
//    piszs(" i:");
//    piszdec(ixf,0);
// Test
//    piszs(" R:");
//    piszdec(Rozmiar_REC,0);

// Korekta trzaskw z ostatniego okna
//    if(Rozmiar_REC > (8192+48))
//	 Rozmiar_REC = Rozmiar_REC - 8192;  

// Test ----------------------------------------------------------------------------
//     piszs("*INDEXB=");piszdec(ixf,0);
     gotoxy(1,2);
     piszs("*Zaps? ");
     if(getch() == 0x0D)//'T'
     {

	 FATZmod = 1;
	 rpl = (Rozmiar_REC>>9) / (unsigned long)SecPerClusL;

     if(!Rolowanie)
     {
      for(xlf = 0; xlf < wskr_E; xlf++)
         {
          // XClusf = Tab_32_Eth[xlf];
          NewClusf = Tab_32_Eth[xlf+1];
          if(NewClusf>1)
              {
                if(pozost <= odejm)
                    {
                        SetFAT(XClusf, 0xFFFF);
                        pozost = 0;
                        zapisan += odejm;
                        ClusFFFF = XClusf;
                        break;
                    }
                else 
                    {
                        SetFAT(XClusf, NewClusf);
                        pozost -= odejm;
                        zapisan += odejm;
                        XClusf = NewClusf;
                    }
              }
          }
      XClusf = Tab_32_Eth[wskr_E]; // ostatni klaster     
      if((XClusf != ClusFFFF) && pozost)
      {
          SetFAT(XClusf, 0xFFFF);
          zapisan += odejm;
          pozost = 0;
      }
     }  // !Rolowanie

// ---------------------------------------------------
   if(Rolowanie < 3)
   {
    xlf = wskr_0;
    ylf = wskr_0 + 1;
    if(ylf >= wskr_T)
        ylf = 0;

    XClusf = Tab_32_Eth[xlf];
    while(xlf != wskr_E)
	 {
       // XClusf = Tab_32_Eth[xlf];
       NewClusf = Tab_32_Eth[ylf];
       if(NewClusf>1)
	   {
           if(pozost <= odejm)
               {
                SetFAT(XClusf, 0xFFFF);
                pozost = 0;
                zapisan += odejm;
                ClusFFFF = XClusf;
                break;
               }
           else 
               {
                SetFAT(XClusf, NewClusf);
                pozost -= odejm;
                zapisan += odejm;
                XClusf = NewClusf;
               }
        }
	    else
          if(pozost)
           {
            SetFAT(XClusf, 0xFFFF);
            zapisan += odejm;
            pozost = 0;
            ClusFFFF = XClusf;
            break;
           }
       ylf++;
       if(ylf >= wskr_T)
        ylf = 0;
      } // while
// ------------------------------------------------------------------
      XClusf = Tab_32_Eth[wskr_E]; // ostatni klaster
      if((XClusf != ClusFFFF) && pozost)
      {
        SetFAT(XClusf, 0xFFFF);
        zapisan += odejm;
        pozost = 0;
      }
     } // Rolowanie 1,2

// ------------------------------------------------------------------
   if(Rolowanie == 4)
   {
    xlf = wskr_0;
    ylf = wskr_0 + 1;
    if(ylf >= wskr_T)
        ylf = 0;

    XClusf = Tab_32_Eth[xlf];
   for(fff = 0; fff < wskr_T; fff++)
	 {
       // XClusf = Tab_32_Eth[xlf];
       NewClusf = Tab_32_Eth[ylf];
       if(NewClusf>1)
	   {
           if(pozost <= odejm)
               {
                SetFAT(XClusf, 0xFFFF);
                pozost = 0;
                zapisan += odejm;
                ClusFFFF = XClusf;
                break;
               }
           else 
               {
                SetFAT(XClusf, NewClusf);
                pozost -= odejm;
                zapisan += odejm;
                XClusf = NewClusf;
               }
        }
	    else
          if(pozost)
           {
            SetFAT(XClusf, 0xFFFF);
            zapisan += odejm;
            pozost = 0;
            ClusFFFF = XClusf;
            break;
           }
       ylf++;
       if(ylf >= wskr_T)
        ylf = 0;
      } // while
// ------------------------------------------------------------------
      XClusf = Tab_32_Eth[wskr_E]; // ostatni klaster
      if((XClusf != ClusFFFF) && pozost)
      {
        SetFAT(XClusf, 0xFFFF);
        zapisan += odejm;
        pozost = 0;
      }
     } // Rolowanie 4
// ------------------------------------------------------------------

     rozmiar_x = Rozmiar_REC;
     Rozmiar_REC = zapisan;

// Zapis w katalogu
     INDEXB = ixf;
     INDEX++;    

     Indexow = Indexow + 1;
     Plikow = Plikow + 1;

     memcpy(Kat_Pliku.Name, zs ,8);
     memcpy(Name8, zs ,8);
     Name8[8]=0x00;
     memcpy(Kat_Pliku.Ext, "WAV", 3);
     memcpy(Ext3, "WAV", 3);
     Ext3[3]=0x00;
     Kat_Pliku.Rozmiar = Rozmiar_REC;
     Kat_Pliku.Atrybuty = 0x20;
     Kat_Pliku.Klaster = FirstClusf;
     Kat_Pliku.Czas = GetTimeF();
     Kat_Pliku.Data = GetDateF();

     memcpy(DIR0, &Kat_Pliku, 32); //(ixf<<5) DIR_R
     WR_SRAM(INDEXB<<5, DIR0);


	 if(DIR_DOT)
	  Write_dot_DIR(INDEXB);
	 else
	  Write_root_DIR(INDEXB);

// Naglowek WAVE
     Get_1_SEC(FirstClusf);
	 Header_WAVE.RIFF = 0x46464952;
	 Header_WAVE.File_long_sub_8 = Rozmiar_REC - 8;
	 Header_WAVE.WAVE = 0x45564157;
	 Header_WAVE.ID = 0x20746D66;
	 Header_WAVE.Extra_format = 0x10;
	 Header_WAVE.Compression = 0x0001;
	 Header_WAVE.Chanels = 2; // Stereo_Mono + 1
	 Header_WAVE.Sample_rate = (unsigned long)Sample_R;
	 Header_WAVE.Bytes_per_second = (((long)Sample_R << 1)*2); // Stereo_Mono + 1L
	 Header_WAVE.Bytes_per_sample = 2 << 1; // Stereo_Mono + 1
	 Header_WAVE.Bits_per_sample = 0x10;
	 Header_WAVE.DATA_WAVE = 0x61746164;
	 Header_WAVE.File_lenght_sub_44 = Rozmiar_REC - 44;
     ch_ptr = (char*)Buf_8;
     memcpy(ch_ptr, &Header_WAVE, 44);
	 Put_1_SEC(FirstClusf);

     piszs("*SAVE*");

    } // Test (if) ---------------------------------------------------
    else
     piszs("NoSave");

// +++++ Test +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++=
    linia2(10, 24); 
    piszs(" Rec:");
    piszdec(rozmiar_x, 9);

//    gotoxy(15,2);

//    piszs(" Zapisano:");
//    piszdec(zapisan, 0);
//    piszs(" Pozostalo:");
//    piszdec(pozost, 0);
    if(FATE)
     {
        piszs("*FAT Error:");
        piszhl(FATE);
     }

    FATZmod = 1;
    Zapisz_FATy();
   }
  }
  else
      {
       gotoxy(18,2);
       piszs("*NoRec*");
      }
  if(DIR_DOT)
    Klaster = Klaster_dot;
  else
    Klaster = 0;
  Read_DIR(Klaster);  
}
// ---------------------------------------------------------------------------------------------

// ================================================ REC_AUDIO (Rec... ) ========================
void Rec_Audio(void)
{
unsigned char over, stp, smiec;
unsigned short RC, LC, LCm, fr, xr, KlastRec, LastClusRec;
unsigned short err;

// REC Audio

 RC = 0; // Rec Cykl
 LC = 0; // Loop Cykl
 LCm = (unsigned short)SecPerClusL >> 4 ; // Loop Cykl max
 KlastRec = 2;

 wskr = 0;
 wskr_C = 0;
 wskr_E = RecLoopLenL / SecPerClusL;
 wskr_E--; // wskr_E (END bufora) - 1

 Timer_2 = 400;

   //gotoxy(1,2);
   piszs(" F:");

 KlastRec = GetFreeFAT(KlastRec);
   //gotoxy(3,2);
   piszhl(KlastRec>>8);
   piszhl(KlastRec);

// Test ------------------------------------------------------------------------------------------
 piszs("*SEC:");
 piszhex(DATA_0 + ((unsigned long)KlastRec - (unsigned long)2) * SecPerClusL);
 piszs("*");

 if(!RecLoop)
 {
// REC/Nagrywanie normalne
  Nagrane = 1;
  Clus_0_Buf = KlastRec;
  Clus_C_Buf = KlastRec;
  Clus_N_Buf = KlastRec;
  Clus_E_Buf = KlastRec;
  Clus_0_File = KlastRec;
//  Clus_1_File = KlastRec;
 }
 else
 {
// REC/Nagrywanie LOOP
  Nagrane = 0;
  Clus_0_Buf = KlastRec;
  Clus_C_Buf = KlastRec;
  Clus_N_Buf = KlastRec;

  xr = Clus_0_Buf;
  for(fr = 0; fr < (unsigned long)RecLoopLenL/(unsigned long)SecPerClusL; fr++)
  {
   Clus_E_Buf = xr;
   xr = GetFreeFAT(xr + 1);
  }

  Clus_0_File = xr;
 }

 if(KlastRec>=2)
  Audio_SEC = 7;
 else
  Audio_SEC = 1;

// Test ----------------------------------------------
 if(RecLoop)
 {
  //gotoxy(1,1);
  piszs(" C0B:");
  piszhl(Clus_0_Buf>>8);
  piszhl(Clus_0_Buf);
  piszs(" C0F:");
  piszhl(Clus_0_File>>8);
  piszhl(Clus_0_File);
//  piszs(" fx:");
//  piszhl(Clus_1_File>>8);
//  piszhl(Clus_1_File);
 } 

 Rozmiar_REC = 0;

 if((Audio_SEC>=0x0007) && (Clus_0_File < MAX_Klaster))
 {
   if(RecLoop)
    piszs(">BUF");
   else
    piszs(">REC");
// SPI - Slave
   over = 0;
   stp = 0;
   error = 0;
   err = 0;

   if(BigClus)
    Ulamek = 1;
   else
    Ulamek = 0;

// Odpalenie nagrywania
   VICVectAddr31 = (uint32_t) Irq_I2S_Rx; // I2S_Tx; I2S_Rx

   piszs("\n\r");
   piszs(" REC.. ");

//   secl = xx;
//   sech = secl + 15;

   i2s_x=0; // 0
   i2s_y=0; // 0
   i2s_o=0; // 0
   i2s_b=0; // 0 lub 8

//   xx = i2s_o;

   I2S_IRQ = 0x0001 + 0 + (4<<8) + (4<<16); // IRQ_rx(01), IRG_tx(02), FIFO_level_rx, FIFO_level_tx

// ------------------------------------- Pelta Rec... ----------------------------------
    piszc(' ');
    while(1)
    {
  // Window 0x20..
     //gotoxy(15,2);
     Timer_2 = 400;
     while((i2s_b & REC_X[RC][0]) == 0)
     {
      if((smiec = KlawX()) > 0)
      {
        // RegVOL(smiec);
       if(smiec == 0x0D)
       {
  // Wyjscie z petli RecLoop
        if(RecLoop == 1)
        {
         RecLoop = 2;
         Nagrane = 1;
         //gotoxy(7, 2);
         piszs(">SYNCH");
         //gotoxy(15,2);
        }
       }
       if(smiec == 0x1B)
        stp++;
      }
      if(!Timer_2)
       break;
     }
     if(!Timer_2)break;

     piszc(REC_X[RC][3]);
  
     KlastRec = GetFreeFAT(KlastRec);
     if(!KlastRec)
      break;
     else
     {
      LastClusRec = KlastRec;
      DI;i2s_b &= REC_X[RC][1];EI;
      KlastRec = Put_1_Okno(KlastRec, REC_X[RC][2]);
     }

     if(!KlastRec)
      break;
     if(!RecLoop)
      Rozmiar_REC = Rozmiar_REC + (unsigned long)8192;
     else
     {
      if((!RecRoll) || (RecLoop == 4))
       Rozmiar_REC = Rozmiar_REC + (unsigned long)8192;
     }
  
     RC++;
     if(RC >= 3)
      RC = 0;

     err = err + error;
     if(err>9)break;
//     if(err)
//      piszc((err&0x0F)+0x30);

//     DisplayVol(8, 0);
  
     if(stp)break;

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
     LC++;
     if(LC == LCm)
     { 
// ===========================================================================================
      LC = 0;
      if(RecLoop && !RecRoll)
      {
       if(RecLoop == 2)
        wskr_C = wskr;
       if(wskr < MAX_wskr)wskr++;
       if(wskr >= wskr_E)
        wskr = 0;
      }

// -------------------------------------------------
    if(RecLoop == 2)
     Clus_C_Buf = KlastRec;
    LastClusRec = KlastRec;

    if(RecLoop == 2)
    {
     if(RecRoll)
     {
	  Clus_N_Buf = KlastRec;
	  RecLoop = 3;
	}
	else
     {
// Recloop -> REC/Nagrywanie normalne
      Clus_C_Buf = Clus_0_Buf;
      Clus_N_Buf = Clus_0_Buf;
      Clus_E_Buf = Clus_0_Buf;
      Clus_0_File = Clus_0_Buf;
//      Clus_1_File = Clus_0_Buf;
	  RecLoop = 0;
	  RecRoll = 0;
      //gotoxy(7, 2);
      piszs(">REC");
	 }
    }

// -------------------------------------------------
      if(!KlastRec)
       break;
  
  // Nagrywanie w petli
       if((KlastRec >= Clus_0_File) && (RecLoop==1))
       {
  // Zapetlenie
        KlastRec = Clus_0_Buf;
        if(Clus_E_Buf < LastClusRec)
         Clus_E_Buf = LastClusRec;
        RecRoll = 1;
       }
  
     if((RecLoop == 3) && (RecRoll))// && (KlastRec == Clus_0_File)
     {
// Koniec RecLoop
      RecLoop = 4;

      if(Clus_E_Buf < LastClusRec)
       Clus_E_Buf = LastClusRec;

      KlastRec = Clus_0_File; // Clus_1_File

      // gotoxy(7, 2);
      piszs(">REC");
     }

	if((RecLoop == 3) && (!RecRoll) && (KlastRec == Clus_0_File))
     {
// Koniec RecLoop
      RecLoop = 4;
      if(Clus_E_Buf < LastClusRec)
       Clus_E_Buf = LastClusRec;

      KlastRec = Clus_0_File; // Clus_1_File

      //gotoxy(7, 2);
      piszs(">REC");
     }
      //gotoxy(3,2);
      piszhl(KlastRec>>8);
      piszhl(KlastRec);
    } // if
// --------------------------------------------------------------------------------------------
   } // while
  
//   Wylacz sprzetowo nagrywanie
// Wylacz przerwania IRQ_rx(01)
   I2S_IRQ = 0 + 0 + (4<<8) + (4<<16); // IRQ_rx(01), IRG_tx(02), FIFO_level_rx, FIFO_level_tx    

   piszs(" x=");piszhex(i2s_x);
   piszs(" y=");piszhex(i2s_y);
   piszs(" o=");piszhex(i2s_o);
   piszs(" SEC=");piszhex(sech + 1);
// ---------------------------------------------------------------------------------------------
     
    if(error)
    {
     piszs("\n\rERROR:");
     piszhl(error>>8);
     piszhl(error);
    }
  
// Test
    if(RecLoop)
    {
     piszs("\n\r");
     piszs(" Cl_C:");
     piszhl(Clus_C_Buf>>8);
     piszhl(Clus_C_Buf);
     piszs(" Cl_N:");
     piszhl(Clus_N_Buf>>8);
     piszhl(Clus_N_Buf);
     piszs(" Cl_E:");
     piszhl(Clus_E_Buf>>8);
     piszhl(Clus_E_Buf);
    }
    else
    {
     piszs("\n\r");
     piszs(" C0F:");
     piszhl(Clus_0_File>>8);
     piszhl(Clus_0_File);
     piszs("Cl_N");
     piszhl(Clus_N_Buf>>8);
     piszhl(Clus_N_Buf);
     piszs(" ClR:");
     piszhl(KlastRec>>8);
     piszhl(KlastRec);
     piszc(' ');
     delayx(1000);
    }
// End Test
  
  } // if
  else
    piszs("NOREC");
}
// =================================================================================

// ================================================ REC_AUDIO (RAM... ) ========================
void Rec_RAM(void)
{
unsigned short RC;
unsigned char _ctrl_2;
// REC Audio RAM

   Timer_2 = 400;
   _ctrl_2 = CTRL2;
   CTRL2 &= 0xA8; // wejscie PCM0(VCR)
   LD_Latch_n(CTRL2, 2);

// Odpalenie nagrywania
   VICVectAddr31 = (uint32_t) Irq_I2S_Rx; // I2S_Tx; I2S_Rx

   i2s_x=0; // 0
   i2s_y=0; // 0
   i2s_o=0; // 0
   i2s_b=0; // 0 lub 8

//   xx = i2s_o;

   RC = 0;

   I2S_IRQ = 0x0001 + 0 + (4<<8) + (4<<16); // IRQ_rx(01), IRG_tx(02), FIFO_level_rx, FIFO_level_tx

// ------------------------------------- Pelta Rec... ----------------------------------
    for(RC=0; RC<3; RC++)
      {
      // Window 0x20..
         //gotoxy(15,2);
         Timer_2 = 400;
         while((i2s_b & REC_X[RC][0]) == 0)
         {
          if(!Timer_2)
           break;
         }
         if(!Timer_2)break;
    
         DI;i2s_b &= REC_X[RC][1];EI;
    
      }
  
// Wylacz sprzetowo nagrywanie
// Wylacz przerwania IRQ_rx(01)
   I2S_IRQ = 0 + 0 + (4<<8) + (4<<16); // IRQ_rx(01), IRG_tx(02), FIFO_level_rx, FIFO_level_tx    
   CTRL2 = _ctrl_2;
   LD_Latch_n(CTRL2, 2);
}
// =================================================================================

// ================================================ REC_AUDIO (Rec... ) ========================
void Rec_Audio_X(void)
{
unsigned char over, stp, Mod_R, bylz;
int smiec;
unsigned short RC, LC, LCm, xr, KlastRec, KlastFree, Rec_B;
unsigned short err, ff, okk, FATX, Fat_M2, Fat_M1, Fat_00;
unsigned long del_, x_, drop_out; // ffff, px, 
// unsigned long wolne_klastry;

// REC Audio X -> Wolne klastry w tablicy

 DIR_OK_P = 0; 
 DIRowP = 0;
 PlikowP = 0;
 IndexowP = 0;
 INDEXP = 0;
 drop_out = 0;
 bylz = 0;

 Fat_M2 = GetFreeFAT(2);
 Fat_M1 = GetFreeFAT(Fat_M2);
 Fat_00 = GetFreeFAT(Fat_M1);

// wolne_klastry = Wolne_Sec() / SecPerClusL;

 FATX = 4090; // SD 512MB, 1GB 4096 (~6 min)
 if(SecPerClus == 0x40)
     FATX = 3230; // SD 2GB 3072, 3230 (~10 min) 
 if(SecPerClus == 0x80)
     FATX = 1938; // SDHC 4GB 2048, 1938 (~12 min)
// if(FATX > wolne_klastry)
//     FATX = wolne_klastry;

 for(ff = 0; ff < 4096; ff++)
   Tab_32_Eth[ff] = 0;

   RC = 0; // Rec Cykl
   LC = 0; // Loop Cykl
   LCm = (unsigned short)SecPerClusL >> 4 ; // Loop Cykl max
   KlastRec = Fat_00;
   KlastFree = 0; // ilosc wolnych klastrow w tablicy
   Klast_M = 0;  // maksymalny numer klastra w tablicy
   Rec_B = 0; // Nagranych blokow
   Mod_R = 0; // 
   
   wskr = 0; // wskaznik do tablicy ustawiany przez GetFreeFATX
   wskr_0 = 0; // wskaznik pierwszego elementu tablicy -> poczatku nagrania
   wskr_C = 0; // wskaznik elemenyu tablicy w chwili START
   wskr_E = 0; // wskaznik ostatniego elementu tablicy -> konca nagrania w chwili STOP
   wskr_M = 0; // wskaznik ostatniego elementu tablicy -> maksymalnego konca nagrania
   wskr_T = 0; // calkowita ilosc elementow w tablicy
   wskr_L = 0; // ostatnio nagrany wskaznik;
   
// ----------------- Schowaj Katalog(DIRECTORY) w SRAM ----------------------------------
/*     DI;
     ff = 0;
     for(ffff = 0x8000; ffff <= 0xFFE0; ffff += 32)
        {
         px = (unsigned long)Tab_8 + ffff;
         ch_ptr = (char*)px;
          WR_SRAM(ff, ch_ptr);
          ff += 32; 
        }
     EI;
*/   
// Wyzeruj tablice wolnych klastrow -----------------------------------------------------
   for(ff = 0; ff < 4096; ff++)
    Buf_16_FAT[ff] = 0;   
// Wypenij tablic wolnych klastrow
   okk = 1;
   Timer_2 = 600;
   while(okk && Timer_2)
     {
     okk = 0;
     for(ff = 0; ff < FATX; ff++)
         {
              if(KlastRec)
                KlastRec = GetFreeFAT(KlastRec);
              else
                Buf_16_FAT[ff] = 0;

              if((KlastRec > 1) && (KlastRec < MAX_Klaster))
                  {
                    Buf_16_FAT[ff] = KlastRec;
                    Klast_M = KlastRec;
                    if(ff == 0)
                        {
                         wskr_E = ff;
                         KlastRec++;
                         KlastFree++;
                        }
                    if(ff)
                        {
                         if((Buf_16_FAT[ff-1] != (Buf_16_FAT[ff]-1))&&(Klast_M < (MAX_Klaster-(Poslizg_X+1))))
                            {
                             wskr_E = 0;
                             KlastFree = 0;
                             KlastRec = Klast_M;
                             okk++;
                             break;
                            }
                         else
                            {
                             wskr_E = ff;
                             KlastRec++;
                             KlastFree++;
                            }
                        }
   
                  }
              else
                    Buf_16_FAT[ff] = 0;
         }
      if(okk)
       for(ff = 0; ff < 4096; ff++)
          Buf_16_FAT[ff] = 0;
     }
   
   if(Timer_2 == 0)
     {
       okk = 1;
     KlastRec = Fat_00;
     KlastFree = 0; // ilosc wolnych klastrow w tablicy
     Klast_M = 0;  // maksymalny numer klastra w tablicy
     Rec_B = 0; // Nagranych blokow
     Mod_R = 0; // 
   
     wskr = 0; // wskaznik do tablicy ustawiany przez GetFreeFATX
     wskr_0 = 0; // wskaznik pierwszego elementu tablicy -> poczatku nagrania
     wskr_C = 0; // wskaznik elemenyu tablicy w chwili START
     wskr_E = 0; // wskaznik ostatniego elementu tablicy -> konca nagrania w chwili STOP
     wskr_M = 0; // wskaznik ostatniego elementu tablicy -> maksymalnego konca nagrania
     wskr_T = 0; // calkowita ilosc elementow w tablicy
     wskr_L = 0; // ostatnio nagrany wskaznik;
   
      for(ff = 0; ff < FATX; ff++)
         {
              if(KlastRec)
                KlastRec = GetFreeFAT(KlastRec);
              else
                Buf_16_FAT[ff] = 0;

              if((KlastRec > 1) && (KlastRec < MAX_Klaster))
                  {
                    Buf_16_FAT[ff] = KlastRec;
                    Klast_M = KlastRec;
                    wskr_E = ff;
                    KlastRec++;
                    KlastFree++;
                  }
              else
                    Buf_16_FAT[ff] = 0;
         }
     }
// Przejscie na Tab_32_USB[] -> nie aktualne dla LPC2387
//   for(ff = 0; ff < 4096; ff++)
//       Set_Word(ff, Tab_32_Eth[ff]);

// Slepy zapis
//   Put_1_Okno_Y(Fat_00, 0x2000);
//   Timer_2 = 99;
//   while(Timer_2);

   if(KlastFree > Poslizg_X)
    {
     wskr_T = KlastFree;
     wskr_E = wskr_T - 1;
     wskr_M = wskr_T - 1;
     wskr_L = 0;
    
   // +++++++++++ TEST ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     gotoxy(1,2);
     piszs("FreeF");
     if(okk)
         piszs("(F):");
     else
         piszs("(L):");
     piszdec(KlastFree, 4);
     piszc(' ');

     Timer_1 = 100;

     while(Timer_1);
         
     Timer_2 = 400;
    
     gotoxy(1,2);
     piszs("START..");

     gotoxy(8,2);
     piszs("F:");
    
     KlastRec = Fat_00;
     KlastRec = GetFreeFATZ(KlastRec);

     gotoxy(20,2);
     piszhl(KlastRec>>8);
     piszhl(KlastRec);
    
    // Test ------------------------------------------------------------------------------------------
    // piszs("*SEC:");
    // piszhex(DATA_0 + ((unsigned long)KlastRec - (unsigned long)2) * SecPerClusL);
    // piszs("*");
    
     Clus_0_Buf = KlastRec;
     Clus_1_File = KlastRec;
     Clus_C_Buf = KlastRec;
     Clus_E_Buf = Klast_M;
     Clus_N_Buf = KlastRec;

     if(!RecLoop)
     {
    // REC/Nagrywanie normalne
      Nagrane = 1;
     }
     else
     {
    // REC/Nagrywanie LOOP
      Nagrane = 0;
     }
    
     if(KlastRec>=2)
      Audio_SEC = 7;
     else
      Audio_SEC = 1;
    
    // Test ----------------------------------------------
    // if(RecLoop)
    // {
    //  gotoxy(8,2);
    //  piszs(" C_0:");
    //  piszhl(Clus_0_Buf>>8);
    //  piszhl(Clus_0_Buf);
    //  piszs(" C_E:");
    //  piszhl(Clus_E_Buf>>8);
    //  piszhl(Clus_E_Buf);
    // } 
    
     Rozmiar_REC = 0;
    
   // Poczekaj po zapisie FAT'ow
   //  Timer_1 = 150;
   //  while(Timer_1);

     error = 0;
     if((Audio_SEC>=0x0007) && (Clus_0_Buf < MAX_Klaster))
     {
       gotoxy(7,2);

       Record = 1;

       if(RecLoop)
        piszs(" >BUF...");
       else
        piszs(" >REC...");
    // SPI - Slave
       over = 0;
       stp = 0;
       error = 0;
       err = 0;
    
       if(BigClus)
        Ulamek = 1;
       else
        Ulamek = 0;
    
       DISK_32_B = 0x5A63A653; // Tryb 32 bitowy
    // Odpalenie nagrywania
       VICVectAddr31 = (uint32_t) Irq_I2S_Rx; // I2S_Tx; I2S_Rx
    //   Record = 1;

       piszs("\n\r");
       gotoxy(20,2);
       piszs("...._");
    
       i2s_x=0; // 0
       i2s_y=0; // 0
       i2s_o=0; // 0
       i2s_b=0; // 0
     
       I2S_IRQ = 0x0001 + 0 + (4<<8) + (4<<16); // IRQ_rx(01), IRG_tx(02), FIFO_level_rx, FIFO_level_tx
    
    // ------------------------------------- Pelta Rec... ----------------------------------
        while(1)
        {
      // Window 0x20..
         gotoxy(15,2);
         Timer_2 = 400;
         while((i2s_b & REC_X[RC][0]) == 0)
         {
          smiec = KlawX();   
          if(smiec > 0)
          {
           // RegVOL(smiec);
           if((smiec != 0x1B)&&(smiec != '-')&&(smiec != '+'))
           {
      // Wyjscie z petli RecLoop
            if(RecLoop == 1)
            {
             RecLoop = 2;
             Nagrane = 1;
             gotoxy(1, 2);
             piszs(">SYNCH >REC");
             gotoxy(15,2);
            }
           }
           if(smiec == 0x1B)
            stp++;
          }
          if(!Timer_2)
           break;
         }
         if(!Timer_2)break;
    
         piszc(8);
         piszc(REC_X[RC][3]);
      
         KlastRec = GetFreeFATZ(KlastRec);
         if(wskr > wskr_T)
           wskr = wskr_T;
              
         if((wskr >= wskr_T) && RecLoop) // przekrecenie sie bufora
             {
              wskr = 0;
              KlastRec = Clus_1_File;
              RecRoll = 1;
   // Test +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
              gotoxy(7, 2);
              piszs(" ROLL");
              piszs(" ....-");
             }
    
         if((wskr >= wskr_T) && (RecLoop == 0)) // koniec bufora
         {
                wskr = wskr_T - 1;
                wskr_E = wskr;
                KlastRec = LastClusRec; // KlatRec = 0 zmieniamy na LastClusRec
                stp++;
                break;
         }
         else
         {
          LastClusRec = KlastRec;
          DI;i2s_b &= REC_X[RC][1];EI;
          wskr_L = wskr;

          Timer_1 = 600; // 400 <+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

          x_ = REC_X[RC][2];
          KlastRec = Put_1_Okno_Z(KlastRec, x_); // Put_1_Okno_X() zwraca nowy KlastRec i wskr

          x_ = REC_X[RC][2] + 0x2000;
          KlastRec = Put_1_Okno_Z(KlastRec, x_); // Put_1_Okno_X() zwraca nowy KlastRec i wskr

          del_ = 600 - Timer_1; // 200 / 4 = 50 impulsow na sekunde, dla 48000 potrzeba ~48

          if(del_ > 47) // 47 59
          {
           // piszc('^');
           x_ = 0x00001111 & i2s_b; // 0x00011111
           if(x_ != 0x00001111)     // 0x00011111
               {
                piszc('+');
                bylz++;
               }
           else
               {
                    piszc('*');
                    bylz++;
                    Timer_1 = 400;
                    switch(RC)
                        {
                        case 0  :   while((i2s_x != 6144)&&Timer_1);
                                    break;
                        case 1  :   while((i2s_x != 10240)&&Timer_1);
                                    break;
                        case 2  :   while((i2s_x != 267924484)&&Timer_1);
                                    break;
                        case 3  :   while((i2s_x != 2048)&&Timer_1); // 2048 267651080
                                    break;
                        case 4  :   while((i2s_x != 2048)&&Timer_1); // !
                                    break;
                        }
                    DI;i2s_b &= 0x000CCCCC;EI;
                    drop_out++;
               }
          }
          if(!RecLoop)
           Rec_B++;
          else
          {
           if((!RecRoll) && ((RecLoop == 1) || (RecLoop == 2)) && !Mod_R)
            Rec_B++;
          }
          if(RecLoop > 2)
            Rec_B++;
         }
   
         if((wskr_L == wskr_M) && (RecLoop > 2)) // koniec petli
             stp++;
   
         RC++;
         if(RC >= 4) // 4 5
          RC = 0;
    
         err = err + error;
   
    
    // 1 l I 1 l I +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      
         LC++;
         if(LC == LCm)
         { 
    // ===========================================================================================
          LC = 0;

          Clus_N_Buf = KlastRec;
          wskr_N = wskr;
          if(!Clus_N_Buf)
            {
              Clus_N_Buf = Buf_16_FAT[0];//Get_Word, Tab_32_Eth[0];
              wskr_N = 0;
            }
   
          if((Mod_R == 0) && (wskr_L >= Poslizg_X) && (RecLoop < 2))
              {
                Mod_R = 1;
                gotoxy(7,2);
                piszs(" MODR....-");
              }
   
          if((err > 2) || stp)
              {
    // Koniec nagrywania (STOP lub ERROR)
                wskr_E = wskr_L;
                Clus_E_Buf = LastClusRec; // Tab_32_Eth[wskr_E];
                break;
              }
   
          if(!KlastRec && RecLoop)
              {
               KlastRec = Buf_16_FAT[0]; //Get_Word, Tab_32_Eth[0]; // Zapetlenie bufora
               RecRoll++;
              }
    // -------------------------------------------------
          if(RecLoop == 2)
            {
             wskr_C = wskr_L;
             Clus_C_Buf = LastClusRec;
   
             if(!RecRoll && Mod_R) // START gdy Klastrow_nagranych >= Poslizg_X
                 {
                    if(wskr_C >= Poslizg_X)
                        {
                         wskr_0 = wskr_C - Poslizg_X;
                         if(wskr_0)
                             wskr_M = wskr_0 - 1;
                         wskr_E = wskr_M;
                        }
                 }
   
             if(RecRoll) // START gdy bufor juz sie przekrecil
                 {
                    if(wskr_C >= Poslizg_X)
                        {
                         wskr_0 = wskr_C - Poslizg_X;
                         if(wskr_0)
                             wskr_M = wskr_0 - 1;
                        }
                    else
                        {
                            xr = Poslizg_X - wskr_C;
                            wskr_0 = wskr_T - xr;
                            wskr_M = wskr_0 - 1;
                        }
                    wskr_E = wskr_M;
                 }
   
             Clus_0_Buf = Buf_16_FAT[wskr_0]; //Get_Word, Tab_32_Eth[wskr_0];
             Clus_C_Buf = Buf_16_FAT[wskr_C]; //Get_Word, Tab_32_Eth[wskr_C];
             Clus_E_Buf = Buf_16_FAT[wskr_E]; //Get_Word, Tab_32_Eth[wskr_E];
   
             RecLoop = 3;
             gotoxy(7,2);
             piszs(" REC ...._");
             // piszs("\010\010\010\010\010");
            }
    
          if(!KlastRec)
           break;
      
          //gotoxy(3,2);
          piszs("\010\010\010\010\010");
          if(bylz)
             {
              bylz = 0;
              piszc(8);
             }
          gotoxy(20,2);
          piszhl(KlastRec>>8);
          piszhl(KlastRec);
          piszc('_');
   // ----------------------------------------------- Rozmiar_REC ------------------------------------
          ECHO_Off;
          gotoxy(18,1);
          //piszdec(Rec_B >> 6, 3);  // Rozmiar_REC[MB] dla Rec_B = 16384
          //piszc('M');
          piszdec(Rec_B << 4, 6);  // Rozmiar_REC[MB] dla Rec_B = 16384
          piszc('k');
          LCD_X;

   // Test +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
          /*if((wskr & 0x00FF) == 0)
              {
               piszs(" w:");
               piszdec(wskr,0);
               piszs(" nnnn+");
              }*/
   
        } // if
    // --------------------------------------------------------------------------------------------
         if((smiec == '+')||(smiec == '-'))
              Set_Vol_SPK(smiec);
         smiec = 0;

       } // while

    // Wylacz sprzetowo nagrywanie
    // Wylacz przerwania IRQ_rx(01)
       I2S_IRQ = 0 + 0 + (4<<8) + (4<<16); // IRQ_rx(01), IRG_tx(02), FIFO_level_rx, FIFO_level_tx    
       Record = 0;
       DISK_32_B = 0x12345678; // Tryb 8 bitowy

   // Odtworz Tab_32_Eth[]; // dla Nagrywanie_X();
       for(ff =0; ff < 4096; ff++)
           Tab_32_Eth[ff] = (unsigned long)Buf_16_FAT[ff] & 0x0000FFFF;////Get_Word, Tab_32_Eth[ff];

       LCD_X;
       LCD_Off;
       piszs(" x=");piszhex(i2s_x);
       piszs(" y=");piszhex(i2s_y);
       piszs(" o=");piszhex(i2s_o);
       piszs(" SEC=");piszhex(sech + 1);
    // ---------------------------------------------------------------------------------------------
   
//     Rozmiar_REC = (unsigned long)Rec_B << 13; // * (unsigned long)8192;        
       Rozmiar_REC = (unsigned long)Rec_B << 14; // * (unsigned long)16384;        
   
       if(error)
        {
         piszs("\n\rERROR:");
         piszhl(error>>8);
         piszhl(error);
        }

       LCD_X;

       if(drop_out) // < ------------------------------------------------------------ Drop Out -----
           {
            ECHO_Off;
            gotoxy(22,1);
            piszdec(drop_out, 3);
            LCD_X;
           }
     
       Record = 0;

      } // if
      else
          piszs("NoRec");

// ----------------- Odtworz Katalog(DIRECTORY) z SRAM ----------------------------------
/*     DI;
     ff = 0;
     for(ffff = 0x8000; ffff <= 0xFFE0; ffff += 32)
        {
         px = (unsigned long)Tab_8 + ffff;
         ch_ptr = (char*)px;
          RD_SRAM(ff, ch_ptr);
          ff += 32; 
        }
     EI;
*/
    } // if
    else
        piszs("NOREC");
}
// =================================================================================

// Make DIR
void Make_DIR(void)
{
 unsigned long x1f, x2f, x4f, ixf, px;
 unsigned short NRNazwy, XClusf;

 gotoxy(1,2);
 piszs("Make DIR: ");

 DISK_32_B = 0x76543210; // Wylacz 32 bitowy dostep do plikow

 if(DIR_OK)
     {
     NRNazwy = 1;
     ixf = Get_Index();
     if(ixf < LastDirEnt)
      {
       strcpy(zs, "FOLDERnn");
       x4f = 1;
       while(x4f)
       {
        x1f = bin2bcd(NRNazwy);
         x2f = ((x1f >> 4) & 0x0F) + 0x30;
         x1f = (x1f & 0x0F) + 0x30;
         zs[6] = x2f;
         zs[7] = x1f;
         zs[8] = 0;
         strcat(zs, "   ");
        x4f = SzukajNazwy(zs);
        NRNazwy++;
       }
    //  gotoxy(1,1);
       piszs(zs);
    
       INDEXB = ixf;
       Indexow = Indexow + 1;
       Plikow = Plikow + 1;
    
       FATZmod = 0;
      }
      else
      {
       piszs("*Brak miejsca w kat.*");
       NRNazwy = 0;
      }
    
      if(NRNazwy)
         {
          memcpy(Kat_Pliku.Name, zs ,8);
          memcpy(Name8, zs ,8);
          Name8[8]=0x00;
          memcpy(Kat_Pliku.Ext, "   ", 3);
          memcpy(Ext3, "   ", 3);
          Ext3[3]=0x00;
          Kat_Pliku.Rozmiar = 0;
          Kat_Pliku.Atrybuty = 0x10;
        
          XClusf = GetFreeFAT(2);
        
          Kat_Pliku.Klaster = XClusf;
          Kat_Pliku.Czas = 0x20 + (sekundy<<5) + sekundy ;// GetTimeF();
          Kat_Pliku.Data = 0x5C21;// GetDateF();
        
          memcpy(DIR0, &Kat_Pliku, 32); //(ixf<<5) DIR_R
          WR_SRAM(INDEXB<<5, DIR0);
        
            if(DIR_DOT)
             Write_dot_DIR(INDEXB);
            else
             Write_root_DIR(INDEXB);
        
          FATZmod = 1;
          SetFAT(XClusf, 0xFFFF);

// +++++++ TEST ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
          piszs(" F:");
          piszhl(XClusf);

    
    // Zrob katalog ---------------------------------------
    // Katalog .
          memcpy(Kat_Pliku.Name, ".       ", 8);
          memcpy(Kat_Pliku.Ext, "   ", 3);
          memcpy((char*)Buf_8, &Kat_Pliku, 32);
    
    // Katalog ..
          memcpy(Kat_Pliku.Name, "..      ", 8);
          memcpy(Kat_Pliku.Ext, "   ", 3);
    
          if(DIR_DOT)
              Kat_Pliku.Klaster = Klaster_dot; // Klauser_dot (dla danych) lub 0
          else
              Kat_Pliku.Klaster = 0; // Klauser_dot (dla danych) lub 0
    
          memcpy((char*)Buf_8 + 32, &Kat_Pliku, 32);
    
    // Zerowe ENTRIES 1 SEC
          for(x1f = 64; x1f < 512; x1f++)
           Buf_8[x1f] = 0;

    // Zapisz nowy katalog 1 SEC
          secl = DATA_0 + (((unsigned long)XClusf - (unsigned long)2) * SecPerClusL); 
          sech = secl;
          px = (unsigned long)Buf_8;
          write_n_sec_p((char*)px);
          //write_n_sec_p(Buf_8);
    
    // Zerowe ENTRIES n SEC
          for(x1f = 0; x1f < 512; x1f++)
           Buf_8[x1f] = 0;
    
    // Zapisz nowy katalog n SEC

          ixf = SecPerClusL;

          for(x2f = 1; x2f < ixf; x2f++)
          {
           secl = DATA_0 + (((unsigned long)XClusf - (unsigned long)2) * SecPerClusL) + (unsigned long)x2f;
           sech = secl;
           px = (unsigned long)Buf_8;
           write_n_sec_p((char*)px);
           //write_n_sec_p(Buf_8);
          }
    // -----------------------------
         }
// +++++++ TEST ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
           piszs(" OK ");
     }
}
// ---------------------------------------------------------------------------------------------

// =================================================================================
unsigned short Put_1_Okno(unsigned short Klaster_O, unsigned long okno)
{
unsigned short x123, NextClus; //, ClusPerWin, f234;
unsigned short Klaster_X1;

 x123 = 0;
 NextClus = 0;

// Klastry <= 8kB
/* if(SecPerClusL <= (long)16)
 {
  ClusPerWin = 16 / SecPerClusL;

  if(!ClusPerWin)
   ClusPerWin = 1;

  Hot_Klastry[0] = GetFreeFAT(Klaster_O);
  Klaster_X1 = Klaster_O;

  for(f234 = 0; f234 <= ClusPerWin; f234++)
  {
   Klaster_X1 = GetFreeFAT(Klaster_O);
   Hot_Klastry[f234] = Klaster_X1;
   Klaster_O = Klaster_X1 + 1;
   if(!Klaster_X1)
   {
    NextClus = 0;
	break;
   }
  }
  if(Klaster_X1)NextClus = Hot_Klastry[ClusPerWin];

  x123 = 0;
   for(f234 = 0; f234 < ClusPerWin; f234++)
   {
    Klaster = Hot_Klastry[x123];
    x123++;

    if((Klaster > 1) && (Klaster < 0xFFF8))
    {
     Klaster = Klaster - 2;
     secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL);
     sech = (unsigned long)secl + (unsigned long)SecPerClusL - 1L;

     deltax = f234 * 8192 / ClusPerWin;
     error = 0;
	Zapal_SD;
     error = write_n_sec_x(okno);
     Zgas_SD;

    }
   }
 }
 else */
// Klaster >= 8k, dla Ulamek = 1,2.. BigClus-1 -> czytaj, dla Ulamek==BogClus -> czytaj i oblicz NextClus
 if(BigClus)
 {
  Klaster = Klaster_O;
  if(Ulamek == BigClus)
  {
   Klaster_X1 = Klaster;
    if((Klaster_X1 > 1) && (Klaster_X1 < 0xFFF8))
     Klaster_X1 = GetFreeFAT(Klaster_X1+1);
   NextClus = Klaster_X1;
  }
  else
  {
   if((Klaster_O > 1) && (Klaster_O < 0xFFF8))
    Klaster = GetFreeFAT(Klaster_O);
   NextClus = Klaster;
  }
  Hot_Klastry[0] = Klaster;

    if((Klaster > 1) && (Klaster < 0xFFF8))
    {
     Klaster--;
     Klaster--;

	 if(Ulamek == 1)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL);
	 if(Ulamek == 2)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)16;
	 if(Ulamek == 3)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)32;
	 if(Ulamek == 4)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)48;
	 if(Ulamek == 5)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)64;
	 if(Ulamek == 6)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)80;
	 if(Ulamek == 7)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)96;
	 if(Ulamek == 8)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)112;


     sech = (unsigned long)secl + (unsigned long)15;

     error = 0;
     Zapal_SD;
	error = write_n_sec_x(okno);
     Zgas_SD;

     Ulamek++;
	 if(Ulamek > BigClus)
	  Ulamek = 1;
    }
 }
 return(NextClus);
}
// =================================================================================

// =================================================================================
unsigned short Put_1_Okno_X(unsigned short Klaster_O, unsigned long okno)
{
unsigned short x123, NextClus; //, ClusPerWin, f234;
unsigned short Klaster_X1;

 x123 = 0;
 NextClus = 0;

// Klaster >= 8k, dla Ulamek = 1,2.. BigClus-1 -> czytaj, dla Ulamek==BogClus -> czytaj i oblicz NextClus
 if(BigClus)
 {
  Klaster = Klaster_O;
  if(Ulamek == BigClus)
  {
   Klaster_X1 = Klaster;
    if((Klaster_X1 > 1) && (Klaster_X1 < 0xFFF8))
     Klaster_X1 = GetFreeFATX(Klaster_X1+1);
   NextClus = Klaster_X1;
  }
  else
  {
   if((Klaster_O > 1) && (Klaster_O < 0xFFF8))
    Klaster = GetFreeFATX(Klaster_O);
   NextClus = Klaster;
  }
  Hot_Klastry[0] = Klaster;

    if((Klaster > 1) && (Klaster < 0xFFF8))
    {
     Klaster--;
     Klaster--;

	 if(Ulamek == 1)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL);
	 if(Ulamek == 2)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)16;
	 if(Ulamek == 3)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)32;
	 if(Ulamek == 4)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)48;
	 if(Ulamek == 5)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)64;
	 if(Ulamek == 6)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)80;
	 if(Ulamek == 7)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)96;
	 if(Ulamek == 8)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)112;


     sech = (unsigned long)secl + (unsigned long)15;

     error = 0;
     Zapal_SD;
	error = write_n_sec_x(okno);
     Zgas_SD;

     Ulamek++;
	 if(Ulamek > BigClus)
	  Ulamek = 1;
    }
 }
 return(NextClus);
}
// =================================================================================

unsigned short Put_1_Okno_Y(unsigned short Klaster_O, unsigned long okno)
{
unsigned short x123, NextClus; //, ClusPerWin, f234;
unsigned short Klaster_X1;

 x123 = 0;
 NextClus = 0;

// Klaster >= 8k, dla Ulamek = 1,2.. BigClus-1 -> czytaj, dla Ulamek==BigClus -> czytaj i oblicz NextClus
 if(BigClus)
 {
  Klaster = Klaster_O;
  if(Ulamek == BigClus)
  {
   Klaster_X1 = Klaster;
    if((Klaster_X1 > 1) && (Klaster_X1 < 0xFFF8))
     Klaster_X1 = GetFreeFATY(Klaster_X1+1);
   NextClus = Klaster_X1;
  }
  else
  {
   if((Klaster_O > 1) && (Klaster_O < 0xFFF8))
    Klaster = GetFreeFATY(Klaster_O);
   NextClus = Klaster;
  }
  Hot_Klastry[0] = Klaster;

    if((Klaster > 1) && (Klaster < 0xFFF8))
    {
     Klaster--;
     Klaster--;

	 if(Ulamek == 1)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL);
	 if(Ulamek == 2)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)16;
	 if(Ulamek == 3)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)32;
	 if(Ulamek == 4)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)48;
	 if(Ulamek == 5)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)64;
	 if(Ulamek == 6)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)80;
	 if(Ulamek == 7)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)96;
	 if(Ulamek == 8)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)112;


     sech = (unsigned long)secl + (unsigned long)15;

     error = 0;
     Zapal_SD;
	error = write_n_sec_x(okno);
     Zgas_SD;

     Ulamek++;
	 if(Ulamek > BigClus)
	  Ulamek = 1;
    }
 }
 return(NextClus);
}
// =================================================================================

unsigned short Put_1_Okno_Z(unsigned short Klaster_O, unsigned long okno)
{
unsigned short x123, NextClus; //, ClusPerWin, f234;
unsigned short Klaster_X1;

 x123 = 0;
 NextClus = 0;

// Klaster >= 8k, dla Ulamek = 1,2.. BigClus-1 -> czytaj, dla Ulamek==BigClus -> czytaj i oblicz NextClus
 if(BigClus)
 {
  Klaster = Klaster_O;
  if(Ulamek == BigClus)
  {
   Klaster_X1 = Klaster;
    if((Klaster_X1 > 1) && (Klaster_X1 < 0xFFF8))
     Klaster_X1 = GetFreeFATZ(Klaster_X1+1);
   NextClus = Klaster_X1;
  }
  else
  {
   if((Klaster_O > 1) && (Klaster_O < 0xFFF8))
    Klaster = GetFreeFATZ(Klaster_O);
   NextClus = Klaster;
  }
  Hot_Klastry[0] = Klaster;

    if((Klaster > 1) && (Klaster < 0xFFF8))
    {
     Klaster--;
     Klaster--;

	 if(Ulamek == 1)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL);
	 if(Ulamek == 2)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)16;
	 if(Ulamek == 3)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)32;
	 if(Ulamek == 4)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)48;
	 if(Ulamek == 5)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)64;
	 if(Ulamek == 6)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)80;
	 if(Ulamek == 7)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)96;
	 if(Ulamek == 8)
	  secl = (unsigned long)DATA_0 + ((unsigned long)Klaster * (unsigned long)SecPerClusL) + (unsigned long)112;


     sech = (unsigned long)secl + (unsigned long)15;

     error = 0;
     Zapal_SD;
	error = write_n_sec_x(okno);
     Zgas_SD;

     Ulamek++;
	 if(Ulamek > BigClus)
	  Ulamek = 1;
    }
 }
 return(NextClus);
}
// =================================================================================

void Write_dot_DIR(unsigned short Indexb)
{
// Write_dot_DIR
unsigned short secd, pages, pagep, f, ff, Klast;
unsigned long secx, secy, px;
 
 secx = secl;
 secy = sech;

 secd = Indexb >> 4; // numer sektora DIR
 pages = secd << 4;
 pagep = pages + 15;

 ff = 0;
 DI;
 for(f=pages; f<=pagep; f++)
 {
  px = (unsigned long)Buf_8 + ff;
  ch_ptr = (char*)px;
  RD_SRAM(f<<5, ch_ptr);
  ff += 32;
 }
 EI;

 Klast = Klaster_dot;
 Klast--;
 Klast--;

 secl = DATA_0 + ((unsigned long)Klast * (unsigned long)SecPerClusL);
 secl = secl + secd;
 sech = secl;
 
 px = (unsigned long)Buf_8 - (unsigned long)Tab_8;
 write_n_sec_x(px);
 //error = write_n_sec_p(Buf_8);

 secl = secx;
 sech = secy;
}
//---------------------------------------------------------------------------

// =================================================================================
void Write_root_DIR(unsigned short Indexb)
{
// Write_root_DIR
unsigned short secd, pages, pagep, f;
unsigned long secx, secy, ff, px;
 
 secx = secl;
 secy = sech;

 secd = Indexb >> 4; // numer sektora DIR
 pages = secd << 4;
 pagep = pages + 15;

 ff = 0;
 DI;
 for(f=pages; f<=pagep; f++)
 {
  px = (unsigned long)Buf_8 + ff;
  ch_ptr = (char*)px;
  RD_SRAM(f<<5, ch_ptr);
  ff += (unsigned long)32;
 }
 EI;

 secl = (unsigned long)DIR_0;
 secl = secl + secd;
 sech = secl;
 
 px = (unsigned long)Buf_8 - (unsigned long)Tab_8;
 write_n_sec_x(px);
// error = write_n_sec_p(Buf_8);

 secl = secx;
 sech = secy;
}
//---------------------------------------------------------------------------

// Test ---------------------------
void Read_STA015(void)
    {
unsigned long xx, yy;
     piszs(" Read STA015: SubAddr:");
     xx = gethex();
     if(!ESC)
     {
      yy = i2c_read_STA015(xx);
      if(yy == -1) 
      {
       piszs("NACK");
      }
      else
      {
       piszs("< Data=");
       piszhex(yy);
      }
      piszc(' ');
     }
    }

// Test ---------------------------
void Write_STA015(void)
    {
unsigned long xx, yy;
     piszs(" Write STA015: SubAddr:");
     xx = gethex();
     if(!ESC)
     {
      piszs("< Data:");
      yy = gethex();
      if(!ESC)
      {
       piszs("< ");
       yy = i2c_write_STA015(xx, yy);
       if(yy == -1) 
       {
        piszs("NACK");
       }
      }
     }
    }

// ---------------------------------

unsigned char bin2bcd(unsigned char xyz)
{
// We = liczba (bajt) 0..255
// Wy = BCDH = najstarsza cyfra (np 2), BCDL = 2 najmlodsze cyfry (np 55)
 char xx;
 BCDH = xyz / 100;
 xx = xyz % 100; 	// reszta z dzielenia przez 100
 BCDL = xx / 10;
 BCDL = BCDL << 4;
 xx = xx % 10; 		// reszta z dzielenia przez 10
 xx = BCDL + xx;
 BCDL = xx;
 return xx;
}
// ---------------------------------

unsigned char bcd2bin(unsigned char xyz)
{
 char xx, yy;
 xx = xyz & 0xf0;
 xx = xx >> 4;
 xx = xx * 10;
 yy = xyz & 0x0f;
 yy = xx + yy;
 return yy;
}
// ---------------------------------

unsigned short Get_Index(void)
{
unsigned short f123, s123, s0, p123;
unsigned short pages, pagep, f;
unsigned long ff;

 p123 = 0;
 pages = 0;
 pagep = 7; // DIR_R
 s123 = 0;
 if(DIR_DOT)
 {
  s0 = 2;
  s123 = 2;
 }
 else
 {
  s0 = 0;
  s123 = 0;
 }
   
 while(s123 < CurrDirEnt)
 {
  ff = 0;
  for(f=pages; f<=pagep; f++)
  {
   ch_ptr = DIR0 + ff;   // DIR_R
   RD_SRAM(f<<5, ch_ptr);
   ff += (unsigned long)32;
  }

  for(f123 = s0; f123 < 8 ; f123++)
  {
   if((DIR0[f123<<5] == 0) || (DIR0[f123<<5]==0xE5))    // DIR_R
    if(DIR0[(f123<<5)+0x0B] != 0x0F)                // DIR_R
     p123++;
  if(p123)
   break;
  }
  if(p123)
   break;
  s123 += 8;
  s123 -= s0;
  s0 = 0;
  pages = pages + 8;
  pagep = pages + 7;
 }

 return(f123 + s123 - s0);
}
//---------------------------------------------------------------------------

unsigned long Set_Word(unsigned long wsk, unsigned short dat)
{
unsigned long nnnn;
 nnnn = Tab_32_USB[wsk/2];
 if(wsk & 1)
     {
      nnnn = nnnn & 0x0000FFFF; 
      nnnn = nnnn | (unsigned long)dat << 16;
     }
 else
     {
      nnnn = nnnn & 0xFFFF0000;
      nnnn = nnnn | (unsigned long)dat;
     }
 Tab_32_USB[wsk/2] = nnnn;
 return nnnn;
}

//---------------------------------------------------------------------------
unsigned short Get_Word(unsigned long wsk)
{
unsigned long nnnn;
 nnnn = Tab_32_USB[wsk/2];
 if(wsk & 1)
      nnnn = nnnn >> 16;
 nnnn = nnnn & 0x0000FFFF; 
 return (unsigned short)nnnn;
}

//---------------------------------------------------------------------------
void MazaniePlikow(unsigned int Index_M)
{
// Mazanie plikow
unsigned long  x123, x234, fx, px, Ix_min, Ix;
unsigned short Klaster_M; // KReturn, DotEnt, KBack;
// unsigned char RDot;

   DISK_32_B = 0x76543210; // Wylacz 32 bitowy dostep do plikow
   x234 = 0;

   if(Index_M > 7)
        Ix_min = Index_M - 7;
   else
        Ix_min = 0;

   px = Index_M - Ix_min;

   for(fx = 0; fx <= px; fx++)
       {
         ch_ptr = (void*)DIR0 + (fx<<5); // DIR_R
         RD_SRAM((Ix_min + fx)<<5, ch_ptr);
       }

   ch_ptr = (void*)DIR0 + (px<<5);
   memcpy(&Kat_Pliku, ch_ptr, 32);
   Klaster = Kat_Pliku.Klaster;
   Klaster_M = Klaster;
   Atrybut = Kat_Pliku.Atrybuty;
//	Atrybut = Atrybut & ~0x20; // 0x20 = Archive
   if((Atrybut == 0x20) && (Kat_Pliku.Name[0] != '.'))
    {
// Pliki Normalne
   Kat_Pliku.Name[0] = 0xE5;
   x234++;
   ch_ptr = (void*)DIR0 + (px<<5);
   memcpy(ch_ptr, &Kat_Pliku, 32);

   piszs("*Del*");

// Mazanie wpisow LFN
   if(px)
        {
         Ix = px - 1;
         while(Ix >= Ix_min)
            {
            if(DIR0[(Ix<<5)+0x0B] == 0x0F)
                {
                DIR0[Ix<<5] = 0xE5;
                Ix--;
                }
            else
                break;
            }
// ----- Test ------------------------------------------------------------------------
         piszs("L");
        }

// Zapisz zmiany
   for(fx = 0; fx <= px; fx++)
         {
          ch_ptr = (void*)DIR0 + (fx<<5);
          WR_SRAM((Ix_min + fx)<<5, ch_ptr);
         }
// ----- Test ------------------------------------------------------------------------
     piszs("R");

// ----- TEST 0001 Start ------------------------------------------------------------
     for(fx = 0; fx < 128; fx++)
       {
        px = (unsigned long)Buf_8_2k + (unsigned long)0x5000 + (unsigned long)(fx<<5);
        ch_ptr = (char*)px;
        RD_SRAM(fx<<5, ch_ptr);
       }
// TEST 0001 End ---------------------------------------------------------------------

   if(DIR_DOT) // (DIR_DOT==0)
       {
            if((Index_M & 0x7FF0) != (Ix_min & 0x7FF0))
                Write_dot_DIR(Ix_min);
            Write_dot_DIR(Index_M);
       }
	 else
       {
            if((Index_M & 0x7FF0) != (Ix_min & 0x7FF0))
                Write_root_DIR(Ix_min);
            Write_root_DIR(Index_M);
       }
// ----- Test ------------------------------------------------------------------------
     piszs("D");

   FATZmod = 0;
	 while(Klaster_M > 1)
     {
      x123 = GFAT0(Klaster_M);
      if(!x123)
        break;
      FATZmod = 1;
      DelFAT(Klaster_M);
      if(x123 == 0xFFFF)
        break;
      Klaster_M = x123;
     }
     Zapisz_FATy();
     //if(error)Zapisz_FATy();
// ----- Test ------------------------------------------------------------------------
     piszs("F");

     x234 = 1;
    }
    /*else
    {
     if(Atrybut == 0x10)
     {
      KBack = Klaster_M;
      KReturn = Klauster_dot; // ?
	  if(Klaster)
      {
       RDot= DIR_DOT;
       Read_DIR(Klaster_M); // Klaster INDEX  ....
       DIR_DOT = 1;
      }

      DotEnt = Plikow + DIRow;
      if(DIRow>=2)DotEnt = DotEnt - 2; // "." & ".."

//      Index_X = Index_X_r;
      if(RDot)
      {
       Read_DIR(KReturn);
       DIR_DOT = 1;
      }
      else
      {
       Read_DIR(0);
       DIR_DOT = 0;
      }
      if(!DotEnt)
      {
       memcpy(&Kat_Pliku, DIR0+(Index_M<<5), 32);
       Kat_Pliku.Name[0] = 0xE5;
       memcpy(DIR0+(Index_M<<5), &Kat_Pliku, 32);
       x234++;
// Mazanie wpisow LFN
       Ix_mn = Index_M;
       while(Ix_mn >= 1)
       {
        if((DIR0[(32 * (Ix_mn - 1))+0x0B] & 0x00FF)==0x0F)
        {
         DIR0[32 * (Ix_mn - 1)] = 0xE5;
         Ix_mn--;
        }
        else
         break;
       }
// -----

       if(DIR_DOT)
	    Write_DIR(Ix_mn);
	   else
	    Write_DIR(0);

       FATZmod = 1;
	   while(KBack > 1)
       {
        x123 = GFAT0(KBack);
        SetFAT(KBack, 0);
        if((unsigned int)x123 >= 0xFFF8)break;
        KBack = x123;
       }
       Zapisz_FATy();
       if(error)Zapisz_FATy();
      }
     }
    }*/

  if(x234)
  {
//   Zapis_FAT();

   if(DIR_DOT)
    Read_DIR(Klaster_dot);
   else
    Read_DIR(0);

//   Wyswietl_PLIKI();

  }
  delayx(0x000F3210);
}
// --------------------------------------------------------------------
unsigned short GetTimeF(void)
{
unsigned short x1, x2;

 x1 = RTC_SEC;
 x1 = x1 >> 1;

 x2 = RTC_MIN;
 x2 = x2 << 5;

 x2 = x2 | x1;

 x1 = RTC_HOUR;
 x1 = x1 << 11;

 x2 = x2 | x1;

 return(x2);
}
//-------------------------------------------------------------------------

unsigned short GetDateF(void)
{
unsigned short x1, x2;

 x1 = RTC_DOM;

 x2 = RTC_MONTH;
 x2 = x2 << 5;

 x2 = x2 | x1;

 x1 = RTC_YEAR - 1980; // 2011, 2012 ...
 x1 = x1; // 0 - 1980, 20 - 2000
 x1 = x1 << 9;

 x2 = x2 | x1;

 return(x2);
}
// ------------------------------------------------------------------------

unsigned short getpilot(void)
{
 unsigned short mxl, ffl, yyl, res;
 mxl = 0;
 res = 0;
           pilotm &= 0x0007; // Pilot_w;
           for(ffl=0; ffl<8; ffl++)
           {
               yyl = PILOT_L[pilotm];
               if(yyl != 0xC000)
                  {
                   PILOT_L[pilotm] = 0xC000;
                   if((Pilot_o != yyl) && (yyl & 0x2000))
                   {
                       res = (yyl & 0x07C0) << 2;
                       if(!res)
                         res = 0x0700;
                       res |= yyl & 0x003F;
                       mxl++;
                       repp = 3;
                   }
                   if((Pilot_o == yyl) && (yyl & 0x2000) && (repp == 0))
                   {
                       res = (yyl & 0x07C0) << 2;
                       if(!res)
                         res = 0x0700;
                       res |= yyl & 0x003F;
                       mxl++;
                   }
                   if((Pilot_o == yyl) && (yyl & 0x2000) && repp)
                       repp--;
                   Pilot_o = yyl;
                  }
               pilotm++;
               pilotm &= 0x0007;
               if(mxl)
                   break;
           }
return res;
}
// -------------------------------------------------------------------------

int RDS_RD(char *buff)
{
int mx_, my_, cx_, cy_, ff_, ret_;
int c1_, c2_, c3_, c4_, c5_, c6_, c7_;
// unsigned short RDSA, RDSB, RDSC, RDSD, RDSDn[4], RDSDx, RDSs, RDS_In[8], RDSt[8], AB, CD;
//   RDSDx = 0;
   ret_ = 0;

 if(SAA6588 == 0x22)
  {
   if((FIO3PIN & DAVN_M)==0) // tylko dla na DAVN = '0'
   {
    for(ff_ = 0; ff_ < 8; ff_++)
       {
           RDS_In[ff_] = 0; // A, B, C, D
           RDSt[ff_] = 0; // 0x10, 0x30, 0x50, 0x70
       }
   
       my_ = 0;
       cx_ = 0;
       cy_ = 0;
       Timer_2 = 46;
   
       for(ff_ = 0; ff_ < 8; ff_ += 2)
       {
           // Pobierz max 8 slow
           Timer_1 = 12;
           while((FIO3PIN & DAVN_M) && Timer_1); // czekam na DAVN = '0'
           if(!Timer_2)return 0xFE; 
           c1_ = -1;
           if((FIO3PIN & DAVN_M)==0)
               c1_ = i2c1_read_a1(0x23);
           if(c1_ >= 0)
           {    
               c2_ = i2c1_read_dn();
               c3_ = i2c1_read_dn();
               c4_ = i2c1_read_dn();
               c5_ = i2c1_read_dn();
               c6_ = i2c1_read_dn();
               c7_ = i2c1_read_de();
           }
           else
           {
               cy_ = 7;
               break;
           }
   
           mx_ = c1_ & 0xF0;
           if((mx_ == 0xF0) || (mx_ == 0xE0))
               cy_++;
   
           // mx_ = 0x10 -> A1, D0
           // mx_ = 0x30 -> B1, A1
           // mx_ = 0x50 -> C1, B1
           // mx_ = 0x70 -> D1, C1
   
           // Sekwencje 'dobre': 0x30, 0x70 lub 0x50, 0x10
   
           RDSt[ff_] = mx_;
           if(((c1_ & 0x03) < 3) && (c1_ & 0x10))// Stopa bledow < 3 i synchronizacja
           {
               AB = c5_ | (c4_ << 8);
               CD = c3_ | (c2_ << 8);
               RDS_In[ff_] = AB;
               RDS_In[ff_+1] = CD;
           }
   
           if(ff_ >= 2)
           {    
               my_ = (RDSt[ff_-2] << 8) + mx_; 
               switch(my_)
               {
               case 0x5010: // B1, C1, D1, A2 
                   RDSB = RDS_In[ff_-2];
                   RDSD = RDS_In[ff_];
                   cx_++;
                   break;
   
               case 0x3070: // A1, B1, C1, D1
                   RDSB = RDS_In[ff_-1];
                   RDSD = RDS_In[ff_+1];
                   cx_++;
                   break;
               }
   
           }
           if(cx_ || (cy_ > 3))
               break;
           if(!Timer_2)return 0xFE;
       }
   
       if(cy_ > 3)
       {
           strcpy(buff, " R D S..");
           return(0x1E); // ERROR
       }
       if(!Timer_2)return 0xFE;
   
      if((RDSB & 0xF800) == 0 ) // Grupa 0A
      {
          mx_ = RDSB & 0x0003; // index znakow
          switch(mx_)
          {
          case    0x00  : if(RDSD)
                          {
                          RDSDn[0] = RDSD;
                          RDSDx |= 0x01;
                          }
                          break;   
          case    0x01  : if(RDSD)
                          {
                          RDSDn[1] = RDSD;
                          RDSDx |= 0x02;
                          }
                          break;   
          case    0x02  : if(RDSD)
                          {
                          RDSDn[2] = RDSD;
                          RDSDx |= 0x04;
                          }
                          break;   
          case    0x03  : if(RDSD)
                          {
                          RDSDn[3] = RDSD;
                          RDSDx |= 0x08;
                          }
                          break;   
          }
          if(!Timer_2)return 0xFE;
          if(RDSDx == 0x0F)
          {
            strcpy(RDS_PS1, RDS_PS0);
              RDS_PS0[0] = RDSDn[0] >> 8;
              RDS_PS0[1] = RDSDn[0] & 0x00FF;
              RDS_PS0[2] = RDSDn[1] >> 8;
              RDS_PS0[3] = RDSDn[1] & 0x00FF;
              RDS_PS0[4] = RDSDn[2] >> 8;
              RDS_PS0[5] = RDSDn[2] & 0x00FF;
              RDS_PS0[6] = RDSDn[3] >> 8;
              RDS_PS0[7] = RDSDn[3] & 0x00FF;
              RDSDx = 0;
              strcpy(buff, RDS_PS1);
   
            if(!strcmp(RDS_PS0, RDS_PS1))
              ret_ = 1; // OK
            else
              ret_ = 2; // Prawie OK
          }
          if(!Timer_2)
              {
               ret_ = 0xFE;
              }
      }
   }
  }
 return(ret_);    
}
// -------------------------------------------------------------------------

int Inic_Tuner(void)
{
int xxt;
                //FIO4SET |= 0x10000000;
                //delayx(0x0003);

                xxt = 0xC0;
                xxt = i2c_write_a(xxt);
                if(xxt >= 0)
                {
                     xxt = freq >> 8; // 2C 1E (1D)
                     xxt = i2c_write_dn(xxt);

                     xxt = freq & 0x00FF; // 3D 26 (A2) [93MHx (88,4MHz)]
                     xxt = i2c_write_dn(xxt);

                     if(VnC == 0)
                       xxt = 0x00; // LOW/HIGH side: bit 4
                     else
                       xxt = 0x91; // LOW/HIGH side: bit 4
                     xxt = i2c_write_dn(xxt);

                     if(VnC == 0)
                       xxt = 0x00; // SWP2[7], XTAL 32k [4]
                     else
                       xxt = 0x80; // SWP2[7], XTAL 32k [4]
                       
                     xxt = i2c_write_dn(xxt);

                     xxt = 0x00; // 40 - De-emphasis - bit 6: 0 -> 50us, 1 -> 75us
                     xxt = i2c_write_de(xxt);

                     xxt = 0;
                }
                else
                {
                  I20CONCLR = 0xFF;
                  I20CONSET = 0x40;
                  xxt = 0xFE;
                }
                //FIO4CLR |= 0x10000000;
                //delayx(0x0001);
                //FIO4SET |= 0x10000000;
 return(xxt);
}      
// -----------------------------------------------------------------------------

int TEA_Quality(void)
{
    int xx;
    xx = i2c_read_a1(0xC1);
    if(xx >= 0)
        {
         TEA_Tuned = xx >> 7;

         xx = i2c_read_dn(); // d2 = PLL L

         xx = i2c_read_dn(); // d3 STERE0, IF
         TEA_ST = xx >> 7;
         TEA_IF = xx & 0x007F;
                              
         xx = i2c_read_de(); // d4 Level, 0000
         TEA_Poziom = xx >> 4;
         xx = TEA_Poziom;
        }
    else
        xx = 0;
 return xx;
}
// -----------------------------------------------------------------------------

int KlawX(void)
{
int xx, yy;

  if(Frames > Blok_6)
    Blok_6 = 0;

  if(Frames > Blok_7)
    Blok_7 = 0;

  if(Frames_Sh && (Frames > Frames_Sh))
    {
      Shift = 0;
      Frames_Sh = 0;
      KOLORLED = LedNieb;
      CTRL1 = (CTRL1 & 0xC3) | (KOLORLED << 4) | (OUTX << 2);
      LD_Latch_n(CTRL1, 1);
    }

    xx = uart0Getch();
    if(xx >= 0)LastU = xx; // Odtatni znak z uart0
    if(xx < 0) // PILOT
      {
       xx = getpilot();
       if(xx > 0)
         {
          // Przemapuj
          // Kody 0x05, 0x07, 0x10, 0x12, 0x14
          yy = xx >> 8;
          if((yy==0x07)||(yy==0x10)||(yy==0x12)||(yy==0x14))
            {
             yy = xx & 0x00FF;
             xx = -1;
             switch(yy)
               {
               case 0x00  : xx = '0';
                            break;
               case 0x01  : xx = '1';
                            break;
               case 0x02  : xx = '2';
                            break;
               case 0x03  : xx = '3';
                            break;
               case 0x04  : xx = '4';
                            break;
               case 0x05  : xx = '5';
                            break;
               case 0x06  : xx = '6';
                            break;
               case 0x07  : xx = '7';
                            break;
               case 0x08  : xx = '8';
                            break;
               case 0x09  : xx = '9';
                            break;
               case 0x26  : xx = 0x0D; // OK
                            break;
               case 0x35  : xx = 0x0D; // START
                            break;
               case 0x36  : xx = 0x1B; // STOP
                            break;
               case 0x20  : xx = '>'; // CH+
                            break;
               case 0x21  : xx = '<'; // CH-
                            break;
               case 0x34  : xx = '>'; // CH+
                            break;
               case 0x32  : xx = '<'; // CH-
                            break;
               case 0x3F  : xx = 'm'; // MENU
                            break;
               case 0x0C  : xx = 'Y'; // WYL
                            break;
               case 0x10  : xx = '+'; // Vol+
                            break;
               case 0x11  : xx = '-'; // Vol-
                            break;
               case 0x0D  : MUTE_On();
                            Mute_Abs++;
                            break;
               default:     break;
               }
            }
         }
       else
         xx = -1;
      }
    if(xx < 0)
      {
        if(LZN) // Odczyt KLAWIATURY
            {
                xx = Buf_Zn[IXL] + 0x30;
                DI;
                LZN--;
                EI;
                IXL++;
                IXL &= 0x07;

                if(xx == '1') // Shift
                   {
                    xx = -1;
                    Shift++;
                    if(Shift == 3)
                        Shift = 0;
                    switch(Shift)
                     {
                        case    0   :   KOLORLED = LedNieb;
                                    break;
                        case    1   :   KOLORLED = LedZiel;
                                    break;
                        case    2   :   KOLORLED = LedZolt;
                                    break;
                        default     :   KOLORLED = LedNieb;
                                    break; 
                     }
                    CTRL1 = (CTRL1 & 0xC3) | (KOLORLED << 4) | (OUTX << 2);
                    LD_Latch_n(CTRL1, 1);
                   }
                else
                   {
                    // --- PRZEMAPUJ KLAWISZE - '2', '3', ... '8' -------------------------------------------
                    // Tlumienie impilsow
                    if(xx == '6')
                      {
                       if(!Blok_6)
                         {
                           Blok_6 = Frames + 50; // Impuls '+' co 0.25s
                           Blok_7 = Frames + 99;
                         }
                       else
                         xx = 0;
                      }
                    if(xx == '7')
                      {
                       if(!Blok_7)
                         {
                           Blok_7 = Frames + 40; // Impuls '-' co 0.2s
                           Blok_6 = Frames + 99;
                         }
                       else
                         xx = 0;
                      }
                    if(xx)
                      {
                        xx = xx - 0x31; // xx = 0..7
                        xx = KEY_X[xx][Shift];
                        if(Shift && (xx != '<') && (xx != '>') && (xx != ',') && (xx != '.'))
                         {
                          Shift = 0;
                          Frames_Sh == 0;
                          KOLORLED = LedNieb;
                          CTRL1 = (CTRL1 & 0xC3) | (KOLORLED << 4) | (OUTX << 2);
                          LD_Latch_n(CTRL1, 1);
                         }
                        if((xx == '<') || (xx == '>') || (xx == ',') || (xx == '.'))
                          Frames_Sh = Frames + 600; // 600 -> 3s  Shift chwilowy  
                      }
                    else
                      xx = -1;
                   }
            }
      }

    if(Unmute_F)
      Unmute();
    if((xx == '+')||(xx=='-'))
      Mute_Abs = 0;

 if(xx >= 0)LKey = xx;
 return xx;
}
// -----------------------------------------------------------------------------

int getch(void)
{
int ch;
 do
 {
   ch = KlawX(); // uart0Getch();
 } while(ch < 0);   // czekaj na znak (-1 brak znaku)
 return ch;
}

int getchu(void)
{
int chu;
 do
 {
   chu = uart0Getch();
 } while(chu < 0);   // czekaj na znak (-1 brak znaku)
 LastU = chu; // Odtatni znak z uart0
 return chu;
}

unsigned char Vol_SPK(short vol)
{
short vL, vR, vC, vS, vLs, vRs, KorD;

  vol &= 0x007F;
  vL = vol;
  KorD = 0;

  if(SPDIF && (act_decoder == 1))
     KorD = 6;
  if(SPDIF && (act_decoder == 2))
     KorD = 3;
  if(DSP_En && DSP_X)
     KorD += 3;

  vL = vol + KorD;
  if(vL > 127)
    vL = 127;
  vR = vol + BlR + KorD;
  if(vR > 127)
    vR = 127;
  if(vR < 26)
    vR = 26;
  vC = vol + BlC + KorD + KorC;
  if(vC > 127)
    vC = 127;
  if(vC < 26)
    vC = 26;
  vS = vol + BlS + KorD;
  if(vS > 127)
    vS = 127;
  if(vS < 26)
    vS = 26;
  vLs = vol + BlLs + KorD;
  if(vLs > 127)
    vLs = 127;
  if(vLs < 26)
    vLs = 26;
  vRs = vol + BlRs + KorD;
  if(vRs > 127)
    vRs = 127;
  if(vRs < 26)
    vRs = 26;
  write_WM8770(0x00, vL); // DACL1 7F->0dB, 79->-6dB ...
  write_WM8770(0x01, vR); // DACR1 7F->0dB, 79->-6dB ...
  write_WM8770(0x02, vC); // DACL2 7F->0dB, 79->-6dB ...
  write_WM8770(0x03, vS); // DACR2 7F->0dB, 79->-6dB ...
  write_WM8770(0x04, vLs); // DACL3 7F->0dB, 79->-6dB ...
  write_WM8770(0x05, 0x0100 + vRs); // DACR3 7F->0dB, 79->-6dB ... bit[8]-Update
  return vol;
}
// =======================================================================+=====

void Balance(int *Blx, short lim)
{
short _uc;
             if(*Blx > lim)
               *Blx = lim;
             if(*Blx < -lim)
               *Blx = -lim;
             if(*Blx < 0)
             {
               piszc('-');
               piszdec(-*Blx, 0);
             }
             else
             {
               piszc('+');
               piszdec(*Blx, 0);
             }
             piszs(") ");
             _uc = getch();
             while((_uc == '-') || (_uc == '+'))
             {
               if(_uc == '-')
                 *Blx -= 1;
               else
                 *Blx += 1;
               if(*Blx > lim)
                 *Blx = lim;
               if(*Blx < -lim)
                 *Blx = -lim;
               Vol_SPK(VOL_SPK);
               gotoxy(20,2);
               if(*Blx < 0)
               {
                 piszc('-');
                 piszdec(-*Blx, 0);
               }
               else
               {
                 piszc('+');
                 piszdec(*Blx, 0);
               }
               piszs(") ");
               _uc = getch();

             }

}
// =======================================================================+=====

unsigned char Vol_PH(short vol)
{
  vol = vol & 0x1F;
   i2c1_write_a(0x8C);
   i2c1_write_dn(0x06); // Att LF (X, Auto-Zero, Test, Increment, 3, 2, 1, 0) [L Phones]
   i2c1_write_de(0xC0 + vol); // C0 -> 0dB, D0 -> -16dB, D4 -> -20dB, DB -> -30dB, DE -> -40db

//   i2c1_write_a(0x8C);
//   i2c1_write_dn(0x07); // Att LR [L Surroud]
//   i2c1_write_de(0xC3); // C0 -> 0dB, D0 -> -16dB, D4 -> -20dB, DB -> -30dB, DE -> -40db

   i2c1_write_a(0x8C);
   i2c1_write_dn(0x08); // Att RF, Output 15 & 16 [R Phones]
   i2c1_write_de(0x80 + vol); // 80 -> 0dB, 90 -> -16dB, 94 -> -20dB, 9B -> -30dB, 9E -> -40db

//   i2c1_write_a(0x8C);
//   i2c1_write_dn(0x09); // Att RR, Blank time [L Surroud]
//   i2c1_write_de(0x83); // 80 -> 0dB, 90 -> -16dB, 94 -> -20dB, 9B -> -30dB, 9E -> -40db

   return vol;
}
// =======================================================================+=====

unsigned char Set_Vol_SPK(char plusm)
{
         if(plusm == '+') // '+'
         {
           if(VOL_SPK < 0x7F)
             VOL_SPK++;
           if(VOL_SPK < 0x7F)
             VOL_SPK++;
           if(VOL_SPK < 0x7F)
             VOL_SPK++;
         }
         else
         {
           if(VOL_SPK > 0x1B) // 0x1A - MUTE
             VOL_SPK--;
           if(VOL_SPK > 0x1B) // 0x1A - MUTE
             VOL_SPK--;
           if(VOL_SPK > 0x1B) // 0x1A - MUTE
             VOL_SPK--;
           if(VOL_SPK > 0x1B) // 0x1A - MUTE
             VOL_SPK--;
         }
         Vol_SPK(VOL_SPK);

         return VOL_SPK;
}
// =======================================================================+=====


unsigned char Set_Vol_Spk(char plusm)
{
         if(plusm == '+') // '+'
         {
           if(VOL_SPK < 0x7F)
             VOL_SPK++;
         }
         else
         {
           if(VOL_SPK > 0x1B) // 0x1A - MUTE
             VOL_SPK--;
         }
         Vol_SPK(VOL_SPK);

         return VOL_SPK;
}
// =======================================================================+=====

void linia1(char x1, char x2)
{
    char f;
    gotoxy(x1, 1);
    for(f=x1;f<x2;f++)
        {
         piszc(' ');
        }
    piszs("\n\r");
    gotoxy(x1, 1);
}
// =======================================================================+=====

void linia2(char x1, char x2)
{
    char f;
    gotoxy(x1, 2);
    for(f=x1;f<x2;f++)
        {
         piszc(' ');
        }
    piszs("\n\r");
    gotoxy(x1, 2);
}
// =======================================================================+=====

void WM_Out_Mix(char wm_m1, char wm_m2, char wm_m3, char wm_m4)
{
short _xx, _yy, wm_mode;
    LCD_Off;

    if(wm_m1 & 0xF0)
      wm_m1 = WM_OUT_MXn[1];
    else
      WM_OUT_MXn[1] = wm_m1;

    if(wm_m2 & 0xF0)
      wm_m2 = WM_OUT_MXn[2];
    else
      WM_OUT_MXn[2] = wm_m2;

    if(wm_m3 & 0xF0)
      wm_m3 = WM_OUT_MXn[3];
    else
      WM_OUT_MXn[3] = wm_m3;

    if(wm_m4 & 0xF0)
      wm_m4 = WM_OUT_MXn[4];
    else
      WM_OUT_MXn[4] = wm_m4;

    wm_mode = wm_m1;
    _yy = 0;
    if((wm_m1==wm_mode)&&(wm_m2==wm_mode)&&(wm_m3==wm_mode)&&(wm_m4==wm_mode))
      {
        // Tryb jednakowy dla wszystkich wyjsc
            WM_OUT_MXn[0] = wm_mode;
                if(wm_mode == 5) // 1-DAC, 2-AUX, 4-Bypass, 3-AUX/DAC, 5-Byp./DAC, 7-Bypass/AUX/DAC
                {
                 write_WM8770(0x1C, 0x02D); // Output Mux: MX2(5,4,3) -> Bypass[5], AUX2[4], DAC2[3]; MX1(2,1,0) -> Bypass[2], AUX1[1], DAC1[0]  
                 write_WM8770(0x1D, 0x00D); // Output Mux: MX4(4,3) -> Bypass[4], DAC4[3]; MX3(2,1,0) -> Bypass[2], AUX3[1], DAC3[0]   
                 piszs("*BYP/DAC*");// MX4 nie moze pracowac w trybie Bypass
                 _yy++; 
                }

                if(wm_mode == 1)
                {
                 _xx = 0x009;
                 if(MODE_DIG_F!=2) // DDD
                    _xx |= 0x010; // dolacz C i Sub z AUX2
                 write_WM8770(0x1C, _xx); // Output Mux: MX2(5,4,3) -> Bypass[5], AUX2[4], DAC2[3]; MX1(2,1,0) -> Bypass[2], AUX1[1], DAC1[0]  

                 _xx = 0x009;
                 if(MODE_DIG_F==3) // DDD + DS
                 //   _xx |= 0x004; // dolocz LS i RS z Bypass2
                   {
                    CTRL1 |= CTRL1_DSTEREO_OR;
                    LD_Latch_n(CTRL1, 1);
                   }
                 else
                   {
                    CTRL1 &= CTRL1_DSTEREO_AND;
                    LD_Latch_n(CTRL1, 1);
                   }

                 write_WM8770(0x1D, _xx); // Output Mux: MX4(4,3) -> Bypass[4], DAC4[3]; MX3(2,1,0) -> Bypass[2], AUX3[1], DAC3[0]   
                 piszs("*DAC*");
                 _yy++;
                }

                if(wm_mode == 3) 
                {
                 write_WM8770(0x1C, 0x01B); // Output Mux: MX2(5,4,3) -> Bypass[5], AUX2[4], DAC2[3]; MX1(2,1,0) -> Bypass[2], AUX1[1], DAC1[0]  
                 write_WM8770(0x1D, 0x00B); // Output Mux: MX4(4,3) -> Bypass[4], DAC4[3]; MX3(2,1,0) -> Bypass[2], AUX3[1], DAC3[0]   
                 piszs("*AUX/DAC*");// MX4 nie moze pracowac w trybie Bypass"
                 _yy++; 
                }

                if(wm_mode == 7) 
                {
                 write_WM8770(0x1C, 0x03F); // Output Mux: MX2(5,4,3) -> Bypass[5], AUX2[4], DAC2[3]; MX1(2,1,0) -> Bypass[2], AUX1[1], DAC1[0]  
                 write_WM8770(0x1D, 0x00F); // Output Mux: MX4(4,3) -> Bypass[4], DAC4[3]; MX3(2,1,0) -> Bypass[2], AUX3[1], DAC3[0]   
                 piszs("*BAX/AUX/DAC*");// MX4 nie moze pracowac w trybie Bypass
                 _yy++;                
                }
      }
    
    if(!_yy)
      {
      // Tryb dowolny dla wszystkich wyjsc
      // 0-MUTE, 1-DAC, 2-AUX, 4-Bypass, 3-AUX/DAC, 5-Byp./DAC, 6-Byp./AUX, 7-AUX/Byp./DAC

              _xx = wm_m1 & 0x07;
			  switch(_xx)
			  {
				case 0	: piszs("*1-MUTE*");
					break;
				case 1	: piszs("*1-DAC*");
					break;
				case 2	: piszs("*1-AUX*");
					break;
				case 3	: piszs("*1-AX/DC*");
					break;
				case 4	: piszs("*1-Bypass*");
					break;
				case 5	: piszs("*1-BP/DC*");
					break;
				case 6	: piszs("*1-BP/AX*");
					break;
				case 7	: piszs("*1-BP/AX/DC*");
					break;
			  }
              _yy = wm_m2 & 0x07;
			  switch(_yy)
			  {
				case 0	: piszs("*2-MUTE*");
					break;
				case 1	: piszs("*2-DAC*");
					break;
				case 2	: piszs("*2-AUX*");
					break;
				case 3	: piszs("*2-AX/DC*");
					break;
				case 4	: piszs("*2-Bypass*");
					break;
				case 5	: piszs("*2-BP/DC*");
					break;
				case 6	: piszs("*2-BP/AX*");
					break;
				case 7	: piszs("*2-BP/AX/DC*");
					break;
			  }
              _yy = _yy << 3;
              _xx = _xx | _yy;
              if(MODE_DIG_F!=2) // DDD
                _xx |= 0x010; // dolacz C i Sub z AUX2
              write_WM8770(0x1C, _xx); // Output Mux: MX2(5,4,3) -> Bypass[5], AUX2[4], DAC2[3]; MX1(2,1,0) -> Bypass[2], AUX1[1], DAC1[0]  

              _xx = wm_m3 & 0x07;
			  switch(_xx)
			  {
				case 0	: piszs("*3-MUTE*");
					break;
				case 1	: piszs("*3-DAC*");
					break;
				case 2	: piszs("*3-AUX*");
					break;
				case 3	: piszs("*3-AX/DC*");
					break;
				case 4	: piszs("*3-Bypass*");
					break;
				case 5	: piszs("*3-BP/DC*");
					break;
				case 6	: piszs("*3-BP/AX*");
					break;
				case 7	: piszs("*3-BP/AX/DC*");
					break;
			  }
              _yy = wm_m4 & 0x07;
              if(_yy & 0x04)
                {
                 _yy &= 0x01;
                 _yy |= 0x02;
                }
              _yy &= 0x03;
			  switch(_yy)
			  {
				case 0	: piszs("*4-MUTE*");
					break;
				case 1	: piszs("*4-DAC*");
					break;
				case 2	: piszs("*4-Bypass*");
					break;
				case 3	: piszs("*4-BP/DC*");
					break;
			  }
              _yy = _yy << 3;
              _xx = _xx | _yy;              
              write_WM8770(0x1D, _xx); // Output Mux: MX4(4,3) -> Bypass[4], DAC4[3]; MX3(2,1,0) -> Bypass[2], AUX3[1], DAC3[0]   

              if(MODE_DIG_F==3) // DDD + DS
               //   _xx |= 0x004; // dolocz LS i RS z Bypass2
                 {
                  CTRL1 |= CTRL1_DSTEREO_OR;
                  LD_Latch_n(CTRL1, 1);
                 }
              else
                 {
                  CTRL1 &= CTRL1_DSTEREO_AND;
                  LD_Latch_n(CTRL1, 1);
                 }
      }

    LCD_X;
}

// =======================================================================+=====

void Set_SPDIF(void)
{
            SPDIF = 1;

            CTRL1 = CTRL1_REC_SPDIF_DD_M;
            CTRL2 = CTRL2_REC_SPDIF_DD_M;
            CTRL3 = CTRL3_REC_SPDIF_DD_M;
            LD_Latch_n(CTRL1, 1);
            LD_Latch_n(CTRL2, 2);
            LD_Latch_n(CTRL3, 3);

            STA_PLL_in(1, 1); // 1, 1
            //STA_Restart(1);
}

// =======================================================================+=====

void Set_SIN1(char slave)
{
            SPDIF = 0;
            if(!slave)
               {
                // CTR1 = ?
                CTRL1 = CTRL1_GRAJ_ADC_DD_M;
                CTRL2 = CTRL2_GRAJ_ADC_DD_M;
                CTRL3 = CTRL3_GRAJ_ADC_DD_M;
                LD_Latch_n(CTRL1, 1);
                LD_Latch_n(CTRL2, 2);
                LD_Latch_n(CTRL3, 3);

                STA_PLL_in(0, 0); // (0, 0); (1, 1); (1, 0) ?
                // STA_PLL_in(0, 0);
               }
            else
               {
                // CTRL1 = ? 
                CTRL1 = CTRL1_GRAJ_ADC_DD;
                CTRL2 = CTRL2_GRAJ_ADC_DD;
                CTRL3 = CTRL3_GRAJ_ADC_DD;
                LD_Latch_n(CTRL1, 1);
                LD_Latch_n(CTRL2, 2);
                LD_Latch_n(CTRL3, 3);

                Set_PLL2PCM(0, 2); // Set_PLL2PCM(s,p) zawiera STA_PLL_in(s,p)
                // STA_PLL_in(0, 0);
               }
            act_decoder = 0;
            STA_write(0x4C, 0x03);
            STA_write(0x4D, 0x03);
            if(slave > 1)
                STA_write(0x05,0x01); // SFREQ: 0-48, 1-44.1, 2-32, 4-96, 5-88.2 [kHz]
            CircleSurr();
            VCROut();
}
// =======================================================================+=====

void STA_write(char addr, char data)
{
  if(DDAdr)
    i2c_write_reg(DDAdr, addr, data);
}

uint8_t STA_read(char addr)
{
 if(DDAdr)
   return i2c_read_reg(DDAdr, addr);\
 else
   return 0xFE;
}
// -------------------------------------------------------------------------------

void Set_ADC_ATT(void)
{
 write_WM8770(0x19, ADC_ATT[WM_IN]); // ADC_ATT_L(4:0); 0->-12dB, 0C->0dB, 1F->+19dB 
 write_WM8770(0x1A, ADC_ATT[WM_IN]); // ADC_ATT_R(4:0); 0->-12dB, 0C->0dB, 1F->+19dB
}

void EPM_SPDIF(char fiber_n_coax) // CTRL3[2][1]: 0 - Coaxial, 1..3 - FiberOptic_1..3
{
    fiber_n_coax = fiber_n_coax << 1; // Bity [1][0] -> [2][1]
    CTRL3 &= 0xF9;
    CTRL3 |= fiber_n_coax;
    LD_Latch_n(CTRL3, 3);
}
// -------------------------------------------------------------------------------

void EPM_DNL(char onoff) // CTRL3[3]: 1 - DNL on, 0 - DNL off
{
    if(onoff)
        CTRL3 |= 0x08;
    else
        CTRL3 &= 0xF7;
    LD_Latch_n(CTRL3, 3);
}
// -------------------------------------------------------------------------------

void EPM_WM_SCK(char WMnMP3) // CTRL1[7][6]: 10 - WM SCK1, 01 - MP3 SCK1
{
    CTRL1 &= 0x3F;
    if(WMnMP3)
        CTRL1 |= 0x80;
    else
        CTRL1 |= 0x40;
    LD_Latch_n(CTRL1, 1);
}
// -------------------------------------------------------------------------------

void EPM_MP3_SCK(char MP3nWM) // CTRL1[7][6]: 10 - WM SCK1, 01 - MP3 SCK1
{
    CTRL1 &= 0x3F;
    if(MP3nWM)
        CTRL1 |= 0x40;
    else
        CTRL1 |= 0x80;
    LD_Latch_n(CTRL1, 1);
}
// -------------------------------------------------------------------------------

void EPM_Set_OUT(char Out) // CTRL1[5][4][3][2]: SET OUTx1 OUTx2 OUTx3 OUTx4
{
    Out &= 0x0F; // Cztery bity: [3]-OUTx1, [2]-OUTx2, [1]-OUTx3, [0]-OUTx4
    Out = Out << 2;    // 2 razy w lewo
    Out &= 0x3C; // Zostaw bity 5..2
    CTRL1 &= 0xC3;
    CTRL1 |= Out;
    LD_Latch_n(CTRL1, 1);
}
// -------------------------------------------------------------------------------

void EPM_Res_OUT(char Out) // CTRL1[5][4][3][2]: CLR OUTx1 OUTx2 OUTx3 OUTx4
{
    Out &= 0x00F; // Cztery bity: [3]-OUTx1, [2]-OUTx2, [1]-OUTx3, [0]-OUTx4
    Out = Out << 2;    // 2 razy w lewo
    Out ^= 0x3C;  // Zaneguj
    Out &= 0x3C;  // Zostaw bity 5..2
    CTRL1 &= Out; // Wypal zerowane bity
    LD_Latch_n(CTRL1, 1);
}
// -------------------------------------------------------------------------------

void EPM_DD_MASTER(char Mast) // CTRL3[0]: 1 - DD SLAVE, 0 - DD MASTER
{
    if(Mast)
        CTRL3 &= 0xFE; // [0] -> 0
    else
        CTRL3 |= 0x01; // [0] -> 1
    LD_Latch_n(CTRL3, 3);
}
// -------------------------------------------------------------------------------

void LD_Latch_s(unsigned long ctrls) // CTRLs[11][10]..[0]
{
unsigned long ctl;

/*    ctl = ctrls & CTRLs_MASK_AND; // 0xF0FFC1
    ctl &= 0x0000FF;
    CTRL1 &= CTRL1_MASK_AND; // 0x3E
    CTRL1 |= (char)ctl;
    LD_Latch_n(CTRL1, 1);*/

    ctl = ctrls & CTRLs_MASK_AND;
    ctl &= 0x00FF00;
    ctl = ctl >> 8;
    CTRL2 &= CTRL2_MASK_AND; // 0x00
    CTRL2 |= (char)ctl;
    LD_Latch_n(CTRL2, 2);

    ctl = ctrls & CTRLs_MASK_AND;
    ctl &= 0xFF0000;
    ctl = ctl >> 16;
    CTRL3 &= CTRL3_MASK_AND; // 0x0F
    CTRL3 |= (char)ctl;
    LD_Latch_n(CTRL3, 3);
  
}
// -------------------------------------------------------------------------------

void zapis_lcd_ci_4H(char dane)
{
// zapis bezposredni CONTROL w trybie 8 bitowym
 RW20;
 RS20;
 KLBLK = 1;
 Enable20;
 delayx(254);
 wr_LCD_4H(dane);
 RW21;
 RS21;
 KLBLK = 0;
}

void zapis_lcd_ci(char dane)
{
// zapis bezposredni CONTROL w trybie 4 bitowym
 RW20;
 RS20;
 KLBLK = 1;
 Enable20;
 //delayx(66);
 wr_LCD(dane);
 RW21;
 RS21;
 KLBLK = 0;
}

void zapis_lcd_di(char dane)
{
// zapis bezposredni DATA w trybie 4 bitowym
 RW20;
 RS21;
 KLBLK = 1;
 Enable20;
 //delayx(11);
 wr_LCD(dane);
 RW21;
 RS21;
 KLBLK = 0;
}

void wr_LCD(char dane)
{
char x1l;
// zapisz 2 razy: 4 starsze a nastepnie 4 mlodsze bity w trybie 4 bitow
    Enable20;
    FIO2DIR |= 0x0F; // Wyjscie
    delayx(0x11);
    x1l = dane >> 4; // H
    x1l &= 0x0F; 
    FIO2CLR |= 0x0F;
    FIO2SET |= x1l;
    delayx(0x11);
    Enable21;
    delayx(0x33);
    Enable20;   // dane sa czytane na zboczu opadajacym
    delayx(0x11);
    x1l = dane & 0x0F;// L
    x1l &= 0x0F; 
    FIO2CLR |= 0x0F;
    FIO2SET |= x1l;
    delayx(0x11);
    Enable21;
    delayx(0x33);
    Enable20;   // dane sa czytane na zboczu opadajacym
    delayx(0x11);
}

void wr_LCD_4H(char dane)
{
// zapisz jeden raz 4 starsze bitow w trybie 8 bitow
    Enable20;
    FIO2DIR |= 0x0F; // Wyjscie
    delayx(0x0400);
    dane = dane >> 4; // H
    dane &= 0x0F;
    FIO2CLR |= 0x0F;
    FIO2SET |= dane;
    delayx(0x0400);
    Enable21;
    delayx(0x07FF);
    Enable20;   // dane sa czytane na zboczu opadajacym
    delayx(0x0400);
}

int rd_KL(void)
{
// czytaj 4 bity
int dane;
    FIO2DIR0 = 0xE0; // Wejscie FIO2
    dane = FIO2PIN0 & 0x000F;
    dane ^= 0x0F; 
    FIO2DIR0 |= 0x0F; // Wyjscie
    return dane;
}

/*char odczyt_lcd_c(void)
{
 char yy;
 RW=1;
 RS=0;
 Enable=0;
 delayx(3);
 EA=0;		// Bloka przerwan
// P2=0xFF;	// P2 jako wejscie
 Enable=1;
// yy=P2;
 Enable=0;
 RW=1;
 RS=1;
 EA=1;		// Odplokowanie przerwan
 return yy;
}*/

void inic_lcd(void)
{
 delayx(0x00013210);
 zapis_lcd_ci_4H(0x30); // 8-bitow
 delayx(0x00093210);
 zapis_lcd_ci_4H(0x30); // 8-bitow
 delayx(0x00043210);
 zapis_lcd_ci_4H(0x30); // 8-bitow
 delayx(0x00043210);
 zapis_lcd_ci_4H(0x20); // 8-bitow
 delayx(0x00043210);
 zapis_lcd_ci(0x28); // 4-bity
 delayx(0x00013210);
 zapis_lcd_ci(0x28); // 4-bity
 delayx(0x00013210);
 zapis_lcd_ci(0x28); // 4-bity
 delayx(0x00013210);
 zapis_lcd_ci(0x06); // 0000 01, D=1 zwiekszaj adr. kur., S=0 nie przesuwaj ekranu
 delayx(0x00003210);
 zapis_lcd_ci(0x0E); // 0000 1, D=1 wyswietlanie, C=1 kursor widoczny , B=0 kursor normalnie
 delayx(0x00003210);
 zapis_lcd_ci(0x01); // Display CLEAR
 delayx(0x00043210);
 zapis_lcd_ci(0x80); // 1000 0000, Adres pamieci ekranu =0
 delayx(0x00013210);
}

/*void zapis_lcd_c(char dane)
{
// gotowosc_lcd();
 zapis_lcd_ci(dane);
}*/

/*void zapis_lcd_d(char dane)
{
// gotowosc_lcd();
 zapis_lcd_di(dane);
}*/

/*void gotowosc_lcd(void)
{
 int fg,z;
 for(fg=127;fg>0;fg--)
 {
  z=odczyt_lcd_c();
  z = z & 0x80;
  if(!z) break;
 }
 delayx(3);
}*/

// ===============================================================================================

void Set_Input_q(void)
{
unsigned int yyl, ucl, setgvs;
 WM_IN = Input & 0x0007;
 ucl = (Input & 0x0030) >> 4;

 Timer_M = 299;
 MUTE_On();

 Display_RDS = 0;
 TDA_Vol(TDA_Vol_M); // -79dB

 if(!(Input & 0x0008))
  {
             SPDIF = 0;
             Set_SIN1(2); // Bylo 0

             // WM_IN++;
             // WM_IN = WM_IN & 0x07;

             yyl = WM_IN << 4;
             write_WM8770(0x1B, WM_IN | yyl); // LMX(2,1,0); RMX(6,5,4)
             Set_ADC_ATT();

             if((WM_IN == 0x05)&&(IN_5_DIR==1))
                    Input_5_1_On;
             else
                    Input_5_1_Off;
  }
 else
  {
             yyl = WM_IN;
             WM_IN = 7;
             write_WM8770(0x1B, 0x77); // LMX(2,1,0); RMX(6,5,4)
             Set_ADC_ATT();
             WM_IN = yyl;
             Set_SPDIF();
             EPM_SPDIF(ucl);
  }

  setgvs = MODE_DIG;

  if((WM_IN == 0x05)&&(IN_5_DIR==1))
   MODE_DIG = 0;

  if(MODE_DIG)
   WM_OUT_MX = 1; // DAC1,2,3,4
  else
   WM_OUT_MX = 3; // AUX/DAC

  Set_MODE_DIG(); // <---------- Set MODE DIG
  MODE_DIG = setgvs;

  delayx(0x00013210);

  if((Input & 0x0007) == 0x07)
     TDA_Vol(TDA_Vol_7 + (TDA_Bass_X>>1)); // 0x0E = +18dB
  else
     TDA_Vol(TDA_Vol_0 + (TDA_Bass_X>>1)); // +12dB

  if(((Input & 0x0007) == 0x07) && SPDIF)
     TDA_Vol(TDA_Vol_S + (TDA_Bass_X>>1)); // 0x0E = +18dB

  if(!WM_IN)
     TDA_Vol(TDA_Vol_Radio + (TDA_Bass_X>>1));

  if(WM_IN == 7)
     TDA_Vol(TDA_Vol_7 + (TDA_Bass_X>>1));

  // if((Input & 0x000F) == 0x0F)
//     TDA_Vol(0x06); // +26dB
}
// ------------------------------------------------------------------------------------------

void Set_Input(void)
{
  DSP_X = 0;
  Set_Input_q();
  Display_Input();
  if(DSP_En && (MODE_DIG == 2))
  {
    //Load_AL_FL(AL_Linii);
    DSP_On();
  }
  DSP_X = 0;
}
// ------------------------------------------------------------------------------------------


void Display_Input(void)
{
unsigned int ucl, audio;
 WM_IN = Input & 0x0007;
 ucl = (Input & 0x0030) >> 4;
 Displ_I = 0;

// linia1(1,20);
// gotoxy(21,1);
// if(MODE_DIG)
//   piszs("/DAC"); // DAC1,2,3,4
// else
//   piszs("/AUX"); // AUX/DAC

 if(!(Input & 0x0008))
  {
   gotoxy(1,1);

   if(Input & 0x0007)
     {
      piszs("IN=");
      piszc(WM_IN + 0x30);
      piszc(' ');
      //TDA_Vol(0x0E); // +18dB
      switch(WM_IN)
          {
          case    1   :   piszs("AUDIO1 ");
                          break;
          case    2   :   piszs("AUDIO2 ");
                          break;
          case    3   :   piszs("AUDIO3 ");
                          break;
          case    4   :   piszs("AUX1/X ");
                          break;
          case    5   :   piszs("DIR5.1 ");
                          break;
          case    6   :   piszs("JACK F ");
                          break;
          case    7   :   piszs("VCR(D4)");
                          break;

          }
     }
   else
     {
      _FM_ = oblicz_FM(freq);
      piszs("FM");
      piszc(_FM_x + '1');
      piszc('=');
      piszdec(_FM_,6);
      piszs("k");
     }
   piszc(' ');
  }
 else
  {
   gotoxy(1,1);
   if(!ucl)
     {
     // DIGIT COAXIAL
     //SPDIF = 1;
     piszs("DIG.SPDIF[1]"); // "DIG.COAXIAL "                 
     }
   else
     {
     // DIGIT FIBER
     //SPDIF = 1;
     piszs("DIG.SPDIF["); // "DIG.OPTIK-"
     piszc(ucl + 0x31); // 0x30
     piszc(']'); // ' '
     }
  }
// Stan dekodera DD
  gotoxy(13,1);
  if(SPDIF)
      {
      audio = AUDIOX & 0x0007; // DTS[2], AC3[1], PCM[0]
      switch(audio)
          {
          case  1   :   piszs("PCM/");
                        break;
          case  2   :   piszs("AC3/");
                        break;
          case  4   :   piszs("DTS/");
                        break;
          default   :   piszs("Err/");
                        break;
          }

      }
  else
      {
          if((Input == 0x05)&&(IN_5_DIR==1))
            piszs("DIR/");
          else
              switch(MODE_DIG_F)
              {
                  case 0    : piszs("AAA/");
                      break;
                  case 1    : piszs("DAA/");
                      break;
                  case 2    : piszs("DDD/");
                      break;
                  case 3    : piszs("DSD/");
                      break;
                  case 4    : piszs("DSA/");
                      break;
                  case 5    : piszs("DIR/");
                      break;
              }
      }
// ----
  if((SPDIF) && (AC3_Ch > 2 ))
      {
       if(Virtual_Dim & 0x0100)
         {
          piszs("VirtualT");
         }
       else
         {
          piszc(0x30 + AC3_Ch);
          if(AC3_LFE)
           piszs(".1/DIGT");
          else
           piszs(".0/DIGT");
         }
      }
  else
      {
      audio = AUDIOX & 0x0030; // Circle[5], DPL[4]
      switch(audio)
          {
          case  0x00   :   piszs("2.0/");
                            break;
          case  0x10   :   piszs("DPL/");
                            break;
          case  0x20   :   piszs("CRL/");
                            break;
          default      :   piszs("DST/");
                            break;
          }
    // ----
      audio = AUDIOX & 0x0300; // VMAX[9], SRS[8]
      switch(audio)
          {
          case  0x000   :   piszs("*LIN");
                            break;
          case  0x100   :   piszs("*SRS");
                            break;
          case  0x200   :   piszs("VMAX");
                            break;
          default       :   piszs("*Err");
                            break;
          }
      }
  gotoxy(2,1);
}
// ------------------------------------------------------------------------------------------

int Set_Bit(int zmienna, char bitx)
{
int maskx;
    maskx = 1;
    if(bitx > 0)
        maskx = maskx << bitx;
    zmienna = zmienna | maskx;
    return zmienna;
}
// ------------------------------------------------------------------------------------------

int Res_Bit(int zmienna, char bitx)
{
int maskx;
    maskx = 1;
    if(bitx > 0)
        maskx = maskx << bitx;
    maskx ^= 0xFFFFFFFF;
    zmienna = zmienna & maskx;
    return zmienna;
}
// ------------------------------------------------------------------------------------------

int Test_Bit(int zmienna, char bitx)
{
int maskx;
    maskx = 1;
    if(bitx > 0)
        maskx = maskx << bitx;
    zmienna = zmienna & maskx;
    return zmienna;
}
// ------------------------------------------------------------------------------------------

unsigned short FM_Plus_Minus(char ucx)
{
int xx;

    LCD_Off;
    xx = 0xC0;
    piszs("\r\n FM+/-12500:");
    piszhl(xx);
    xx = i2c_write_a(xx);
    if(xx >= 0)
        {
        //piszs(" d1:");
        if((ucx == '+')&&(freq < 0x00003FFF))
            freq++; 
        if((ucx != '+')&&(freq > 0x00001000))
            freq--; 
        xx = freq >>8; // 1E (1D, 1F, 20, 21, 23) [93MHz (88,4; 94,6; 98,5; 102; 107,4MHz)]
        xx = i2c_write_dn(xx);
        }
    else
        piszs("NA");

    xx = freq & 0x00FF;
    xx = i2c_write_de(xx);
    
    LCD_On;
    gotoxy(1,1);
    _FM_ = oblicz_FM(freq);
    piszs("FM");
    piszc(_FM_x + '1');
    piszc('=');
    piszdec(_FM_,6);
    piszs("k ");
    LCD_X;
    
return(_FM_);
}

// MUTE ---------------------------
void MUTE_On(void)
{
    Unmute_F =0;
    Vol_SPK(0x1A);
    Vol_PH(0x1E);
    VOL_b = 0x1A;
}

// UNMUTE -------------------------
void MUTE_Off(void)
{
    Unmute_F =0;
    Vol_SPK(VOL_SPK);
    Vol_PH(VOL_PH);
    VOL_b = VOL_SPK;
}

// UNMUTE -------------------------
void UnmuteF(void)
{
    Unmute_F = Frames + 1;
    Vol_SPK_X = VOL_SPK/2; //0x1A;
    if(Vol_SPK_X < 0x1A)
      Vol_SPK_X = 0x1A;
    Vol_PH_X = VOL_PH/2; //0x1E;
    //Vol_SPK(VOL_SPK);
    //Vol_PH(VOL_PH);
    //VOL_b = VOL_SPK;
    Unmute();
}

void Unmute(void)
{
  if(Unmute_F <= Frames)
   {
    if(Vol_SPK_X < VOL_SPK)
      {
       Vol_SPK_X++;
       Vol_SPK(Vol_SPK_X);
      }
    if(Vol_SPK_X < VOL_SPK)
      {
       Vol_SPK_X++;
       Vol_SPK(Vol_SPK_X);
      }
    if(Vol_SPK_X < VOL_SPK)
      {
       Vol_SPK_X++;
       Vol_SPK(Vol_SPK_X);
      }

   // if(Vol_PH_X > VOL_PH)
   //   {
   //    Vol_PH_X--;
   //    Vol_PH(Vol_PH_X);
   //   }
   Vol_PH(VOL_PH);

   if((Vol_SPK_X != VOL_SPK)||(Vol_PH_X != VOL_PH))
      Unmute_F = Frames + 3;
   else
      Unmute_F = 0;
  }

 VOL_b = Vol_SPK_X;
}

// Maksymalny (MAX) poziom z przetwornika ADC
short ADCm(void)
{
short f_, ml_, mr_;
 ml_ = 0;
 mr_ = 0;
 DI;ADC53 = 0;EI;
 for(f_ = 0; f_ < 8; f_++)
     {
      while((ADC53&0x01)==0);
      DI;
      if(ADCLL >= ml_)
          ml_ = ADCLL;
      ADC53 = 0;
      EI;
      while((ADC53&0x02)==0);
      DI;
      if(ADCLR >= mr_)
          mr_ = ADCLR;
      ADC53 = 0;
      EI;
     }
 ADCLLm = ml_; // Max L
 ADCLRm = mr_; // Max R
 return(ADCLLm+ADCLRm);
}
// --------------------------------------------------------------------------------

// Ustaw wedlug MODE_DIG
void Set_MODE_DIG(void)
{
short _xx, _yy, stereo_x;

    LCD_Off;

    MODE_DIG_F = MODE_DIG;
    if((MODE_DIG == 0x02)&&DSTEREO) // DDD + DS = DSD
       {
        MODE_DIG_F = 0x03; // DSD
        CTRL1 |= CTRL1_DSTEREO_OR;
       }
    if((MODE_DIG == 0x03)&&(DSTEREO==0))
       {
        MODE_DIG_F = 0x02; // DDD
        CTRL1 &= CTRL1_DSTEREO_AND;
       }

    stereo_x = 0;
    if(SPDIF)
      {
        if(AC3_Ch <= 2)
           stereo_x = 1;
        else
          MODE_DIG_F = 2; // DDD
        LCh = AC3_Ch;
      }

    // 0 - AAA/3XA BT   STEREO A -> 5.1 A
    // 1 - DAA     BT#  STEREO D -> STEREO D + C,Sub A + Surroud A
    // 2 - DDD/3XD BT   STEREO D lub 5.1 D -> 5.1 D 
    // 3 - DAD/DSD BT#  STEREO D -> 2 x STEREO D + C,Sub A
    // 4 - AAA/DSA BT   STEREO A -> 2 x STEREO A + C,Sub A
    // 5 - DIR     BT   DIRECT 5.1 A 

    if(SPDIF && (MODE_DIG_F == 0) && stereo_x) //&& (MODE_STEREO==0)) // cyfrowe 5.1/2.0
        MODE_DIG_F = 0x09; // DAA z VCR //MODE_DIG_F = 0x08; // AAA z VCR

    if(SPDIF && (MODE_DIG_F == 1) && stereo_x) //&& (MODE_STEREO==0)) // cyfrowe 5.1/2.0
        MODE_DIG_F = 0x09; // DAA z VCR

    if(SPDIF && (MODE_DIG_F == 3) && stereo_x) //&& (MODE_STEREO==0)) // cyfrowe 5.1/2.0
        MODE_DIG_F = 0x0B; // DSD z PCM1

    if((WM_IN == 0x05)&&(IN_5_DIR==1))
        MODE_DIG_F = 0x05; // DIR

    if(!MODE_DIG_F && DSTEREO) // AAA + DS = DSA
        MODE_DIG_F = 0x04; // DSA

    if(MODE_DIG_F == 0x02) // DDD
    {  
             //123456789012345678901234
        piszs(" DDD/2 ");

        WM_OUT_MX = 0x01; // 0x0D
        // gotoxy(21,1);
        WM_Out_Mix(WM_OUT_MX, WM_OUT_MX, WM_OUT_MX, WM_OUT_MX); // 1-DAC, 3-AUX/DAC, 5-Bypass/DAC, 7-Bypass/AUX/DAC

        //BassTrebleFilter_TDA_5 &= 0x7F;
        //i2c1_write_reg(I2C_TDA7461, 0x05, BassTrebleFilter_TDA_5);
        i2c1_write_reg(I2C_TDA7461, 0x04, BassTrebleATT_TDA_4); // BT
        TDA_Bass_X = TDA_Bass;

        WM_DIG_ATT(0xFE, 0xFE,0xFE,0xFE);

        //CTRL1 = CTRL1_GRAJ_ADC_DD;
        if(SPDIF)
          {
           MUX123 = MUX123_REC_SPDIF_DD_M;
           MUX45 = MUX45_REC_SPDIF_DD_M;
          }
        else
          {
           MUX123 = MUX123_GRAJ_ADC_R_DD;
           MUX45 = MUX45_GRAJ_ADC_R_DD;
          }
    }

    if((MODE_DIG_F == 0x08)||(MODE_DIG_F == 0x09))
      {
       WM_IN = 0x07;
       Input |= 0x0007;
      }

    if((MODE_DIG_F == 0x00)||(MODE_DIG_F == 0x08)) // AAA/3XA
    {   
             //123456789012345678901234
        piszs(" AAA/");
        piszdec(MODE_DIG_F, 1);
        piszc(' ');

        //if(WM_IN != 0x07)
        //   {
        //    MUX123 = MUX123_GRAJ_ADC_DD; // WAV
        //    MUX45 = MUX45_GRAJ_ADC_DD; // WAV
        //    }
        if(MODE_DIG_F == 0x08)
          {
           MUX123 = MUX123_REC_SPDIF_DD_M;
           MUX45 = MUX45_REC_SPDIF_DD_M;
          }
        else
          {
           MUX123 = MUX123_GRAJ_WAV; // WAV
           MUX45 = MUX45_GRAJ_WAV; // WAV
          }

        WM_OUT_MX = 0x03; // 2
        WM_Out_Mix(WM_OUT_MX, WM_OUT_MX, WM_OUT_MX, 0x01); // 1-DAC, 3-AUX/DAC, 5-Bypass/DAC, 7-Bypass/AUX/DAC

        BassTrebleFilter_TDA_5 |= 0x80;
        i2c1_write_reg(I2C_TDA7461, 0x05, BassTrebleFilter_TDA_5);
        i2c1_write_reg(I2C_TDA7461, 0x04, BassTrebleATT_TDA_4); // BT
        TDA_Bass_X = TDA_Bass;

        WM_DIG_ATT(0x01, 0x01,0x01,0xFE);
    }

    if((MODE_DIG_F == 0x01)||(MODE_DIG_F == 0x09)) // DAA/DAA
    {   
             //123456789012345678901234
        piszs(" DAA/");
        piszdec(MODE_DIG_F, 1);
        piszc(' ');

        if(MODE_DIG_F == 0x09)
          {
           MUX123 = MUX123_REC_SPDIF_DD_M;
           MUX45 = MUX45_REC_SPDIF_DD_M;
          }
        else
          {
           MUX123 = MUX123_GRAJ_WAV; // WAV
           MUX45 = MUX45_GRAJ_WAV; // WAV
          }

        if(WM_IN == 7)
        {
            _xx = 0x01; // DAC1
            _yy = 0xFE; // ATT1
            MUX123 &= 0x7E; // DD Off 
        }
        else
        {
            _xx = 0x05; // BYP1
            _yy = 0x01; // ATT1
            MUX123 = MUX123_GRAJ_WAV; // WAV
            MUX45 = MUX45_GRAJ_WAV; // WAV
        }

        WM_OUT_MX = 0x03; // AUX/DAC
        WM_Out_Mix(_xx, WM_OUT_MX, WM_OUT_MX, 0x01); // 1-DAC, 3-AUX/DAC, 5-Bypass/DAC, 7-Bypass/AUX/DAC

        BassTrebleFilter_TDA_5 |= 0x80;
        i2c1_write_reg(I2C_TDA7461, 0x05, BassTrebleFilter_TDA_5);
        i2c1_write_reg(I2C_TDA7461, 0x04, 0xFF); // BT Off
        TDA_Bass_X = 0;

        WM_DIG_ATT(_yy, 0x01,0x01,0xFE);
    }

    if((MODE_DIG_F == 0x03)||(MODE_DIG_F == 0x0B)) // DDD + DS = DSD/DSD
    {   
             //123456789012345678901234
        piszs(" DSD/");
        piszdec(MODE_DIG_F, 0);
        piszc(' ');

        if(MODE_DIG_F == 0x0B)
          {
           MUX123 = MUX123_REC_SPDIF_DD_M;
           MUX45 = MUX45_REC_SPDIF_DD_M;
          }
        else
          {
           MUX123 = MUX123_GRAJ_WAV; // WAV
           MUX45 = MUX45_GRAJ_WAV; // WAV
          }

        if(WM_IN != 0x07)
            {
             MUX123 = MUX123_GRAJ_ADC_DD; // WAV
             MUX45 = MUX45_GRAJ_ADC_DD; // WAV
            }

        WM_OUT_MX = 0x01; // 0
        // dolacz C i Sub z AUX2
        WM_Out_Mix(WM_OUT_MX, 0x03, WM_OUT_MX, 0x01); // 1-DAC, 3-AUX/DAC, 5-Bypass/DAC, 7-Bypass/AUX/DAC

        CTRL1 |= CTRL1_DSTEREO_OR;
        LD_Latch_n(CTRL1, 1);

        //BassTrebleFilter_TDA_5 &= 0x7F;
        //i2c1_write_reg(I2C_TDA7461, 0x05, BassTrebleFilter_TDA_5);
        i2c1_write_reg(I2C_TDA7461, 0x04, 0xFF); // BT Off
        TDA_Bass_X = 0;

        WM_DIG_ATT(0xFE, 0x01,0xFE,0xFE);
    }

    if(MODE_DIG_F == 0x04) // AAA + DS = DSA
    {   
             //123456789012345678901234
        piszs(" DSA/");
        piszdec(MODE_DIG_F, 1);
        piszc(' ');

        if(WM_IN != 0x07)
            {
             MUX123 = MUX123_GRAJ_WAV; // WAV
             MUX45 = MUX45_GRAJ_WAV; // WAV
            }
        MUX123 &= 0x7E; // DD Off

        WM_OUT_MX = 0x03; // AUX/DAC
        // L/R i LS/RS Baypass/DAC
        WM_Out_Mix(0x05, WM_OUT_MX, 0x05, 0x01); // 1-DAC, 3-AUX/DAC, 5-Bypass/DAC, 7-Bypass/AUX/DAC

        BassTrebleFilter_TDA_5 |= 0x80;
        i2c1_write_reg(I2C_TDA7461, 0x05, BassTrebleFilter_TDA_5);
        i2c1_write_reg(I2C_TDA7461, 0x04, 0xFF); // BT Off
        TDA_Bass_X = 0;

        WM_DIG_ATT(0x01, 0x01,0x01,0xFE);
    }

    if(MODE_DIG_F == 0x05) // DIR
    {   
             //123456789012345678901234
        piszs(" DIR/5 ");

        if(WM_IN != 0x07)
            {
             MUX123 = MUX123_GRAJ_WAV; // WAV
             MUX45 = MUX45_GRAJ_WAV; // WAV
            }
        MUX123 &= 0x7E; // DD Off

        WM_OUT_MX = 0x03; // AUX/DAC
        WM_Out_Mix(WM_OUT_MX, WM_OUT_MX, WM_OUT_MX, 0x01); // 1-DAC, 3-AUX/DAC, 5-Bypass/DAC, 7-Bypass/AUX/DAC

        BassTrebleFilter_TDA_5 |= 0x80;
        i2c1_write_reg(I2C_TDA7461, 0x05, BassTrebleFilter_TDA_5);
        i2c1_write_reg(I2C_TDA7461, 0x04, 0xFF); // BT Off
        TDA_Bass_X = 0;

        WM_DIG_ATT(0x01, 0x01,0x01,0xFE);
    }

    if(!(Glosniki&0x01))
     {
      if((MODE_DIG_F == 2)||(MODE_DIG_F == 5))
        {C_MIX_EN;}
      else
        {C_MIX_DIS;}     
     }
    LCD_X;
    Konfiguracja();
}
// --------------------------------------------------------------------------------

char Set_BassTreble_F(void)
{
char _x_;

    TDA_BTFilter = 0;

    _x_ = Bass_Q << 4;
    _x_ &= 0x30; 
    TDA_BTFilter |= _x_;

    _x_ = Bass_F << 2;
    _x_ &= 0x0C; 
    TDA_BTFilter |= _x_;

    _x_ = Sop_F & 0x03;
    TDA_BTFilter |= _x_;

    BassTrebleFilter_TDA_5 &= 0xC0;
    BassTrebleFilter_TDA_5 |= TDA_BTFilter;

    i2c1_write_reg(I2C_TDA7461, 0x05, BassTrebleFilter_TDA_5);
    
    return(BassTrebleFilter_TDA_5);  
}

void Konfiguracja(void)
{
  CTRL1 = (CTRL1 & 0xC3) | (KOLORLED << 4) | (OUTX << 2);
  LD_Latch_n(CTRL1, 1);

  CTRL2 = MUX123;
  LD_Latch_n(CTRL2, 2);

  CTRL3 = (CTRL3 & 0x01) | (MUX45 << 4) | (MUXS << 1);
  if(DNL)
    CTRL3 |= 0x08; // DNL
  else
    CTRL3 &= 0xF7; // DNL
  LD_Latch_n(CTRL3, 3);

// ----------------------------------------------------------------------------------- DSP On/Off -------
  if(DSP_En)
    DSP_On();
  else
    DSP_Off();
}
// --------------------------------------------------------------------------------

void WM_DIG_ATT(char dac1, char dac2, char dac3, char dac4)
{  // Digital ATT
  write_WM8770(0x09, dac1); // DACL1 FF->0dB, F9->-6dB ...
  write_WM8770(0x0A, dac1); // DACR1 FF->0dB, F9->-6dB ...
  write_WM8770(0x0B, dac2); // DACL2 FF->0dB, F9->-6dB ...
  write_WM8770(0x0C, dac2); // DACR2 FF->0dB, F9->-6dB ...
  write_WM8770(0x0D, dac3); // DACL3 FF->0dB, F9->-6dB ...
  write_WM8770(0x0E, dac3); // DACR3 FF->0dB, F9->-6dB ...
  write_WM8770(0x0F, dac4); // DACL4 FF->0dB, F9->-6dB ...
  write_WM8770(0x10, 0x0100 + dac4); // DACR4 FF->0dB, F9->-6dB ... bit[8]-Update
}
// --------------------------------------------------------------------------------

void TDA_Vol(char vol)
{
   i2c1_write_a(0x8C);
   i2c1_write_dn(0x02); // Volume
   i2c1_write_de(vol); // 0x20->0dB
}
// --------------------------------------------------------------------------------

long int Szumy(void)
{
long int yyx;
int fx;
  yyx = 0;
  for(fx = 0x1000; fx < 0x1FFE; fx++ )
  {
    yyx = yyx + abs(Tab_16[fx]-Tab_16[fx+2]);
  }
 return yyx;
}
// --------------------------------------------------------------------------------

void Nawigacja_SD(void)
{
int xx, yy;
char uc;
// Nawigacja na SD
             ENTER = 0;
             Input_BS = 0;
             inxi = 0; // przelacznik wejscia
// Odczyt katalogu
             if(DIR_DOT)
              {
               Klaster = Klaster_dot;
               xx = Read_DIR(Klaster);
              }
             else
              {
               xx = Read_DIR(0);
               Poziom = 0;
               DIR_DOT = 0;
              }

             if(Indexow)
             {
               DIR_n = 1;
               if(DIR_DOT)
               {
                   DIR_n = 2;
               }

               uc = ' ';

               while(uc != 0x1B)
               {
                 if(IMPULSATOR)
                 {
                     if((uc == '-')||(uc == '.'))
                     {
                       if(((DIR_n > 2)&&Poziom)||((DIR_n>1)&&!Poziom))
                         DIR_n--;
                     }
    
                     if((uc == '+')||(uc == ','))
                     {
                       if(DIR_n <= Indexow)
                         DIR_n++;
                     }
                 }
                 else
                 {
                     if((uc == '+')||(uc == ','))
                     {
                       if(((DIR_n > 2)&&Poziom)||((DIR_n>1)&&!Poziom))
                         DIR_n--;
                     }

                     if((uc == '-')||(uc == '.'))
                     {
                       if(DIR_n <= Indexow)
                         DIR_n++;
                     }
                 }

                 INDEX = DIR_n;

                 if(uc == 0x0D)
                 {  
L_PLAY_MP3:          INDEX = DIR_n;
                     ENTER = 1;

                     yy = INDEX;

                     if(INDEX && DIR_OK)
                     {
                      Klaster = Tab_Klaster(INDEX);
                      xx = Read_DIR(Klaster);
                     }
                     else
                     {
                  // Powtorny odczyt katalogu
                      if(!ENTER)
                       {
                        if(DIR_DOT)
                        {
                         Klaster = Klaster_dot;
                         xx = Read_DIR(Klaster);
                        }
                        else
                        {
                         xx = Read_DIR(0);
                         Poziom = 0;
                         DIR_DOT = 0;
                        }
                       }
                      if(!xx)
                       DIR_OK = 1;
                      if(DIR_DOT)
                          DIR_n = 2;
                      else
                          DIR_n = 1;
                     }

                     if(xx == 1) 
                     {
                         // FILE
                         INDEX = DIR_n;
                         AtrybTot = Tab_Atrybut(INDEX);
                         if(AtrybTot & 0x0400)
                         {
                          // Pliki *.PCM
                          if(!inxi)
                           {
                               Set_IN7();
                               inxi = 1;
                               STAvolume(0x7E); // Szumy z STA310
                           }
                          while(Timer_M);
                          MUTE_Off();
                          Graj_PCM(INDEX);
                          Display_Freq(19,2);
                         }
        
                         if(AtrybTot & 0x0200)
                         {
                          // Pliki *.WAV
                          if(!inxi)
                          {
                             Set_IN7();
                             inxi = 1;
                             STAvolume(0x7E); // Szumy z STA310
                          }
                          while(Timer_M);
                          MUTE_Off();
                          Graj_WAV(INDEX);
                          Display_Freq(19,2);
                         }
        
                         if(AtrybTot & 0x0100)
                         {
                          // Pliki *.MP3 
                          if(inxi == 0)
                          {    
                              Set_IN7();
                              inxi = 1;
                              STAvolume(0x7E); // Szumy z STA310
                          }
                          // WM_DIG_ATT(0x01, 0x01, 0x01, 0xFE);
                          MUTE_Off();
                          Graj_MP3(INDEX);
                          MUTE_On();
                          Timer_M = 100;
                          delayx(0x00001000);
                          Display_Freq(19,2);
                         }

                         if(AtrybTot & 0x0800)
                         {
                          // Pliki *.OBJ - program DSP
                          Get_File(INDEX);
                          Display_Freq(19,2);
                          LKey = 0x1B; // <---------------------- STUCZKA !
                         }

// Graj n utworow -------------------------------------------------------------
                         if(KlawX() < 0)
                         {
                          if(DIR_n <= Indexow)
                          {    
                            DIR_n++;
                            DIR_AB(DIR_n);
                            if(LKey != 0x1B)
                              goto L_PLAY_MP3;
                          }
                         }
                         //if(inxi)
                         //{
                           //  Restore_IN();
                           //  inxi = 0;
                         //}
                         Display_Freq(19,2);

                     }
                     else
                     {
                         // Katalog
                         if(DIR_DOT)
                             DIR_n = 2;
                         else
                             DIR_n = 1;
                     }
                 }

                 if(uc == 'm')
                 {
                   gotoxy(1,2);
                   piszs("[1]REC[2]MP3B[3]MD[4]DEL");
                   uc = getch();

                   if(uc == '3')
                        Make_DIR();

                   if(uc == '4')
                   {
                     linia2(1,24);
                     piszs("DELETE-");

                     piszdec(INDEX,0);
                     piszc('/');
                     INDEXB = Tab_Indexb(INDEX);
                     piszdec(INDEXB,0);
                     delayx(0x00071234);

                     if((INDEX <= (Indexow + 1)) && INDEX && DIR_OK)
                     {
                         INDEXB = Tab_Indexb(INDEX);    
                         //piszc('-');
                         //piszdec(INDEX, 0);
                         //piszc('*');
                         MazaniePlikow(INDEXB);
                         delayx(0x000A1234);
                         DIR_n--;
                     }
                   }

                   if((uc == '1')||(uc == uc_Rec))
                   {
                     if(inxi)
                     {  
                       Restore_IN();
                       inxi = 0;
                     }
                     while(Timer_M);
                     MUTE_Off();
                     Stat_REC = Input;
                     Nagrywanie_X();
                   }

                   if(uc == '2')
                   {
                      gotoxy(1,2);
                      if(!MP3Boost)
                          piszs("[1]BassB[2]SopranB[*]Off");
                      if(MP3Boost == 1)
                          piszs("[*]BassB[2]SopranB[3]Off");
                      if(MP3Boost == 2)
                          piszs("[1]BassB[*]SopranB[3]Off");
                      if(MP3Boost == 3)
                          piszs("[*]BassB[*]SopranB[3]Off");

                      uc = getch();

                      gotoxy(1,1);
                      switch(uc)
                          {
                          case '1'  :   MP3_Bass_Booster();
                                        piszs("MP3 Bass Booster .. ");
                                        break;
                          case '2'  :   MP3_Sopran_Booster();
                                        piszs("MP3 Sopran Booster  ");
                                        break;
                          case '3'  :   MP3_Booster_Off();
                                        piszs("MP3 Booster Off ... ");
                                        break;
                          default   :   piszs("??? ");
                                        break;
                          }
                      delayx(0x00074321);
                  }
                 }

                 if((uc == '1')||(uc == uc_Rec))
                 {
                   if(inxi)
                   {  
                     Restore_IN();
                     inxi = 0;
                   }
                   while(Timer_M);
                   MUTE_Off();
                   Stat_REC = Input;
                   Nagrywanie_X();
                 }

                 if((uc == '2')||(uc == '<'))
                     Set_Vol_SPK('-');

                 if((uc == '3')||(uc == '>'))
                     Set_Vol_SPK('+');

                 DIR_AB(DIR_n);
                 uc = getch();
               }

               while(Timer_M);
               MUTE_Off();
               gotoxy(1,2);
               piszs("\r\n* SD STOP *");

               if(inxi)
               {
                 MUTE_On();
                 Timer_M = 225;
                 Restore_IN();
                 inxi = 0;
                 while(Timer_M);
                 MUTE_Off();
               }

             }
             STAvolume(0x02);
             Input_BS = 0;
             Display_Input();
}
// --------------------------------------------------------------------------------

void Nawigacja_VDIP(void)
{
int xx, f;
char uc;
// Nawigacja na DIP
             ENTER = 0;
             Input_BS = 0;
             inxi = 0; // przelacznik wejscia

             DIR_OK_P = 0; // Zawsze 'otwieramy' Pendriv'a

             if(!DIR_OK_P)
             {
// Powtorny odczyt katalogu
               Open_VDIP();
               INDEXP = 0;
             }
         
             AttP = Get_NameP(zs);

             if(DIR_OK_P)
             {
               DIR_n = 1;
               uc = ' ';
               while(uc != 0x1B)
               {
                   if(IMPULSATOR)
                   {
                       if((uc == '-')||(uc == '.'))
                       {
                         if(DIR_n > 1)
                           DIR_n--;
                       }

                       if((uc == '+')||(uc == ','))
                       {
                         if(DIR_n <= IndexowP)
                           DIR_n++;
                       }
                   }
                   else
                   {
                       if((uc == '+')||(uc == ','))
                       {
                         if(DIR_n > 1)
                           DIR_n--;
                       }

                       if((uc == '-')||(uc == '.'))
                       {
                         if(DIR_n <= IndexowP)
                           DIR_n++;
                       }
                   }

                 if(uc == 0x0D)
                 {  
L_PLAY_MP3P:         INDEXP = DIR_n;
                     ENTER = 1;

                     AttP = Get_NameP(zs);

                     if(AttP == 0x10)
                     {
                       if((INDEXP == 1) && (AttP == 0x10) && (zs[0]=='.')) 
                       {
                         piszs(" CD ..");
                         WR_VDIP(0x02); // CD ..
                         WR_VDIP(0x20);
                         WR_VDIP(0x2E);
                         WR_VDIP(0x2E);
                         WR_VDIP(0x0D);
      
                         while(RD_VDIP() != 0x0D ); // Poczekaj na '>' CR
      
                         Open_VDIP();
                         INDEXP = 1;
                         AttP = 0;
                         DIR_n = 1;
                       }
                       else
                       {
                         if(AttP == 0x10)
                         {
                           piszs(" CD ");
                           piszs(zs);
                           xx = strlen(zs);
                           WR_VDIP(0x02); // CD
                           WR_VDIP(0x20);
                           for(f=0;f<xx;f++)
                             WR_VDIP(zs[f]);
                           WR_VDIP(0x0D);

                           while(RD_VDIP() != 0x0D ); // Poczekaj na '>' CR
    
                           Open_VDIP();
                           INDEXP = 1;
                           AttP = 0;
                           DIR_n = 1;
                         }
                       }
                       xx = 0;
                     }
                     else
                       xx = 1;
                     
                     if(xx == 1) 
                     {
                         // FILE
                         INDEXP = DIR_n;
                         AttP = Get_NameP(zs);
                         Rozmiar_Pliku_P = Tab_32_Eth[(INDEXP*5)+4];
        
                         if(AttP & 0x0120)
                         {
                          if(inxi == 0)
                          {    
                              Set_IN7();
                              inxi = 1;
                              STAvolume(0x7E); // Szumy z STA310
                          }

                          xx = strlen(zs);
                          WR_VDIP(0x0E); // OPR - OPEN FILE r
                          WR_VDIP(0x20);
                          for(f=0;f<xx;f++)
                              WR_VDIP(zs[f]);
                          WR_VDIP(0x0D);
                          while(RD_VDIP() != 0x0D ); // Poczekaj na '>' CR

                          MUTE_Off();
                          Graj_MP3_P(Rozmiar_Pliku_P);
                          MUTE_On();
                          Timer_M = 100;

                          xx = strlen(zs);
                          WR_VDIP(0x0A); // CLF - CLOSE FILE
                          WR_VDIP(0x20);
                          for(f=0;f<xx;f++)
                              WR_VDIP(zs[f]);
                          WR_VDIP(0x0D);
                          while(RD_VDIP() != 0x0D ); // Poczekaj na '>' CR

                          delayx(0x00001000);
                          Display_Freq(19,2);
                         }
// Graj n utworow -------------------------------------------------------------
                         if(KlawX() < 0)
                         {
                          if(DIR_n <= IndexowP)
                          {    
                            DIR_n++;
                            DIR_ABP(DIR_n);
                            if(LKey != 0x1B)
                              goto L_PLAY_MP3P;
                          }
                         }
                         //if(inxi)
                         //{
                         //    Restore_IN();
                         //    inxi = 0;
                         //}
                         Display_Freq(19,2);

                     }
                 }

                 if((uc == 'm') || (uc == '1'))
                 {
                      gotoxy(1,2);
                      if(!MP3Boost)
                          piszs("[1]BassB[2]SopranB[*]Off");
                      if(MP3Boost == 1)
                          piszs("[*]BassB[2]SopranB[3]Off");
                      if(MP3Boost == 2)
                          piszs("[1]BassB[*]SopranB[3]Off");
                      if(MP3Boost == 3)
                          piszs("[*]BassB[*]SopranB[3]Off");

                      uc = getch();

                      gotoxy(1,1);
                      switch(uc)
                          {
                          case '1'  :   MP3_Bass_Booster();
                                        piszs("MP3 Bass Booster .. ");
                                        break;
                          case '2'  :   MP3_Sopran_Booster();
                                        piszs("MP3 Sopran Booster  ");
                                        break;
                          case '3'  :   MP3_Booster_Off();
                                        piszs("MP3 Booster Off ... ");
                                        break;
                          default   :   piszs("??? ");
                                        break;
                          }
                      delayx(0x00074321);
                 }

                 if((uc == '2')||(uc == '<'))
                     Set_Vol_SPK('-');

                 if((uc == '3')||(uc == '>'))
                     Set_Vol_SPK('+');

                 DIR_ABP(DIR_n);
                 uc = getch();
               }

               while(Timer_M);
               MUTE_Off();
               gotoxy(1,2);
               piszs("\r\n* USB STOP *");

               if(inxi)
               {
                 MUTE_On();
                 Timer_M = 225;
                 Restore_IN();
                 inxi = 0;
                 while(Timer_M);
                 MUTE_Off();
               }

             }
             STAvolume(0x02);
             Input_BS = 0;
             Display_Input();

}
// --------------------------------------------------------------------------------

// = Odczyt Partycji =============================================================
int Open_Part(void)
{
int xx;

  DIR_OK = 0;
    
  LCD_X;
  piszc(8);
  LCD_On;
  gotoxy(1,1);
  piszs(" Odczyt Part. SD .. ");
  gotoxy(1,2);
  LCD_Off;
 
  xx = Open_SD();

  if(!xx)
  {
   secl = 0;
   sech = 0;
    
   Zapal_SD;
   xx = read_n_sec();
   Zgas_SD;
    
   LCD_On;
    
   if(!xx)
   {
        ch_ptr = Tab_8 + 0x21B0;
        memcpy(&Part_HDD, ch_ptr, 80);
        Pierwszy_Sektor = Part_HDD.P_Pierwszy_Sektor;
        Liczba_Sektorow = Part_HDD.P_Liczba_Sektorow;
        if((Liczba_Sektorow == 0) || ((Tab_8[0x2000]==0xEB)&&(Tab_8[0x2003]==0x4D)))
        {
         Liczba_Sektorow = SD_SECTORS;
         Pierwszy_Sektor = 0;
         Part_HDD.P_Liczba_Sektorow = Liczba_Sektorow;
         Part_HDD.P_Pierwszy_Sektor = Pierwszy_Sektor;
        }
        DIR_OK = 0;
        piszs(" S:");
        piszhex(Pierwszy_Sektor);
        piszs(" T:");
        piszhex(Liczba_Sektorow);
        piszc(' ');
   }
   else
    piszs(" Error ! ");

   LCD_X;
   gotoxy(1,2);
   LCD_Off;

// = Odczyt Boot_Sec ===============================================
   Boot_0 = Pierwszy_Sektor;
   secl = Boot_0;
   sech = Boot_0; // + 641;

   Zapal_SD;
   xx = read_n_sec();
   Zgas_SD;

   if(!xx)
   {
    ch_ptr = Tab_8 + 0x2000;
    memcpy(&Boot_HDD, ch_ptr, 80);
    secl = Boot_0;

    SecPerClus = (unsigned char)Boot_HDD.Boot_SecPerClus;
    SecPerClus = SecPerClus & 0x00FF;
    SecPerClusL = (long)SecPerClus;

    FAT_0 = Boot_0 + (long)Boot_HDD.Boot_RsvdSecCnt;  // zwykle 1   ...
    FAT_1 = FAT_0 + (long)Boot_HDD.Boot_FATSz16;
    DIR_0 = FAT_1 + (long)Boot_HDD.Boot_FATSz16;
    DIRSec = ((Boot_HDD.Boot_RootEntCnt * 32) + (Boot_HDD.Boot_BytesPerSec - 1)) / Boot_HDD.Boot_BytesPerSec;
    DATA_0 = DIR_0 + DIRSec;
// MAX Klaster
    xx = Liczba_Sektorow - ((unsigned long)DATA_0 - (unsigned long)Boot_0);
    MAX_Klaster = xx / (unsigned long)SecPerClusL;

    secl = (unsigned long)FAT_0;
    sech = secl + (unsigned long)Boot_HDD.Boot_FATSz16 - (unsigned long)1;
    // Odczyt Fat'a ~256 sectorow

    DIR_DOT = 0; // 0 - root DIR, 1 - podkatalog
    Klaster = 0;
    Poziom = 0;

// ilosc clustr'ow na jedno okno (8kB = 16 sector'ow)
   BigClus = 0,
   Ulamek = 0;
   if(SecPerClus > 16)
   {
    BigClus = SecPerClus >> 4;
    Ulamek = BigClus;
   }


    piszs("SecPerClus:0x");
    piszhex(SecPerClus);
    piszc(' ');

    piszs("FAT_0:0x");
    piszhex(FAT_0);
    piszc(' ');

    piszs("FAT_1:0x");
    piszhex(FAT_1);
    piszc(' ');

    piszs("DIR_0:0x");
    piszhex(DIR_0);
    piszc(' ');

    piszs("DIRSec:0x");
    piszhex(DIRSec);
    piszc(' ');

    piszs("DATA_0:0x");
    piszhex(DATA_0);
    piszc(' ');
    
    LCD_On;
    gotoxy(1,2);

    piszs("All/Free:");
    piszdec(Liczba_Sektorow>>11,0);
    piszc('/');
    piszdec(Wolne_Sec()>>11,0);
    piszs("M \n\r");

    if(SecPerClus & 0xF0)
        Poslizg_X = Poslizg_40 / SecPerClus;

// Read_root_DIR
    secl = DIR_0;
    sech = DIR_0 + 47;
    if (DIRSec < 47)
    {
     sech = DIR_0 + DIRSec;
    }

    Zapal_SD;
    xx = read_n_sec();
    Zgas_SD;
   }
  }
  LCD_X;
 return xx;
}
// -------------------------------------------------------------------------------

void Menu_Power(void)
{
    int xx, yy;
    char uc;
         linia1(1,24);
         //123456789012345678901234
         piszs("1,2-TPA3.. 3-TAS5..");
         linia2(1,24);
              //123456789012345678901234
         piszs("Power AMP[1,2,3]:");
         xx = SHUTDN & 0x07;
         switch(xx)
         {
         case 0x00  : piszs("0,0,0");
                      break;
         case 0x01  : piszs("0,0,1");
                      break;
         case 0x02  : piszs("1,0,0");
                      break;
         case 0x03  : piszs("1,0,1");
                      break;
         case 0x04  : piszs("0,1,0");
                      break;
         case 0x05  : piszs("0,1,1");
                      break;
         case 0x06  : piszs("1,1,0");
                      break;
         case 0x07  : piszs("1,1,1");
                      break;
         }
         piszs("?");

         uc = getch();
         if(uc > 0x40)
           uc &= 0xDF;

         if((uc >= '0') && (uc <= '7'))
         {
           xx = uc & 0x07;
           switch(xx) // Zamien 2 z 4 oraz 3 z 5
           {
           case 2 : uc = 4;
             break;
           case 3 : uc = 5;
             break;
           case 4 : uc = 2;
             break;
           case 5 : uc = 3;
             break;
           }
           xx = SHUTDN & 0xFFFFFFF8; 
           xx  = xx + (uc & 0x07);
           SHUTDN = xx;

           xx = (SHUTDN & 0x06) << 3; // SHUTDN[2]->PCF[5], SHUTDN[1]->PCF[4]
           xx = xx & 0x0030;
           Wy_7E &= 0xCF;
           Wy_7E |= (char)xx;
           yy = i2c_write_a(0x7E);
           xx = i2c_write_de(Wy_7E);

           xx = SHUTDN;
           xx = SHUTDN & 0x0001; // SHUTDN[0]->PCF[0]
           Wy_76 &= 0xFE;
           Wy_76 |= (char)xx;
           yy = i2c_write_a(0x76);
           xx = i2c_write_de(Wy_76);

           linia2(1,24);
                //123456789012345678901234
           piszs("Power AMP[1,2,3]:");
           xx = SHUTDN & 0x07;
           switch(xx)
           {
           case 0x00  : piszs("0,0,0");
                        break;
           case 0x01  : piszs("0,0,1");
                        break;
           case 0x02  : piszs("1,0,0");
                        break;
           case 0x03  : piszs("1,0,1");
                        break;
           case 0x04  : piszs("0,1,0");
                        break;
           case 0x05  : piszs("0,1,1");
                        break;
           case 0x06  : piszs("1,1,0");
                        break;
           case 0x07  : piszs("1,1,1");
                        break;
           }

         }
}
// -------------------------------------------------------------------------------

void Ustaw_czas(void)
{
int xx;
       piszs("\n\r"); 
       linia1(1,24);
       piszs("GODZ.(");
       piszdec(RTC_HOUR, 2);
       piszs("):");
       ENTER = 0;
       ESC = 0;
       xx = getdec();
       if(ENTER && (xx < 24))
        RTC_HOUR = xx;

       if(!ESC)
       {
           piszs(", MIN.(");
           piszdec(RTC_MIN, 2);
           piszs("):");
           ENTER = 0;
           ESC = 0;
           xx = getdec();
           if(ENTER && (xx < 60))
            RTC_MIN = xx;
           piszs(", ");
       }

       if(!ESC)
       {
           linia1(1,24);
           piszs("ROK(");
           piszdec(RTC_YEAR , 4);
           piszs("):");
           ENTER = 0;
           ESC = 0;
           xx = getdec();
           if(ENTER && (xx > 2011))
            RTC_YEAR = xx;
           piszs(", ");
       }

       if(!ESC)
       {
           linia2(1,24);
           piszs("MIESIAC(");
           piszdec(RTC_MONTH , 4);
           piszs("):");
           ENTER = 0;
           ESC = 0;
           xx = getdec();
           if(ENTER && (xx < 13))
            RTC_MONTH = xx;
           piszs(", ");
       }

       if(!ESC)
       {
           linia2(1,24);
           piszs("DZIEN(");
           piszdec(RTC_DOM , 4);
           piszs("):");
           ENTER = 0;
           ESC = 0;
           xx = getdec();
           if(ENTER && (xx < 32))
            RTC_DOM = xx;
           piszc('<');
       }
}
// -------------------------------------------------------------------------------

void Ustaw_WE(char xx_)
{
short uc_;
    
uc_ = 0;    
            if((xx_ >= 0x30) && (xx_ <= 0x38))
            {
             xx_ = xx_ & 0x0F;
             if((xx_ == 8) || (xx_ == 0))
                 {
                 // Radio
                  gotoxy(1,1);
                  piszs("FM[1..9]? ");
                  WM_IN = 0;
                  Timer_1 = 399;
                  IZ = 0;
                  while(Timer_1)
                      {
                       uc_ = KlawX(); 
                       if(uc_ == 0x1B)
                           uc_ = '4' ; // ECS -> '4'
                       if(uc_ == 0x0D)
                           uc_ = '5' ; // CR -> '5'
                       if(uc_ > 0x19)
                         {
                          IZ++;
                          break;
                         }
                      }
                  
                  if( (uc_>= '1') && (uc_ <= '9') )
                      Ustaw_Prg(uc_ & 0x0F);
                 }
             else
               WM_IN = xx_;
             Input = Input & 0xFFC0;
             Input = Input | WM_IN;

             Set_Input();
             SPDIFOut(1);
             //Set_Delay();

             xx_ = 0x47;
            }

            if(xx_ == '9')
            {
             WM_IN = 7;
             Input = Input & 0xFFC0;
             Input = Input | 0x0007;

             linia2(1,24);
                  //123456789012345678901234
             piszs("[1..4]SPFIF COAXIAL/OPTO");

             gotoxy(1,2);
//             uc_ = getch();
//             if(uc_ > 0x40)
//             uc_ &= 0xDF;
             Timer_1 = 399;
             IZ = 0;
             while(Timer_1)
                 {
                  uc_ = KlawX(); 
                  if(uc_ == 0x1B)
                      uc_ = '4' ; // ECS -> '4'
                  if(uc_ > 0x19)
                    {
                     IZ++;
                     break;
                    }
                 }
             
             if((uc_>=0x31) && (uc_<=0x34))
             {
               uc_ = uc_ - 1;
               MUXS = uc_ & 0x03;
             }
               uc_ = MUXS << 4;
               uc_ &= 0x0030;
               Input |= uc_;
               Input |= 0x0008;

               MUTE_On();
               Set_Input();
               if(act_decoder == 1)
                SPDIFOut(0);
               else
                SPDIFOut(1);
               //Set_Delay();

               Rec_RAM();
               if(Szumy() > 0x0121EEEE) // 0x0321EEEE
               {
                 Set_Input();
                 if(act_decoder == 1)
                   SPDIFOut(0);
                 else
                   SPDIFOut(1);
                 //Set_Delay();
               }
               MUTE_Off();

            }
}
// -------------------------------------------------------------------------------

void Ustaw_WE_Q(char xx_)
{
short uc_;

uc_ = 0;

            if((xx_ >= 0x30) && (xx_ <= 0x38))
            {
              xx_ = xx_ & 0x0F;  
              if((xx_ == 8) || (xx_ == 0))
                  {
                    WM_IN = 0;
                    Timer_1 = 399;
                    while(Timer_1)
                     {
                        uc_ = KlawX();
                        if(uc_ == 0x1B)
                            uc_ = '4' ; // ECS -> '4'
                        if(uc_ == 0x0D)
                            uc_ = '5' ; // CR -> '5'
                        if(uc_ > 0x19)
                          break;
                          
                     }
                    
                    if( (uc_>= '1') && (uc_ <= '9') )
                        Ustaw_Prg(uc_ & 0x0F);
                  }
              else
                WM_IN = xx_;

             Input = Input & 0xFFC0;
             Input = Input | WM_IN;

             Set_Input();
             SPDIFOut(1);
             //Set_Delay();

             xx_ = 0x47;
            }

            if(xx_ == '9')
            {
             WM_IN = 7;
             Input = Input & 0xFFC0;
             Input = Input | 0x0007;

             Timer_1 = 399;
             while(Timer_1)
                 {
                  uc_ = KlawX(); 
                  if(uc_ == 0x1B)
                      uc_ = '4' ; // ECS -> '4'
                  if(uc_ > 0x19)
                      break;
                 }
             
             if((uc_>=0x31) && (uc_<=0x34))
             {
               uc_ = uc_ - 1;
               MUXS = uc_ & 0x03;
             }
             uc_ = MUXS << 4;
             uc_ &= 0x0030;
             Input |= uc_;
             Input |= 0x0008;

             MUTE_On();  
             Set_Input();
             if(act_decoder == 1)
               SPDIFOut(0);
             else
               SPDIFOut(1);
             //Set_Delay();

             Rec_RAM();
             if(Szumy() > 0x0121EEEE) // 0x0321EEEE
               {
                 Set_Input();
                 if(act_decoder == 1)
                   SPDIFOut(0);
                 else
                   SPDIFOut(1);
                 //Set_Delay();
               }
              MUTE_Off();
            }
}
// -------------------------------------------------------------------------------

char Szumy_X(void)
{
char _sz_;

    _sz_ = 0;

    delayx(0x00010000);
    Rec_RAM();

    if(Szumy() > 0x0321EEEE) // 0x0321EEEE
      {
        _sz_++;
        Set_Input();
        SPDIFOut(1);
        //Set_Delay();

        delayx(0x00020000);
        Rec_RAM();

        if(Szumy() > 0x0321EEEE) // 0x0321EEEE
        {
         _sz_++;
         Set_Input();
         SPDIFOut(0);
         //Set_Delay();
        }
        else
            _sz_--;
      }
 return _sz_;
}
// -------------------------------------------------------------------------------

int Progres(int maxim, int curent)
{
int _xx;
    _xx = 100 * curent;
    _xx = _xx / maxim;
return _xx;
}
// -------------------------------------------------------------------------------

// STA015 - Sopran    
void MP3_Sopran_Booster(void)
   {
    int xc;
    STA015_ATT = 0x02;
	i2c_write_STA015(0x46, STA015_ATT);  // DLA ATT
    i2c_write_STA015(0x48, STA015_ATT);  // DRA ATT
	
	// STA015 TONE_ATT
    xc = MP3_Ton_A & 0x0007;
    i2c_write_STA015(0x7D, xc + 3);  // TONE_ATT x 1.5 dB

	LCD_Off;
    piszs(" Sopran Enhance ");
    piszdec(MP3_Sop_F,0);
    piszc('/');
    piszdec(MP3_Ton_A,0);
    piszc(' ');
    LCD_X;
	
    xc = MP3_Sop_F & 0x00FF;
    i2c_write_STA015(0x77, xc);         // Sopran_L 5C, 80
    xc = (MP3_Sop_F & 0x3F00)>>8;       // MAX 0x3FFF = 16383
    i2c_write_STA015(0x78, xc);         // Sopran_H 12, 25
    i2c_write_STA015(0x7B, MP3_Ton_A + 3);  // Sopran_Enhance x 1.5 dB FB

    MP3Boost |= 0x0002;
   }
// -------------------------------------------------------------------------------
   
// STA015 - BASS   
void MP3_Bass_Booster(void)
   {
    int xc;
    STA015_ATT = 0x03;
	i2c_write_STA015(0x46, STA015_ATT);  // DLA ATT
    i2c_write_STA015(0x48, STA015_ATT);  // DRA ATT

	// STA015 TONE_ATT
    xc = MP3_Ton_A & 0x0007;
    i2c_write_STA015(0x7D, xc + 3);  // TONE_ATT x 1.5 dB

    LCD_Off;
    piszs(" Bass Enhance ");
    piszdec(MP3_Bass_F,0);
    piszc('/');
    piszdec(MP3_Ton_A,0);
    piszc(' ');
    LCD_X;

    xc = MP3_Bass_F & 0x00FF;
    i2c_write_STA015(0x79, xc);         // BASS_L D0, 8C
    xc = (MP3_Bass_F & 0x0700)>>8;      // MAX 0x7FF = 2047                       
    i2c_write_STA015(0x7A, xc);         // BASS_H 07, 00
    i2c_write_STA015(0x7C, MP3_Ton_A + 3);  // BASS_Enhance x 1.5 dB FB 

    MP3Boost |=0x0001;
   }
// -------------------------------------------------------------------------------
   
// STA015 - Bez Barwy Tonu   
void MP3_Booster_Off(void)
   {
    STA015_ATT = 0x02;
	i2c_write_STA015(0x46, STA015_ATT);  // DLA ATT
    i2c_write_STA015(0x48, STA015_ATT);  // DRA ATT

	// STA015 TONE_ATT
    i2c_write_STA015(0x7D, 0x00);  // TONE_ATT x 1.5 dB

	// piszs(" Bass, Sopran Off ");

    i2c_write_STA015(0x7B, 0x00);  // Sopran_Enhance
    i2c_write_STA015(0x7C, 0x00);  // BASS_Enhance

    i2c_write_STA015(0x7D, 3);  // TONE_ATT x 1.5 dB

    MP3Boost = 0;
   }
// -------------------------------------------------------------------------------
 
   
void Ustaw_Prg(int xx)
{
    char c1, c2, c3;                                
      _FM_x = xx - 1;
      xx = _FM_;
      switch(_FM_x)
      {
      case  0 : _FM_ = _FM_0;
                break;
      case  1 : _FM_ = _FM_1;
                break;
      case  2 : _FM_ = _FM_2;
                break;
      case  3 : _FM_ = _FM_3;
                break;
      case  4 : _FM_ = _FM_4;
                break;
      case  5 : _FM_ = _FM_5;
                break;
      case  6 : _FM_ = _FM_6;
                break;
      case  7 : _FM_ = _FM_7;
                break;
      case  8 : _FM_ = _FM_8;
                break;
      case  9 : _FM_ = _FM_9;
                break;
      }
      if((_FM_ < 87500)||(_FM_ > 108000))
        _FM_ = xx;
// -----------------------------------------------------
      I2C0_SPEED(LOW_S, LOW_S);
      delayx(0x0007);
      freq = oblicz_freq(_FM_);
      c1 = 0xC0;
      //piszs(" a:");
      //piszhl(c1);
      xx = i2c_write_a(c1);
      if(xx >= 0)
      {
       c2 = freq >> 8; // 1E (1D, 1F, 20, 21, 23) [93MHz (88,4; 94,6; 98,5; 102; 107,4MHz)]
       xx = i2c_write_dn(c2);
       if(xx >= 0)
       {
        c3 = freq & 0x00FF;
        xx = i2c_write_de(c3);
       }
       //if(xx >= 0)
       //{
        // piszs(" d1:");
        // piszhl(c2);
        // piszs(" d2:");
        // piszhl(c3);
       //}
       //if(xx == -1)
       //  piszs(" NA ");
       //else
       //  piszs(" OK ");
       I2C0_SPEED(HIGH_S, HIGH_S);
      }
}
// ---------------------------------------------------------

void wyl(void)
{
    WM_Out_Mix(1, 1, 1, 1); // DAC
    WM_DIG_ATT(0x01, 0x01, 0x01, 0x01); // DIG ATT := 1
    write_WM8770(0x1B, 0x77); // WM_IN := 7
    if(DDAdr)
      {
        STA_softreset();
        PLL(0);
        STAint();
        STAsynch();
        STA_Auto();
      }
}
// ---------------------------------------------------------

void cros(char cr) // 0->L,R; 1->R,L, 2->MONO: (L+R)/2
{
 switch(cr)
   {
   case 0:  write_WM8770(0x13, 0x090); // DAC Ctrl 0x90->L,R; 0x60->R,L; 0xF0->MONO
            break;
   case 1:  write_WM8770(0x13, 0x060); // DAC Ctrl 0x90->L,R; 0x60->R,L; 0xF0->MONO
            break;
   case 2:  write_WM8770(0x13, 0x0F0); // DAC Ctrl 0x90->L,R; 0x60->R,L; 0xF0->MONO
            break;
   default: write_WM8770(0x13, 0x090); // DAC Ctrl 0x90->L,R; 0x60->R,L; 0xF0->MONO
            break;
   }
}
// ---------------------------------------------------------

int  al_read(unsigned int _sadr_)
{
// odczyt danych z AL3102 - 1 bajt
  unsigned int ax, dx, fx, _dane_;

  ax = _sadr_;
  _dane_ = 0;
  dx = _dane_;

  ALDATAOut;

  ALDATA20;
  ALCLK20;
  delayx(7);
  // ATTN Select
  ALCLK21;
  delayx(7);
  ALDATA21;
  delayx(5); // impuls 1 na DATA dla CLK=1
  ALDATA20;
  delayx(7);
  ALCLK20;
  delayx(7);
  // Bit READ = 0 (stabilny na zboczu CLK)
  ALDATA20; // DATA -> 0
  delayx(7); 
  ALCLK21;  // CLK +
  delayx(7);
  // Transmisja adresu: A11, A10... A0
  for(fx = 0; fx < 6; fx++)
    {
     // starszy bit
     if(ax & 0x0800)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(7);
     ALCLK20;    // CLK -
     delayx(7);
     // nastepny bit
     ax = ax << 1; 
     if(ax & 0x0800)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(6);
     ALCLK21;    // CLK +
     delayx(7);
     ax = ax << 1; 
    }
  // Odczyt danych: D7, D6... D0
  ALDATA21;      // Linia danych profilaktycznie na '1'
  ALDATAIn;      // P1.1 -> wejscie
  for(fx = 0; fx < 4; fx++)
    {
     ALCLK20; // CLK -> 0
     // starszy bit
     delayx(7);
     dx = ALDATAPin;  // odczyt bitu na pzycji 0x0002
     _dane_ = _dane_ << 1;
     _dane_ += dx;
     delayx(7);
     ALCLK21;    // CLK +
     // nastepny bit
     delayx(7);
     dx = ALDATAPin;  // odczyt bitu na pzycji 0x0002
     _dane_ = _dane_ << 1;
     _dane_ += dx;
     delayx(7);
    }
  // Deselect nie wymagany
  ALCLK20;
  ALDATA21; // Linia danych profilaktycznie na '1'
  delayx(7);
  ALDATAOut;      // P1.1 -> wyjscie
  ALCLK21;
  // koniec
  delayx(0x000E); // 07FF
  _dane_ = _dane_ >> 1; // przesuniecie bitow na swoje miejsce
  _dane_ &= 0x00FF;     // wyciecie 8 bitow
  return _dane_;
}
// ---------------------------------------------------------

int  al_read_5(unsigned int _sadr_)
{
// odczyt danych z AL3102 - 40 bitow
  unsigned int ax, dx, fx, _dane_;

  ax = _sadr_;
  _dane_ = 0;
  dx = _dane_;

  ALDATAOut;

  ALDATA20;
  ALCLK20;
  delayx(7);
  // ATTN Select
  ALCLK21;
  delayx(7);
  ALDATA21;
  delayx(5); // impuls 1 na DATA dla CLK=1
  ALDATA20;
  delayx(7);
  ALCLK20;
  delayx(7);
  // Bit READ = 0 (stabilny na zboczu CLK)
  ALDATA20; // DATA -> 0
  delayx(7); 
  ALCLK21;  // CLK +
  delayx(7);
  // Transmisja adresu: A11, A10... A0
  for(fx = 0; fx < 6; fx++)
    {
     // starszy bit
     if(ax & 0x0800)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(7);
     ALCLK20;    // CLK -
     delayx(7);
     // nastepny bit
     ax = ax << 1; 
     if(ax & 0x0800)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(6);
     ALCLK21;    // CLK +
     delayx(7);
     ax = ax << 1; 
    }
  // Odczyt danych: D7, D6... D0
  ALDATA21;      // Linia danych profilaktycznie na '1'
  ALDATAIn;      // P1.1 -> wejscie
  for(fx = 0; fx < 4; fx++)
    {
     ALCLK20; // CLK -> 0
     // starszy bit
     delayx(7);
     dx = ALDATAPin;  // odczyt bitu na pzycji 0x0002
     _dane_ = _dane_ << 1;
     _dane_ += dx;
     delayx(7);
     ALCLK21;    // CLK +
     // nastepny bit
     delayx(7);
     dx = ALDATAPin;  // odczyt bitu na pzycji 0x0002
     _dane_ = _dane_ << 1;
     _dane_ += dx;
     delayx(7);
    }
  _dane_ = _dane_ >> 1; // przesuniecie bitow na swoje miejsce
  _dane_ &= 0x00FF;     // wyciecie 8 bitow
  AL0 = _dane_;         // DATA 0
  // -----------------------------------------------
  _dane_ = 0;
  for(fx = 0; fx < 4; fx++)
    {
     ALCLK20; // CLK -> 0
     // starszy bit
     delayx(7);
     dx = ALDATAPin;  // odczyt bitu na pzycji 0x0002
     _dane_ = _dane_ << 1;
     _dane_ += dx;
     delayx(7);
     ALCLK21;    // CLK +
     // nastepny bit
     delayx(7);
     dx = ALDATAPin;  // odczyt bitu na pzycji 0x0002
     _dane_ = _dane_ << 1;
     _dane_ += dx;
     delayx(7);
    }
  _dane_ = _dane_ >> 1; // przesuniecie bitow na swoje miejsce
  _dane_ &= 0x00FF;     // wyciecie 8 bitow
  AL1 = _dane_;         // DATA 1
  // -----------------------------------------------
  _dane_ = 0;
  for(fx = 0; fx < 4; fx++)
    {
     ALCLK20; // CLK -> 0
     // starszy bit
     delayx(7);
     dx = ALDATAPin;  // odczyt bitu na pzycji 0x0002
     _dane_ = _dane_ << 1;
     _dane_ += dx;
     delayx(7);
     ALCLK21;    // CLK +
     // nastepny bit
     delayx(7);
     dx = ALDATAPin;  // odczyt bitu na pzycji 0x0002
     _dane_ = _dane_ << 1;
     _dane_ += dx;
     delayx(7);
    }
  _dane_ = _dane_ >> 1; // przesuniecie bitow na swoje miejsce
  _dane_ &= 0x00FF;     // wyciecie 8 bitow
  AL2 = _dane_;         // DATA 2
  // -----------------------------------------------
  _dane_ = 0;
  for(fx = 0; fx < 4; fx++)
    {
     ALCLK20; // CLK -> 0
     // starszy bit
     delayx(7);
     dx = ALDATAPin;  // odczyt bitu na pzycji 0x0002
     _dane_ = _dane_ << 1;
     _dane_ += dx;
     delayx(7);
     ALCLK21;    // CLK +
     // nastepny bit
     delayx(7);
     dx = ALDATAPin;  // odczyt bitu na pzycji 0x0002
     _dane_ = _dane_ << 1;
     _dane_ += dx;
     delayx(7);
    }
  _dane_ = _dane_ >> 1; // przesuniecie bitow na swoje miejsce
  _dane_ &= 0x00FF;     // wyciecie 8 bitow
  AL3 = _dane_;         // DATA 3
  // -----------------------------------------------
  _dane_ = 0;
  for(fx = 0; fx < 4; fx++)
    {
     ALCLK20; // CLK -> 0
     // starszy bit
     delayx(7);
     dx = ALDATAPin;  // odczyt bitu na pzycji 0x0002
     _dane_ = _dane_ << 1;
     _dane_ += dx;
     delayx(7);
     ALCLK21;    // CLK +
     // nastepny bit
     delayx(7);
     dx = ALDATAPin;  // odczyt bitu na pzycji 0x0002
     _dane_ = _dane_ << 1;
     _dane_ += dx;
     delayx(7);
    }
  _dane_ = _dane_ >> 1; // przesuniecie bitow na swoje miejsce
  _dane_ &= 0x00FF;     // wyciecie 8 bitow
  AL4 = _dane_;         // DATA 4
  // Deselect nie wymagany
  ALCLK20;
  ALDATA21; // Linia danych profilaktycznie na '1'
  delayx(7);
  ALDATAOut;      // P1.1 -> wyjscie
  ALCLK21;
  // koniec
  delayx(0x000E); // 07FF
  return _dane_;
}
// ---------------------------------------------------------

unsigned long al_read_4(unsigned int _sadr_)
{
// odczyt danych z AL3102 - 28 bitow
  unsigned int ax,  fx;
  unsigned long dx, _dane_;

  ax = _sadr_;
  _dane_ = 0;
  dx = _dane_;

  ALDATAOut;

  ALDATA20;
  ALCLK20;
  delayx(7);
  // ATTN Select
  ALCLK21;
  delayx(7);
  ALDATA21;
  delayx(5); // impuls 1 na DATA dla CLK=1
  ALDATA20;
  delayx(7);
  ALCLK20;
  delayx(7);
  // Bit READ = 0 (stabilny na zboczu CLK)
  ALDATA20; // DATA -> 0
  delayx(7); 
  ALCLK21;  // CLK +
  delayx(7);
  // Transmisja adresu: A11, A10... A0
  for(fx = 0; fx < 6; fx++)
    {
     // starszy bit
     if(ax & 0x0800)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(7);
     ALCLK20;    // CLK -
     delayx(7);
     // nastepny bit
     ax = ax << 1; 
     if(ax & 0x0800)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(6);
     ALCLK21;    // CLK +
     delayx(7);
     ax = ax << 1; 
    }
  // Odczyt danych: D27, D26... D0
  ALDATA21;      // Linia danych profilaktycznie na '1'
  ALDATAIn;      // P1.1 -> wejscie
  for(fx = 0; fx < 14; fx++)
    {
     ALCLK20; // CLK -> 0
     // starszy bit
     delayx(7);
     dx = ALDATAPin;  // odczyt bitu na pzycji 0x0002
     _dane_ = _dane_ << 1;
     _dane_ += dx;
     delayx(7);
     ALCLK21;    // CLK +
     // nastepny bit
     delayx(7);
     dx = ALDATAPin;  // odczyt bitu na pzycji 0x0002
     _dane_ = _dane_ << 1;
     _dane_ += dx;
     delayx(7);
    }
  _dane_ = _dane_ >> 1; // przesuniecie bitow na swoje miejsce
  _dane_ &= 0x0FFFFFFF;     // wyciecie 28 bitow
  // Deselect nie wymagany
  ALCLK20;
  ALDATA21; // Linia danych profilaktycznie na '1'
  delayx(7);
  ALDATAOut;      // P1.1 -> wyjscie
  ALCLK21;
  // koniec
  delayx(0x000E); // 07FF
  return _dane_;
}
// ---------------------------------------------------------

int  al_write(unsigned int _sadr_, char _dane_)
{
// transmisja danych do AL3102 - 1 bajt
  unsigned int ax, dx, fx;

  ax = _sadr_;
  dx = _dane_;

  ALDATAOut;

  ALDATA20;
  ALCLK20;
  delayx(7);
  // ATTN Select
  ALCLK21;
  delayx(7);
  ALDATA21;
  delayx(5); // impuls 1 na DATA dla CLK=1
  ALDATA20;
  delayx(7);
  ALCLK20;
  delayx(7);
  // Bit WRITE=1 (stabilny na zboczu CLK)
  ALDATA21; // DATA -> 1
  delayx(7); 
  ALCLK21;  // CLK +
  delayx(7);
  // Transmisja adresu: A11, A10... A0
  for(fx = 0; fx < 6; fx++)
    {
     // starszy bit
     if(ax & 0x0800)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(7);
     ALCLK20;    // CLK -
     delayx(7);
     // nastepny bit
     ax = ax << 1; 
     if(ax & 0x0800)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(6);
     ALCLK21;    // CLK +
     delayx(7);
     ax = ax << 1; 
    }
  // Transmisja danych: D7, D6... D0
  for(fx = 0; fx < 4; fx++)
    {
     // starszy bit
     if(dx & 0x080)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(7);
     ALCLK20;    // CLK -
     delayx(7);
     // nastepny bit
     dx = dx << 1; 
     if(dx & 0x080)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(7);
     ALCLK21;    // CLK +
     delayx(7);
     dx = dx << 1; 
    }
  // ATTN Deselect
  ALDATA20;
  delayx(7);
  ALDATA21; // impuls 1 na DATA dla CLK=1
  delayx(5);
  ALDATA20;
  delayx(5);
  ALDATA21; // drugi impuls 1 na DATA dla CLK=1
  delayx(5);
  ALCLK20;  // ujemne zbocze CLK dla DATA=1 - Deselect 
  delayx(7);
  // koniec
  delayx(0x000E); // 07FF
  dx = _dane_;
  return dx;
}
// ---------------------------------------------------------

int  al_write_5(unsigned int _sadr_, char _dane_4, char _dane_3, char _dane_2, char _dane_1, char _dane_0)
{
// transmisja danych do AL3102 - 5 bajtow (40 bitow)
  unsigned int ax, dx, fx;

  ax = _sadr_;
  dx = _dane_4;

  ALDATAOut;

  ALDATA20;
  ALCLK20;
  delayx(8);
  // ATTN Select
  ALCLK21;
  delayx(8);
  ALDATA21;
  delayx(5); // impuls 1 na DATA dla CLK=1
  ALDATA20;
  delayx(8);
  ALCLK20;
  delayx(8);
  // Bit WRITE=1 (stabilny na zboczu CLK)
  ALDATA21; // DATA -> 1
  delayx(8); 
  ALCLK21;  // CLK +
  delayx(8);
  // Transmisja adresu: A11, A10... A0
  for(fx = 0; fx < 6; fx++)
    {
     // starszy bit
     if(ax & 0x0800)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(8);
     ALCLK20;    // CLK -
     delayx(8);
     // nastepny bit
     ax = ax << 1; 
     if(ax & 0x0800)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(8);
     ALCLK21;    // CLK +
     delayx(8);
     ax = ax << 1; 
    }
  // Dane 4
  // Transmisja danych: D7, D6... D0
  for(fx = 0; fx < 4; fx++)
    {
     // starszy bit
     if(dx & 0x080)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(8);
     ALCLK20;    // CLK -
     delayx(8);
     // nastepny bit
     dx = dx << 1; 
     if(dx & 0x080)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(8);
     ALCLK21;    // CLK +
     delayx(8);
     dx = dx << 1; 
    }
  // Dane 3
  dx = _dane_3;
  // Transmisja danych: D7, D6... D0
  for(fx = 0; fx < 4; fx++)
    {
     // starszy bit
     if(dx & 0x080)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(8);
     ALCLK20;    // CLK -
     delayx(8);
     // nastepny bit
     dx = dx << 1; 
     if(dx & 0x080)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(8);
     ALCLK21;    // CLK +
     delayx(8);
     dx = dx << 1; 
    }
  // Dane 2
  dx = _dane_2;
  // Transmisja danych: D7, D6... D0
  for(fx = 0; fx < 4; fx++)
    {
     // starszy bit
     if(dx & 0x080)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(8);
     ALCLK20;    // CLK -
     delayx(8);
     // nastepny bit
     dx = dx << 1; 
     if(dx & 0x080)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(8);
     ALCLK21;    // CLK +
     delayx(8);
     dx = dx << 1; 
    }
  // Dane 1
  dx = _dane_1;
  // Transmisja danych: D7, D6... D0
  for(fx = 0; fx < 4; fx++)
    {
     // starszy bit
     if(dx & 0x080)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(8);
     ALCLK20;    // CLK -
     delayx(8);
     // nastepny bit
     dx = dx << 1; 
     if(dx & 0x080)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(8);
     ALCLK21;    // CLK +
     delayx(8);
     dx = dx << 1; 
    }
  // Dane 0
  dx = _dane_0;
  // Transmisja danych: D7, D6... D0
  for(fx = 0; fx < 4; fx++)
    {
     // starszy bit
     if(dx & 0x080)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(8);
     ALCLK20;    // CLK -
     delayx(8);
     // nastepny bit
     dx = dx << 1; 
     if(dx & 0x080)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(8);
     ALCLK21;    // CLK +
     delayx(8);
     dx = dx << 1; 
    }
  // ATTN Deselect
  ALDATA20;
  delayx(8);
  ALDATA21; // impuls 1 na DATA dla CLK=1
  delayx(5);
  ALDATA20;
  delayx(5);
  ALDATA21; // drugi impuls 1 na DATA dla CLK=1
  delayx(5);
  ALCLK20;  // ujemne zbocze CLK dla DATA=1 - Deselect 
  delayx(8);
  // koniec
  delayx(0x000E); // 07FF
  dx = _dane_0;
  return dx;
}
// ---------------------------------------------------------

unsigned long al_write_4(unsigned int _sadr_, unsigned long _dane_)
{
// transmisja danych do AL3102 - 3,5 bajta (28 bitow)
  unsigned int ax, fx;
  unsigned long dx;

  ax = _sadr_;
  dx = _dane_ << 4; // transmisja od najstrszego bitu
  dx &= 0xFFFFFFF0;

  while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete

  ALDATAOut;

  ALDATA20;
  ALCLK20;
  delayx(8);
  // ATTN Select
  ALCLK21;
  delayx(8);
  ALDATA21;
  delayx(5); // impuls 1 na DATA dla CLK=1
  ALDATA20;
  delayx(8);
  ALCLK20;
  delayx(8);
  // Bit WRITE=1 (stabilny na zboczu CLK)
  ALDATA21; // DATA -> 1
  delayx(8); 
  ALCLK21;  // CLK +
  delayx(8);
  // Transmisja adresu: A11, A10... A0
  for(fx = 0; fx < 6; fx++)
    {
     // starszy bit
     if(ax & 0x0800)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(8);
     ALCLK20;    // CLK -
     delayx(8);
     // nastepny bit
     ax = ax << 1; 
     if(ax & 0x0800)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(8);
     ALCLK21;    // CLK +
     delayx(8);
     ax = ax << 1; 
    }
  // Dane x
  // Transmisja danych: D31, D30... D4
  for(fx = 0; fx < 14; fx++)
    {
     // starszy bit
     if(dx & 0x80000000)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(8);
     ALCLK20;    // CLK -
     delayx(8);
     // nastepny bit
     dx = dx << 1; 
     if(dx & 0x80000000)
       ALDATA21; // DATA -> 1
     else
       ALDATA20; // DATA -> 0
     delayx(8);
     ALCLK21;    // CLK +
     delayx(8);
     dx = dx << 1; 
    }
  // ATTN Deselect
  ALDATA20;
  delayx(8);
  ALDATA21; // impuls 1 na DATA dla CLK=1
  delayx(5);
  ALDATA20;
  delayx(5);
  ALDATA21; // drugi impuls 1 na DATA dla CLK=1
  delayx(5);
  ALCLK20;  // ujemne zbocze CLK dla DATA=1 - Deselect 
  delayx(8);
  // koniec
  delayx(0x000E); // 07FF
  dx = _dane_;
  return dx;
}
// -------------------------------------------------------------------

void DSP_On(void)
{
  CTRL2 &= 0xEF; // bit[4] = DSP#
  MUX123 &= 0xEF;
  if(MODE_DIG_F == 2)
    {
     CTRL2 &= 0x7F; // bit[7] = STA310/AL3102#
     MUX123 &= 0x7F;
    }
  LD_Latch_n(CTRL2, 2);
  DSP_X++;
}
// ---------------------------------------------------------

void DSP_Off(void)
{
  CTRL2 |= 0x10; // bit[4] = DSP#
  MUX123 |= 0x10;
  if(MODE_DIG_F == 2)
    {
     CTRL2 |= 0x80; // bit[7] = STA310/AL3102#
     MUX123 |= 0x80;
    }
  LD_Latch_n(CTRL2, 2);
  DSP_X = 0;
}
// ---------------------------------------------------------

int Load_AL_73(int linii)
{
  int xx, yy, my, f;

  xx = 0xE000;
  my = 0;

  while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
  al_write(0x400, 0x07); // Word 0
  delayx(0x007F); // 0FFF

  while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
  al_write(0x401, 0x02); // Word 1
  delayx(0x007F); // 0FFF

  for(f=0; f<1024; f++)
  {
    if(f < linii)
    {
      yy = xx;
      while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
      al_write_5(f, AL_73[f][0], AL_73[f][1], AL_73[f][2], AL_73[f][3], AL_73[f][4]);
      Tab_8[xx] = AL_73[f][0];
      xx++;
        Tab_8[xx] = AL_73[f][1];
        xx++;
          Tab_8[xx] = AL_73[f][2];
          xx++;
            Tab_8[xx] = AL_73[f][3];
            xx++;
              Tab_8[xx] = AL_73[f][4];
              xx++;
      al_read_5(f);
      if((AL0!=AL_73[f][0])||(AL1!=AL_73[f][1])||(AL2!=AL_73[f][2])||(AL3!=AL_73[f][3])||(AL4!=AL_73[f][4]))
      {
        //xx = yy;
        while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
        al_write_5(f, AL_73[f][0], AL_73[f][1], AL_73[f][2], AL_73[f][3], AL_73[f][4]);
        al_read_5(f);
        if((AL0!=AL_73[f][0])||(AL1!=AL_73[f][1])||(AL2!=AL_73[f][2])||(AL3!=AL_73[f][3])||(AL4!=AL_73[f][4]))
        {
          my++;
          piszhex(AL0);piszhex(AL1);piszhex(AL2);piszhex(AL3);piszhex(AL4);piszc('<');
        }
      }
    }
    else
    {
      yy = xx;
      while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
      al_write_5(f, 0, 0, 0, 0, 0);
      xx++;
        Tab_8[xx] = 0;
        xx++;
          Tab_8[xx] = 0;
          xx++;
            Tab_8[xx] = 0;
            xx++;
              Tab_8[xx] = 0;
              xx++;
       //al_read_5(f);
       //if(AL0 || AL1 || AL2 || AL3 || AL4)
       // {
       //   al_write_5(f, 0, 0, 0, 0, 0);
       //   al_read_5(f);
       //   if(AL0 || AL1 || AL2 || AL3 || AL4)
       //     my++;
       // }
    }
    xx += 3; // co 8 bajtow
  }

  while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
  al_write(0x400, 0x7F); // Word 0
  delayx(0x0FFF); 

  while((al_read(0x407) & 0x001)==0); // czekaj na Memory acces complete
  al_write(0x401, 0x02); // Word 1

  return my;
}

